<?php
/**
 * File: $Id: admin.php,v 1.38 2005/09/05 13:15:35 greyhead Exp $ admin.php,v 1.1.2.13 2004/04/30 03:51:12 masterkain Exp $
 *
 * Ciamos: this file is called when abuse is detected
 * Ciamos - Content Management System
 *
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 *
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author The Xoops Project (@link http://www.xoops.org)
 */

$sysOption['pagetype'] = "admin";

include_once("mainfile.php");
if ( (!$sysUser || !$sysUser->isAdmin()) ) {
    redirect_header(SYS_ROOT_URL."/index.php", 2, _NOPERM, 0, 3);
}
include_once(SYS_ROOT_PATH."/include/cp_functions.php");
include(SYS_ROOT_PATH.'/include/extra.js');
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

global $sys_request, $sysConfig, $sysHandler, $sysUser, $sysSecurity;

/**
 * Admin authorisation
 */
if ( !$sysUser || !$sysUser->isAdmin() ) {
    $sysHandler['security']->checkGlobalVars('index.php', 2, _NOPERM, 0, 3);
}

if ( empty($sys_request['op']) ||
    $sys_request['op'] == "list" ) {

    /**
     * initialise variables
     */
    $present    = "<font color='#00CC00'>"._PRESENT."</font>";
    $loaded     = "<font color='#00CC00'>"._LOADED."</font>";
    $notpresent = "<font color='#FF0000'>"._NOT_PRESENT."</font>";
    $none       = "<font color='#666666'>"._NONE."</font>";
    $on         = "<font color='#00CC00'>"._ON."</font>";
    $off        = "<font color='#FF0000'>"._OFF."</font>";
    $sys_version_runon = "<strong>$sys_version</strong>&nbsp;"._RUNNINGON."&nbsp;<strong>".$sysConfig['database']."</strong>" ;

    /**
     * Create System information form
     */
    $form = new SysThemeForm(_SYSINFO, 'SysInfo', '' );
    $form_array = array();
    $form_array[] = new SysFormLabel(_CIAMOSVER, $sys_version_runon);
    $form_array[] = new SysFormLabel(_OPERSYS, php_uname());
    $form_array[] = new SysFormLabel(_SERVERSOFT, fetchServerSoftware());
    $form_array[] = new SysFormLabel(_PHPVER, phpversion());
    $form_array[] = new SysFormLabel(_PHPINT, php_sapi_name());
    $form_array[] = new SysFormLabel(_SERVERTIME, formatTimestamp(time(), _MEDIUMDATESTRING));
    $form_array[] = new SysFormLabel(_USERAGENT, phpversion() <= "4.2.1" ? getenv( "HTTP_USER_AGENT" ) : $_SERVER['HTTP_USER_AGENT'] );
    $form_array[] = new SysFormLabel(_REGGEDUSERS, SysUser::countAllUsers(array("level>0")));
    $form_array[] = new SysFormLabel(_SUPPORTUS, _AD_SUPPORT);

    /**
     * Create PHP vars form
     */
    $php_form = new SysThemeForm('', 'PHPVars', '' );
    $php_array = array();
    
    $php_array[] = new SysFormLabel('', _PHPVARSTXT);
    $php_array[] = new SysFormLabel('Safe mode', fetchPhpSetting('safe_mode'));
    $php_array[] = new SysFormLabel('Open basedir', ($ob = ini_get('open_basedir') ? $ob : $none));
    $php_array[] = new SysFormLabel('Display errors', fetchPhpSetting('display_errors'));
    $php_array[] = new SysFormLabel('Short open tags', fetchPhpSetting('short_open_tag'));
    $php_array[] = new SysFormLabel('File uploads', fetchPhpSetting('file_uploads'));
    $php_array[] = new SysFormLabel('Magic quotes', fetchPhpSetting('magic_quotes_gpc'));
    $php_array[] = new SysFormLabel('Register globals', fetchPhpSetting('register_globals'));
    $php_array[] = new SysFormLabel('Output buffering', fetchPhpSetting('output_buffering'));
    $php_array[] = new SysFormLabel('Session save path', ($savepath = ini_get('session.save_path')) ? $savepath : $none);
    $php_array[] = new SysFormLabel('Session auto start', (intval( ini_get( 'session.auto_start' ) ) ? $on : $off));
    $php_array[] = new SysFormLabel('XML extension', (extension_loaded('xml') ? $present : $notpresent));
    $php_array[] = new SysFormLabel('Zlib extension', (extension_loaded('zlib') ? $present : $notpresent));
    $php_array[] = new SysFormLabel('Curl extension', (extension_loaded('curl') ? $present : $notpresent));
    $php_array[] = new SysFormLabel('Sockets extension', (extension_loaded('sockets') ? $present : $notpresent));
    $php_array[] = new SysFormLabel('OpenSSL support', (extension_loaded('openssl') ? $present : $notpresent));
    $php_array[] = new SysFormLabel('MySQL support', (extension_loaded('mysql') ? $loaded : $notpresent));
    $php_array[] = new SysFormLabel('PostGreSQL support', (extension_loaded('pgsql') ? $loaded : $notpresent));
    $php_array[] = new SysFormLabel('GD support', (extension_loaded('gd') ? $loaded : $notpresent));
    $php_array[] = new SysFormLabel('FTP support', (extension_loaded('ftp') ? $loaded : $notpresent));
    $php_array[] = new SysFormLabel('Disabled functions', ( $disfunc = ini_get('disable_functions') ) ? $disfunc : $none);

    /**
     * Write page
     */
    sysCpHeader();
    openTable();

    if ( @is_writable(SYS_ROOT_PATH."/mainfile.php" ) ) {
        displayMessage(sprintf(_FILEWARN, SYS_ROOT_PATH."/mainfile.php"));
    }
    if ( @is_dir(SYS_ROOT_PATH."/_install" ) ) {
        displayMessage(sprintf(_INSTALLWARN, SYS_ROOT_PATH."/_install/"));
    }
    $form->display($form_array, true);
    /*echo "<div id='relphpvars_closed'><a href='' onClick='ToggleDiv( \"relphpvars\", g_div_relphpvars ); return false;'
        ><strong>"._PHPVARS."</strong> <img src='".SYS_ROOT_URL."/images/icons/down.gif' alt='open' align='middle' /></a></div>";
    echo "<div id='relphpvars_open' style='display: none;'><a href='' onClick='ToggleDiv( \"relphpvars\", g_div_relphpvars ); return false;'
        ><strong>"._PHPVARS."</strong> <img src='".SYS_ROOT_URL."/images/icons/up.gif' alt='close' align='middle' /></a><br />";
    $php_form->display();
    echo "</div><br />
            <script type='text/JavaScript'>
                SetDiv( \"relphpvars\", g_div_relphpvars );
            </script>";*/

    echo "<div class='formtitle' onClick=\"expandcontent('sc1')\" style='cursor:hand; cursor:pointer;'><strong>"._PHPVARS."</strong> <img src='".SYS_ROOT_URL."/images/icons/down.gif' alt='' align='middle' /></div>";
    echo "<div id='sc1' class='switchcontent' style='display:none;'>";
    $php_form->display($php_array, true);
    echo "</div>";
    sysCpFooter();
}

/**
 * @return unknown
 * @desc Fetches server software
 */

function fetchServerSoftware()
{
    if ( isset($_SERVER['SERVER_SOFTWARE']) ) {
        $return = $_SERVER['SERVER_SOFTWARE'];
    } elseif ( $software = getenv('SERVER_SOFTWARE') ) {
        $return = $software;
    } else {
        $return = '"._NOTAVAIL."';
    }
    return $return;
}

/**
 * @return unknown
 * @param unknown $val
 * @desc Fetch php settings
 */
function fetchPhpSetting($val)
{
    global $on, $off;

    $return = $off;
    if ( ini_get($val) ) {
        $return = $on;
    } 
    return $return;
}

/**
 * Enter description here...
 *
 * @return unknown
 */
function checkUpdate()
{
    $url = "http://www.ciamos.com/release";

    // example of 'release' file content below:
    /* The latest stable version of Ciamos is: 1.0 */
    // soon it will be ported to xml
    $return  = _NOTAVAIL;
    $lines = file($url);
    if ( $lines ) {
        for ( $i = 0; $i < count($lines); $i++ ) {
            if ( ereg("The latest stable version of Ciamos is:(.*)", $lines[$i]) ) {
                $return = trim(ereg_replace("The latest stable version of Ciamos is:(.*)\n", "\\1", $lines[$i]));
            }
        }
    }
    return $return;
}
?>








