<?php
/**
* File: $Id: groupaccess.php,v 1.13 2005/05/07 11:08:36 greyhead Exp $
*
*  Ciamos: Simple + Flexible + Advanced Content Management
*  @link http://www.ciamos.com
*
* @Author: Half-Dead
* @license Proprietary (@link /manual/licenses/half-dead.txt)
*/

if ( defined("CIAMOS_GROUPACCESS_INCLUDED") ) {
    exit();
}
define("CIAMOS_GROUPACCESS_INCLUDED", true);

include_once(SYS_ROOT_PATH . '/class/sysgroup.php');

/**
 * The class maintains an array with <br />
 * $key = group id and
 * $value = true or false depending on access 
 */
class groupAccess
{
    var $table;
    var $field;
    var $item;
    var $groupname;

    var $groups      = array();
    var $user_groups = array();

    function groupAccess($groupname='groupid')
    {
        global $sysUser;

        $this->groupname   = $groupname;
        $this->user_groups = SysGroup::getByType("Anonymous");
        if ( $sysUser ) {
            $this->user_groups = array_merge((array)$this->user_groups, (array)$sysUser->groups());
        }
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $id
     * @param unknown_type $item
     * @param unknown_type $table
     * @param unknown_type $field
     * @return unknown
     */
    function loadGroups($id, $item, $table, $field='groupid')
    {
        global $db;

        $this->table = $db->prefix($table);
        $this->field = $field;
        $this->item  = $item;
        $sql = "
            SELECT ".$this->field."
                FROM ".$this->table."
                WHERE ".$this->item."='$id'";
        $return = false;
        if ( $result = $db->query($sql) ) {
            list ( $groups ) = $db->fetch_row($result);
            unset($this->groups[$this->groupname]);
            $this->addGroups($groups, 1);
            $return = true;
        }
        return $return;
    }

    /**
     * Makes sure $groupid is a space delimited string and not an array, before saving to database.
     *
     * @return string A space delimited string of group ID's
     */
    function saveGroups($id)
    {
        global $db;

        $groups = array();
        foreach ( $this->groups[$this->groupname] as $key => $value ) {
            if ( $value == 1 ) {
                $groups[$key] = $key;
            }
        }
        $groups = implode(" ", $groups);
        $sql = "
            UPDATE ".$this->table."
                SET ".$this->field."='$groups'
                WHERE ".$this->item."='$id'";
        $retrun = false;
        if ( $result = $db->query($sql) ) {
            $return = true;
        }
        return $return;
    }

    /**
     * Adds groups from $groups with permission $allow
     *
     * @param string or array $groups
     * @param boolean $allow
     */
    function addGroups($groups, $allow=true)
    {
        if ( !is_array($groups) ) {
            $groups = explode(" ", $groups);
        }
        $allow = (boolean) $allow;
        foreach ( $groups as $key ) {
            $this->groups[$this->groupname][$key] = $allow;
        }
    }

    /**
     * Adds groups from $groups with permission reversed
     *
     * @param unknown_type $groups
     * @param boolean $allow
     */
    function removeGroups($groups, $allow=true)
    {
        if ( !is_array($groups) ) {
            $groups = explode(" ", $groups);
        }
        $allow = (boolean) $allow;
        foreach ( $groups as $key ) {
            $this->groups[$this->groupname][$key] = !$allow;
        }
    }

    /**
     * Checks to see if user has permission
     *
     * @param boolean $allow
     * @return boolean
     */
    function checkGroups($allow=1)
    {
        $allow = (boolean) $allow;
        $size = max( count($this->groups), count($this->user_groups));
        $return = false;
        foreach ( $this->groups[$this->groupname] as $key => $value ) {
            if ( $value == $allow && !$return ) {
                if ( @in_array($key, $this->user_groups) ) {
                    $return = true;
                }
            }
        }
        return $return;;
    }

    /**
        * Description
        *
        * @param type $var description
        * @return type description
        */
    function listGroups()
    {
        global $db, $myts, $sys_request;

        if ( !empty($sys_request[$this->groupname]) ) {
            unset($this->groups[$this->groupname]);
            $this->addGroups($sys_request[$this->groupname], 1);
        }
        $sql = "
                SELECT groupid, name
                    FROM ".$db->prefix('groups')."
                    ORDER BY name ASC";
        if ( $result = $db->query($sql) ) {
            $i = 0;
            while ( list($gid, $name) = $db->fetch_row($result) ) {
                if ( $i == "4" ) {
                    $grouplist .= "<br />";
                    $i = 0;
                }
                $grouplist .= "<input type='checkbox' class='checkbox' name='".$this->groupname."[$gid]' value='$gid'";
                if ( empty($this->groups[$this->groupname])
                        || $this->groups[$this->groupname][$gid] == 1 ) {
                    $grouplist .= " checked";
                }
                $grouplist .= " />".$myts->makeTboxData4Show($name);
                $i++;
            }
        }
        return $grouplist;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $style
     * @param unknown_type $type
     * @return unknown
     */
    function groups($style=1, $type=1)
    {
        $type = (boolean) $type;
        $return = array_keys($this->groups[$this->groupname], $type);
        if ( $style != 1 ) {
            $return = implode(" ", $return);
        }
        return $return;
    }

    /**
     * Returns list of groups<br />
     *
     * @param boolean $style true = as array, false = as string
     * @return string or array
     */
    function userGroups($style=1)
    {
        $return = $this->user_groups;
        if ( $style != 1 ) {
            $return = implode(" ", $return);
        }
        return $return;
    }
}
?>
