<?php
/**
 * File: $Id: sessions.class.php,v 1.9 2004/12/31 15:01:32 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_SESSION_CLASS_INCLUDED") ) {
    return;
}
define("CIAMOS_SESSION_CLASS_INCLUDED", 1);

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
class SysUserSession
{
    var $db;
    var $uid;
    var $uname;
    var $hash;
    var $pass;
    var $cookie;
    var $expiretime;
    var $sessionID;

    function SysUserSession($sessionID='')
    {
        global $sysConfig;

        $this->cookie     = $sysConfig['session_name'];
        $this->expiretime = $sysConfig['session_expire'];

        if ( !empty($sessionID) ) {
            $this->sessionID = $sessionID;
        }
    }

    /**
     * creates new session for user
     * and sets a cookie containing the session id
     *
     * @param type $var description
     * @return type description
     */
    function store()
    {
        global $db, $HTTP_SESSION_VARS, $sysConfig;

        $sql = "
            DELETE 
                FROM ".$db->prefix("session")." 
                WHERE uid=".$this->uid;
        $db->query($sql);
        $this->hash = md5($this->uid.':'.$this->pass.':'._HTTP_USER_AGENT.':'._REMOTE_ADDR);
        $sql = "
            INSERT 
                INTO ".$db->prefix("session")." 
                SET uid=".$this->uid.", 
                    uname='".$this->uname."', 
                    time=".time().", 
                    ip='"._REMOTE_ADDR."', 
                    hash='".$this->hash."'";
        if ( $db->query($sql) ) {
            if ( $sysConfig['use_sessions'] == 1 ) {
                session_register($sysConfig['session_name']);
                $HTTP_SESSION_VARS[$sysConfig['session_name']] = $this->hash;
            } else {
                cookie($this->cookie, $this->hash, $this->expiretime);
            }
            return true;
        }
        return false;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function setUid($value)
    {
        $this->uid = $value;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function setUname($value)
    {
        $this->uname = $value;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function setPass($value)
    {
        $this->pass = $value;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function uid()
    {
        return $this->uid;
    }


    /**
     * @return unknown
     * @desc Enter description here...
     */
    function isValid()
    {
        global $db;

        $mintime = (time()-$this->expiretime);
        $sql = "
            DELETE 
                FROM ".$db->prefix("session")." 
                WHERE time < $mintime";
        $db->query($sql);

        $sql = "
            SELECT
                u.uid,
                u.uname,
                u.pass,
                s.hash
            FROM ".$db->prefix("session")." s
            INNER JOIN ".$db->prefix("users")." u ON u.uid=s.uid
            WHERE s.hash='".$this->sessionID."'";

        if ( !$result = $db->query($sql) ) {
            return false;
        }

        list($uid, $uname, $pass, $hash) = $db->fetch_row($result);
        if ( !empty($uid) ) {
            if ($this->sessionID == md5($uid.':'.$pass.':'._HTTP_USER_AGENT.':'._REMOTE_ADDR)) {
                $this->uid   = $uid;
                $this->uname = $uname;
                $this->pass  = $pass;
                $this->hash  = $hash;
                return true;
            }
        }

        return false;
    }

    /**
     * updates the session table
     *
     * @param type $var description
     * @return type description
     */
    function update()
    {
        global $db, $HTTP_SESSION_VARS, $sysConfig;

        $sql = "
            UPDATE ".$db->prefix("session")." 
                SET time=".time()." 
                WHERE uid=".$this->uid;
        $db->query($sql);
        if ( $sysConfig['use_sessions'] ) {
            $HTTP_SESSION_VARS[$sysConfig['session_name']] = $this->hash;
        } else {
            cookie($this->cookie, $this->hash, $this->expiretime);
        }
    }
}
?>
