<?php
/**
 * File: $Id: syscomments.php,v 1.20 2005/09/06 09:53:36 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_COMMENTS_INCLUDED") ) {
    exit;
}
define("CIAMOS_COMMENTS_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/module.errorhandler.php");
include_once(SYS_ROOT_PATH."/class/systree.php");

/**
     * Description
     *
     * @param type $var description
     * @return type description
     */
class SysComments extends SysObject
{
    var $ctable;

    function SysComments($ctable, $id=NULL)
    {
        $this->ctable = $ctable;
        $this->SysObject();
        $this->initVar("item_id", "int", NULL, false);
        $this->initVar("order", "int", NULL, false);
        $this->initVar("mode", "other", NULL, false);
        $this->initVar("subject", "textbox", NULL, false, 255, false);
        $this->initVar("comment", "textarea", NULL, false, NULL, false);
        $this->initVar("ip", "other", NULL, false);
        $this->initVar("comment_id", "int", NULL, false);
        $this->initVar("pid", "int", 0, false);
        $this->initVar("date", "int", NULL, false);
        $this->initVar("allow_html", "int", 0, false);
        $this->initVar("allow_smileys", "int", 1, false);
        $this->initVar("allow_bbcode", "int", 1, false);
        $this->initVar("type", "other", "user", false);
        $this->initVar("user_id", "int", NULL, false);
        $this->initVar("icon", "other", NULL, false);
        $this->initVar("prefix", "other", NULL, false);
        if ( !empty($id) ) {
            if ( is_array($id) ) {
                $this->set($id);
            } else {
                $this->load(intval($id));
            }
        }
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function load($id)
    {
        global $db;

        $sql = "
                SELECT *
                    FROM ".$this->ctable."
                    WHERE comment_id=".intval($id)."";
        $arr = $db->fetch_array($db->query($sql));
        $this->set($arr);
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function store()
    {
        global $db, $sysUser;

        if ( !$this->isCleaned() ) {
            if ( !$this->cleanVars() ) {
                return false;
            }
        }
        foreach ( $this->cleanVars as $k=>$v ) {
            $$k = $v;
        }
        $isnew = false;
        if ( empty($comment_id ) ) {
            $isnew = true;
            $comment_id = $db->genId($this->ctable."_comment_id_seq");

            $sql = "
                    INSERT
                        INTO ".$this->ctable."
                        SET
                            comment_id=".intval($comment_id).",
                            pid=".intval($pid).",
                            item_id=".intval($item_id).",
                            date=".time().",
                            user_id=".intval($user_id).",
                            ip='".$ip."',
                            subject='".$subject."',
                            comment='".$comment."',
                            allow_html=".intval($allow_html).",
                            allow_smileys=".intval($allow_smileys).",
                            allow_bbcode=".intval($allow_bbcode).",
                            type='".$type."',
                            icon='".$icon."'";
        } else {
            if ( $sysUser ) {
                $editor   = $sysUser->getVar("uname");
                $on_date  = _ON." ".formatTimestamp(time(), _MEDIUMDATESTRING);
                $comment .= "\n\n[ "._EDITEDBY." ".$editor." ".$on_date." ]";
            }
            $sql = "
                    UPDATE ".$this->ctable."
                        SET
                            subject='".$subject."',
                            comment='".$comment."',
                            allow_html=".intval($allow_html).",
                            allow_smileys=".intval($allow_smileys).",
                            allow_bbcode=".intval($allow_bbcode).",
                            icon='".$icon."'
                        WHERE comment_id=".intval($comment_id)."";
        }
        if ( !$result = $db->query($sql) ) {
            return false;
        }
        if ( empty($comment_id) ) {
            $comment_id = $db->insert_id();
        }
        if ( $isnew != false ) {
            $sql = "
                    UPDATE ".$db->prefix("users")."
                        SET posts=posts+1
                        WHERE uid=".intval($user_id)."";
            if (!$result = $db->query($sql)) {
                echo _NOTUPDATED;
            }
        }
        return $comment_id;
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function delete()
    {
        global $db;

        $sql = "
                DELETE
                    FROM ".$this->ctable."
                    WHERE comment_id=".$this->getVar("comment_id")."";
        if ( !$result = $db->query($sql) ) {
            return false;
        }
        $sql = "
                UPDATE ".$db->prefix("users")."
                    SET posts=posts-1
                    WHERE uid=".$this->getVar("user_id")."";
        if ( !$result = $db->query($sql) ) {
            echo _NOTUPDATED;
        }
        $mytree = new SysTree($this->ctable, "comment_id", "pid");
        $arr    = $mytree->getAllChild($this->getVar("comment_id"), "comment_id");
        $size   = count($arr);
        if ( $size > 0 ) {
            for ( $i = 0; $i < $size; $i++ ) {
                $sql = "
                        DELETE
                            FROM ".$this->ctable."
                            WHERE comment_id=".intval($arr[$i]['comment_id'])."";
                if ( !$result = $db->query($sql) ) {
                    echo _NOTUPDATED;
                }
                $sql = "
                        UPDATE ".$db->prefix("users")."
                            SET posts=posts-1
                            WHERE uid=".intval($arr[$i]['user_id'])."";
                if ( !$result = $db->query($sql) ) {
                    echo _NOTUPDATED;
                }
            }
        }
        return ($size + 1);
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function getCommentTree()
    {
        $mytree = new SysTree($this->ctable, "comment_id", "pid");
        $ret    = array();
        $tarray = $mytree->getChildTreeArray($this->getVar("comment_id"), "comment_id");
        foreach ( $tarray as $ele ) {
            $ret[] = new SysComments($this->ctable, $ele);
        }
        return $ret;
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function getAllComments($criteria=array(), $asobject=true, $orderby="comment_id ASC", $limit=0, $start=0)
    {
        global $db;

        $ret         = array();
        $where_query = "";
        if ( is_array($criteria) && count($criteria) > 0 ) {
            $where_query = " WHERE";
            foreach ( $criteria as $c ) {
                $where_query .= " $c AND";
            }
            $where_query = substr($where_query, 0, -4);

            if ( !$asobject ) {
                $sql    = "
                        SELECT comment_id
                            FROM ".$this->ctable."".$where_query."
                            ORDER BY $orderby";
                $result = $db->query($sql,$limit, $start);
                while ( $myrow = $db->fetch_array($result) ) {
                    $ret[] = $myrow['comment_id'];
                }
            } else {
                $sql = "
                        SELECT *
                            FROM ".$this->ctable."
                            $where_query
                            ORDER BY $orderby";
                $result = $db->query($sql, $limit, $start);
                while ( $myrow = $db->fetch_array($result) ) {
                    $ret[] = new SysComments($this->ctable, $myrow);
                }
            }
        }
        //echo $sql;
        return $ret;
    }


    /* Methods below will be moved to maybe another class? */

    /**
        * Description
        *
        * @param type $var description
        * @return type description
        */
    function printNavBar($item_id, $mode="flat", $order=1)
    {
        global $sysConfig, $sysUser;

        $bar = "
<form method='get' action='"._PHP_SELF."'>
<table width='100%' border='0' cellspacing='1' cellpadding='2'><tr>
<td class='bg1' align='center'><select class='select' name='mode'><option value='0'";

        if ( $mode == "0" ) {
            $bar .= " selected='selected'";
        }
        $bar .= ">"._NOCOMMENTS."</option><option value='flat'";

        if ($mode == 'flat') {
            $bar .= " selected='selected'";
        }
        $bar .= ">"._FLAT."</option><option value='thread'";

        if ( $mode == "thread" || $mode == "" ) {
            $bar .= " selected='selected'";
        }
        $bar .= ">"._THREADED."</option></select> <select class='select' name='order'><option value='0'";

        if ( $order != 1 ) {
            $bar .= " selected='selected'";
        }
        $bar .= ">"._OLDESTFIRST."</option><option value='1'";

        if ( $order == 1 ) {
            $bar .= " selected='selected'";
        }
        $bar .= ">"._NEWESTFIRST."</option></select><input type='hidden' name='item_id' value='".intval($item_id)."' /> <input type='submit' class='button' value='". _REFRESH ."' />";

        if ( $sysConfig['anonpost'] == 1 || $sysUser ) {
            if ($mode != "flat" || $mode != 0 || $mode != "thread" ) {
                $mode = "flat";
            }
            $bar .= "&nbsp;<input type='button' class='button' onclick='location=\"newcomment.php?item_id=".intval($item_id)."&amp;order=".intval($order)."&amp;mode=".$mode."\"' value='"._POSTCOMMENT."' />";
        }

        $bar .= "</td></tr></table></form>";
        return $bar;
    }

    /**
        * Deprecated
        */
    function showThreadHead()
    {
    }
    /**
        * Deprecated
        */
    function showThreadFoot()
    {
    }

    /**
            * Description
            *
            * @param type $var description
            * @return type description
            */
    function showTreeHead($width="100%")
    {
        return "
                    <table border='0' cellpadding='3' cellspacing='0' width='$width'>
                        <tr class='bg2' align='left'>
                            <td width='60%'>"._REPLIES."</td>
                            <td width='20%'>"._POSTER."</td>
                            <td>"._DATE."</td>
                        </tr>";
    }

    /**
            * Description
            *
            * @param type $var description
            * @return type description
            */
    function showTreeItem($order, $mode, $color_num)
    {
        if ( $color_num == 1 ) {
            $bg1 = 'bg1';
        } else {
            $bg1 = 'bg3';
        }
        $prefix = str_replace(".", "&nbsp;&nbsp;&nbsp;&nbsp;", $this->getVar("prefix"));
        $date   = formatTimestamp($this->getVar("date"), "m");
        if ( $this->getVar("icon") != "" ) {
            $icon = "subject/".$this->getVar("icon", "E");
        } /*else {
        $icon = "icons/posticon.gif";
        }*/

        return "
            <tr class='$bg1' align='left'>
            <td>".$prefix."<img src='".SYS_ROOT_URL."/images/".$icon."' />&nbsp;<a href='"._PHP_SELF."?item_id=".$this->getVar("item_id")."&comment_id=".$this->getVar("comment_id")."&mode=".$mode."&order=".$order."#".$this->getVar("comment_id")."'>".$this->getVar("subject")."</a></td>
            <td><a href='".SYS_ROOT_URL."/userinfo.php?uid=".$this->getVar("user_id")."'>".SysUser::getUnameFromId($this->getVar("user_id"))."</a></td>
            <td>".$date."</td></tr>";
    }

    /**
            * Description
            *
            * @param type $var description
            * @return type description
            */
    function showTreeFoot()
    {
        return "</table>";
    }

    /**
        * Description
        *
        * @param type $var description
        * @return type description
        */
    function showThreadPost($order, $mode, $adminview=0, $color_num=1)
    {
        global $sysConfig, $sysUser, $myts, $sys_image;

        $edit_image   = "";
        $reply_image  = "";
        $delete_image = "";
        $post_date    = formatTimestamp($this->getVar("date"), "m");

        if ( $this->getVar("user_id") != 0 ) {
            $poster = new SysUser($this->getVar("user_id"));
            if ( !$poster->isActive() ) {
                $poster = 0;
            }
        } else {
            $poster = 0;
        }

        if ( $this->getVar("icon") != NULL && $this->getVar("icon") != "" ) {
            $subject_image = "<a name='".$this->getVar("comment_id")."' id='".$this->getVar("comment_id")."'></a><img src='".SYS_ROOT_URL."/images/subject/".$this->getVar("icon")."' alt='' align='middle' />";
        } /*else {
        $subject_image =  "<a name='".$this->getVar("comment_id")."' id='".$this->getVar("comment_id")."'></a><img src='".SYS_ROOT_URL."/images/icons/posticon.gif' alt='' />";
        }*/

        if ( $adminview ) {
            $ip_image = "<a href='".SYS_MOD_URL."/system/admin.php?fct=filter&op=ips&add_ip=".$this->getVar("ip")."'>"
            ."<img src='".$sys_image['ip']."' alt='".$this->getVar("ip")."' border='0' /></a>";
        }

        if ( $adminview || ($sysUser && $this->getVar("user_id") == $sysUser->getVar("uid")) ) {
            $edit_image = "<a href='editcomment.php?comment_id=".$this->getVar("comment_id")."&amp;mode=".$mode."&amp;order=".intval($order)."'>"
            ."<img src='".$sys_image['edit']."' alt='"._EDITTHISPOST."' /></a>";
        }

        if ( $sysConfig['anonpost'] || $sysUser ) {
            $reply_image = "<a href='replycomment.php?comment_id=".$this->getVar("comment_id")."&amp;mode=".$mode."&amp;order=".intval($order)."'>"
            ."<img src='".$sys_image['reply']."' alt='"._REPLY."' /></a>";
        }

        if ( $adminview ) {
            $delete_image = "<a href='deletecomment.php?comment_id=".$this->getVar("comment_id")."&amp;mode=".$mode."&amp;order=".intval($order)."'>"
            ."<img src='".$sys_image['delete']."' alt='"._DELETETHISPOST."' /></a>";
        }

        if ( $poster ) {
            $reg_date   = _JOINED;
            $reg_date  .= formatTimestamp($poster->getVar("user_regdate"), "s");
            $posts      = _POSTS;
            $posts     .= $poster->getVar("posts");
            $user_from  = _FROM;
            $user_from .= $poster->getVar("user_from");

            $rank = $poster->rank();
            if ($rank['image'] != "") {
                $rank['image'] = "<img src='".SYS_ROOT_URL."/images/ranks/".$rank['image']."' alt='' vspace='2' />";
            }

            $avatar_image = $poster->getVar("user_avatar") ? "<img src='".SYS_ROOT_URL."/images/avatar/".$poster->getVar("user_avatar")."' alt='' />" : '';

            if ( $poster->isOnline() ) {
                $online_image = "<strong>"._ONLINE."</strong>";
            } else {
                $online_image = "";
            }

            $profile_image = "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$poster->getVar("uid")."'>"
            ."<img src='".$sys_image['profile']."' alt='"._PROFILE."' align='middle' /></a>";

            if ( $sysUser ) {
                $pm_image =  "<a href='".SYS_MOD_URL."/messages/pmlite.php?send=1&to_userid=".$poster->getVar("uid")."'>"
                ."<img src='".$sys_image['pm']."' alt='".sprintf(_SENDPMTO, $poster->getVar("uname", "E"))."' align='middle' /></a>";
            }

            $email_image = "<a href='mailto:".$poster->getVar("email")."'>"
            ."<img src='".$sys_image['email']."' alt='".sprintf(_SENDEMAILTO, $poster->getVar("uname"))."' align='middle' /></a>";

            if ($poster->getVar("url") != "") {
                $www_image = "<a href='".$poster->getVar("url")."'>"
                ."<img src='".$sys_image['www']."' alt='"._VISITWEBSITE."' align='middle' /></a>";
            }

            if ( $sysUser && ($poster->getVar("user_icq") != "") ) {
                $icq_image = "<a href='http://wwp.icq.com/scripts/search.dll?to=".$poster->getVar("user_icq")."'>"
                ."<img src='".$sys_image['icq']."' alt='"._ADDTOLIST."' align='middle' /></a>";
            }

            if ( $sysUser && ($poster->getVar("user_aim") != "") ) {
                $aim_image = "<a href='aim:goim?screenname=".$poster->getVar("user_aim")."&message=Hi+".$poster->getVar("user_aim")."+Are+you+there?'>"
                ."<img src='".$sys_image['aim']."' alt='aim' align='middle' /></a>";
            }

            if ( $sysUser && ($poster->getVar("user_yim") != "") ) {
                $yim_image = "<a href='http://edit.yahoo.com/config/send_webmesg?.target=".$poster->getVar("user_yim")."&.src=pg'>"
                ."<img src='".$sys_image['yim']."' alt='yim' align='middle' /></a>";
            }

            if ( $sysUser && ($poster->getVar("user_msnm") != "") ) {
                $msnm_image = "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$poster->getVar("uid")."'>"
                ."<img src='".$sys_image['msnm']."' alt='msnm' align='middle' /></a>";
            }

            $subject = $this->getVar("subject");
            $comment = $this->getVar("comment");

            if ( ($poster->getVar("attachsig") == 1) && ($poster->getVar("user_sig") != "") ) {
                $comment .= "<br /><br />--<br />";
                $comment .= $myts->makeTareaData4Show($poster->getVar("user_sig", "N"), 0, 1, 1);
            }

            $username = '<a href="'.SYS_ROOT_URL.'/userinfo.php?uid='.$poster->getVar("uid").'">'.$poster->getVar("uname").'</a>';
            return theme_post($subject, $comment, $color_num, $subject_image, $post_date, $ip_image, $reply_image, $edit_image, $delete_image, $username, $rank['title'], $rank['image'], $avatar_image, $reg_date, $posts, $user_from, $online_image, $profile_image, $pm_image, $email_image, $www_image, $icq_image, $aim_image, $yim_image, $msnm_image);
        }
    }
}
?>