<?php
/**
 * File: $Id: formdhtmltextarea.php,v 1.22 2005/08/21 07:18:44 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

include_once(SYS_ROOT_PATH."/include/syscodes.php");
include_once(SYS_ROOT_PATH."/class/sysform/formtextarea.php");

class SysFormDhtmlTextArea extends SysFormTextArea
{
    function SysFormDhtmlTextArea($caption, $name, $value="", $rows='', $cols='')
    {

        global $sysConfig;
        if ( $rows == '') {
            $rows =  $sysConfig['htmlarea_rows'];
        }
        $this->setRows($rows);
        if ( $cols == '') {
            $cols =  $sysConfig['htmlarea_cols'];
        }
        $this->setCols($cols);

        $this->SysFormTextArea($caption, $name, $value, $this->getRows(), $this->getCols());
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function render()
    {
        global $myts, $sysUser, $sysConfig;

        //include_once(SYS_ROOT_PATH."/class/sysform/formdhtmltextarea.js.php");
        if (! defined("CIAMOS_FORMDHTMLTEXTAREA_JS_INCLUDED") ) {
            define("CIAMOS_FORMDHTMLTEXTAREA_JS_INCLUDED", true);
            $ret = '<script type="text/javascript" language="JavaScript" src="'.SYS_ROOT_URL.'/class/sysform/formdhtmltextarea.js.php?language='.urlencode($sysConfig['language']).'"></script>';
        }
        $admin = false;
        if ( $sysUser && $sysUser->isAdmin() ) {
            $admin = true;
        }

        $ret .= "<table border='0' cellspacing='1' cellpadding='0'><tr class='bg2'><td>";
        $ret .= "<table border='0' cellspacing='1' cellpadding='8' width='100%'><tr class='bg1'><td>";

        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/bold.gif' alt='"._BOLD."' title='"._BOLD."' onclick='sysCodeBold(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/italic.gif' alt='"._ITALIC."' title='"._ITALIC."' onclick='sysCodeItalic(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/underline.gif' alt='"._UNDERLINE."' title='"._UNDERLINE."' onclick='sysCodeUnderline(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/strike.gif' alt='"._STRIKE."' title='"._STRIKE."' onclick='sysCodeStrike(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/overline.gif' alt='"._OVERLINE."' title='"._OVERLINE."' onclick='sysCodeOverline(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/left.gif' alt='"._LEFT."' title='"._LEFT."' onclick='sysCodeLeft(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/center.gif' alt='"._CENTER."' title='"._CENTER."' onclick='sysCodeCenter(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/right.gif' alt='"._RIGHT."' title='"._RIGHT."' onclick='sysCodeRight(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/justify.gif' alt='"._JUSTIFY."' title='"._JUSTIFY."' onclick='sysCodeJustify(\"".$this->getName()."\");' /></a> ";

        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/list.gif' alt='"._LIST."' title='"._LIST."' onclick='sysCodeList(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/hr.gif' alt='"._HLINE."' title='"._HLINE."' onclick='sysCodeHr(\"".$this->getName()."\");' /></a> ";
        $ret .= "<br />";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/iframe.gif' alt='"._IFRAME."' title='"._IFRAME."' onclick='sysCodeIframe(\"".$this->getName()."\");' /></a> ";

        /**
         * Commented out marquee buttons - bbcode will still work
         *
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/marqd.gif' alt='"._MARQD."' title='"._MARQD."' onclick='sysCodeMarqd(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/marqu.gif' alt='"._MARQU."' title='"._MARQU."' onclick='sysCodeMarqu(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/marql.gif' alt='"._MARQL."' title='"._MARQL."' onclick='sysCodeMarql(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/marqr.gif' alt='"._MARQR."' title='"._MARQR."' onclick='sysCodeMarqr(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/marqh.gif' alt='"._MARQH."' title='"._MARQH."' onclick='sysCodeMarqh(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/marqv.gif' alt='"._MARQV."' title='"._MARQV."' onclick='sysCodeMarqv(\"".$this->getName()."\");' /></a> ";
        $ret .= "<br />";
         */

        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/link.gif' alt='"._URL."' title='"._URL."' onclick='sysCodeUrl(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/image.gif' alt='"._IMAGE."' title='"._IMAGE."' onclick='sysCodeImg(\"".$this->getName()."\");' /></a> ";
        if ( $admin || $myts->allowLibrary == 1 ) {
            $ret .= " <a href='javascript:justReturn();'>
        <img src='".SYS_ROOT_URL."/images/editor/image-m.gif' alt='"._LIB."' alt='"._LIB."' onclick='openWithSelfMain(\"".SYS_ROOT_URL."/misc.php?action=showpopups&type=images&target=".$this->getName()."\", \"images\", 275, 350);' /></a> ";
        }
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/email.gif' alt='"._EMAIL."' title='"._EMAIL."' onclick='sysCodeEmail(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/quote.gif' alt='"._QUOTE."' title='"._QUOTE."' onclick='sysCodeQuote(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/code.gif'  alt='"._CODE."'  title='"._CODE."'  onclick='sysCodeCode(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/flash.gif' alt='"._FLASH."' title='"._FLASH."' onclick='sysCodeFlash(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/video.gif' alt='"._VIDEO."' title='"._VIDEO."' onclick='sysCodeVideo(\"".$this->getName()."\");' /></a> ";
        $ret .= "<a href='javascript:justReturn();'><img src='".SYS_ROOT_URL."/images/editor/sound.gif' alt='"._SOUND."' title='"._SOUND."' onclick='sysCodeSound(\"".$this->getName()."\");' /></a>";
        $ret .= "<br />";

        $ret .= "<select class='select' id='".$this->getName()."Size' onchange='sysCodeSize(\"".$this->getName()."\");'></a>";
        $ret .= "<option value='SIZE'>"._SIZE."</option>";

        $sizearray = array("xx-small", "x-small", "small", "medium", "large", "x-large", "xx-large");
        foreach ($sizearray as $size) {
            $ret .=  "<option value='$size'>$size</option>";
        }
        $ret .= "</select> ";

        $fontarray = array("Arial", "Courier", "Georgia", "Helvetica", "Impact", "Verdana");
        $ret      .= "<select class='select' id='".$this->getName()."Font' onchange='sysCodeFont(\"".$this->getName()."\");'>";
        $ret      .= "<option value='FONT'>"._FONT."</option>";

        foreach ($fontarray as $font) {
            $ret .= "<option value='$font'>$font</option>";
        }
        $ret .= "</select> ";

        $ret .= "<select class='select' id='".$this->getName()."Color' onchange='sysCodeColor(\"".$this->getName()."\");'>";
        $ret .= "<option value='COLOR'>"._COLOR."</option>";

        $colorarray = array("00", "33", "66", "99", "CC", "FF");
        foreach ($colorarray as $color1) {
            foreach ($colorarray as $color2) {
                foreach ($colorarray as $color3) {
                    $ret .= "<option value='".$color1.$color2.$color3."' style='background-color:#".$color1.$color2.$color3.";color:#".$color1.$color2.$color3.";'>#".$color1.$color2.$color3."</option>";
                }
            }
        }
        $ret .= "
                </select>
                </td></tr></table>
                </td></tr></table>
                <textarea class='textarea' id='".$this->getName()."' name='".$this->getName()."' cols='".$this->getCols()."' rows='".$this->getRows()."'".$this->getExtra().">".$this->getValue()."</textarea>
                <br />";
        $ret .= $this->renderSmileys();
        return $ret;
    }

    /**
         * Description
         *
         * @param type $var description
         * @return type description
         */
    function renderSmileys()
    {
        $smileyPath = "images/smilies";

        $ret  = "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-) \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/smile.gif' border='0' alt=':-)' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-( \");'><im src='".SYS_ROOT_URL."/".$smileyPath."/frown.gif' border='0' alt=':-(' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-D \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/biggrin.gif' border='0' alt=':-D' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" ;-) \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/wink.gif' border='0' alt=';-)' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-o \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/ohmygod.gif' border='0' alt=':-o' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" 8-) \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/cool.gif' border='0' alt='8-)' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-? \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/huh.gif' border='0' alt=':-?' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-P \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/blush.gif' border='0' alt=':-P' /></a>";
        $ret .= "<a href='javascript:justReturn()' onclick='sysCodeSmilie(\"".$this->getName()."\", \" :-x \");'><img src='".SYS_ROOT_URL."/".$smileyPath."/angry.gif' border='0' alt=':-x' /></a>";
        $ret .= " [<a href='javascript:openWithSelfMain(\"".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=smilies&amp;target=".$this->getName()."\",\"smilies\", 300, 430);'>"._MORE."</a>]";

        return $ret;
    }
}
?>
