<?php
/**
 * File: $Id: formselect.php,v 1.5 2005/08/21 07:18:44 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

include_once(SYS_ROOT_PATH."/class/sysform/formelement.php");

/**
 * Enter description here...
 *
 */
class SysFormSelect extends SysFormElement
{
    var $size;
    // pre-selected values in array
    var $value    = array();
    var $options  = array();
    var $multiple = false;

    function SysFormSelect($caption, $name, $value="", $size=1, $multiple=false, $options='', $extra='')
    {
        $this->setCaption($caption);
        $this->setName($name);
        $this->multiple = $multiple;
        $this->size     = intval($size);
        $this->setValue($value);
        if ( is_array($options) ) {
            $this->addOptionArray($options);
        }
        if ( isset($extra) ) {
            $this->setExtra($extra);
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function isMultiple()
    {
        return $this->multiple;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getSize()
    {
        return $this->size;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getValue()
    {
        return $this->value;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addOption($value, $name="")
    {
        if ( $name != "" ) {
            $this->options[$value] = $name;
        } else {
            $this->options[$value] = $value;
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function setValue($value)
    {
        if ( $value != "" ) {
            $this->value = '';
            if ( is_array($value) ) {
                foreach ( $value as $v ) {
                    $this->value[] = $v;
                }
            } else {
                $this->value[] = $value;
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addOptionArray($arr)
    {
        if ( is_array($arr) ) {
            foreach ($arr as $k=>$v) {
                $this->addOption($k, $v);
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getOptions()
    {
        return $this->options;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function render()
    {
        $ret = "<select class='select' size='".$this->getSize()."'".$this->getExtra()."";

        if ( $this->isMultiple() != false ) {
            $ret .= " name='".$this->getName()."[]' id='".$this->getName()."[]' multiple='multiple'>";
        } else {
            $ret .= " name='".$this->getName()."' id='".$this->getName()."'>";
        }

        foreach ( $this->getOptions() as $value => $name ) {
            $ret .= "<option value='".htmlspecialchars($value, ENT_QUOTES)."'";
            $count = count($this->getValue());
            if ( $count > 0 && in_array($value, $this->getValue()) ) {
                $ret .= " selected='selected'";
            }
            $ret .= ">".$name."</option>";
        }
        $ret .= "</select>";
        return $ret;
    }
} // END CLASS
?>
