<?php
/**
 * File: $Id: sysgroup.php,v 1.6 2005/09/05 13:15:35 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_GROUP_INCLUDED") ) {
    exit();
}
define("CIAMOS_GROUP_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysobject.php");

/**
 * Enter description here...
 *
 */
class SysGroup extends SysObject
{
    var $admin_right_modules = array();
    var $read_right_modules  = array();
    var $read_right_blocks   = array();
    var $html_tags_right     = array();


    function SysGroup($id = NULL)
    {
        $this->SysObject();
        $this->initVar("groupid", "int", NULL, false);
        $this->initVar("name", "textbox", NULL, true, 100, false);
        $this->initVar("description", "textarea", NULL, true);
        $this->initVar("type", "other", NULL, false);
        $this->initVar("allowed_html", "textbox", NULL, true);

        if ( !empty($id) ) {
            if ( is_array($id) ) {
                $this->set($id);
            } else {
                $this->load(intval($id));
            }
        }
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $groupid
     */
    function load($groupid)
    {
        global $db;

        $sql = "
            SELECT *
                FROM ".$db->prefix("groups")."
                WHERE groupid=".$groupid."";
        $result = $db->query($sql);
        $arr = $db->fetch_array($result);
        $this->set($arr);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $arr
     */
    function setAdminRightModules($arr=array())
    {
        sort($arr);
        $this->admin_right_modules = $arr;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $arr
     */
    function setReadRightModules($arr=array())
    {
        sort($arr);
        $this->read_right_modules = $arr;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $arr
     */
    function setReadRightBlocks($arr=array())
    {
        sort($arr);
        $this->read_right_blocks = $arr;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $arr
     */
    function setHtmlTagsRight($arr=array())
    {
        sort($arr);
        $this->html_tags_right = $arr;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function store()
    {
        global $db;

        if ( !$this->isCleaned() ) {
            if ( !$this->cleanVars() ) {
                return false;
            }
        }
        foreach ( $this->cleanVars as $k=>$v ) {
            $$k = $v;
        }

        if ( empty($type) ) {
            if ( is_array($this->admin_right_modules) && count($this->admin_right_modules)>0 ) {
                $type = "Admin";
            } else {
                $type = "Custom";
            }
        }
        $allowed_html = "";
        if ( count($this->html_tags_right) > 0 ) {
            $allowed_html = implode("|", $this->html_tags_right);
        }
        if ( empty($groupid) ) {
            $groupid = $db->genId($db->prefix("groups")."_groupid_seq");
            $sql     = "
                INSERT
                    INTO ".$db->prefix("groups")."
                    SET groupid     = $groupid,
                        name        = '".$name."',
                        description = '".$description."',
                        type        = '".$type."',
                        tags        = '".$allowed_html."'";
        } else {
            $sql = "
                DELETE
                    FROM ".$db->prefix("groups_modules_link")."
                    WHERE groupid=".$groupid."";
            if ( !$result = $db->query($sql) ) {
                exit();
            }
            $sql = "
                DELETE
                    FROM ".$db->prefix("groups_blocks_link")."
                    WHERE groupid = ".$groupid."";
            if ( !$result = $db->query($sql) ) {
                exit();
            }
            $sql = "
                UPDATE ".$db->prefix("groups")."
                    SET name        = '".$name."',
                        description = '".$description."',
                        type        = '".$type."',
                        tags        = '".$allowed_html."'
                    WHERE groupid = ".$groupid."";
        }
        if ( !$result = $db->query($sql) ) {
            //must be localized!
            $this->setErrors("Could not query database");
            return false;
        }
        if ( empty($groupid) ) {
            $groupid = $db->insert_id();
        }
        foreach( $this->admin_right_modules as $admin_right_module ) {
            $sql = "
                INSERT
                    INTO ".$db->prefix("groups_modules_link")."
                    SET groupid = $groupid,
                        mid     = $admin_right_module,
                        type    = 'A'";
            $result = $db->query($sql);
            $sql = "
                INSERT
                    INTO ".$db->prefix("groups_modules_link")."
                    SET groupid = $groupid,
                        mid     = $admin_right_module,
                        type    = 'R'";
            $result = $db->query($sql);
        }
        foreach( $this->read_right_modules as $read_right_module ) {
            if ( !in_array($read_right_module, $this->admin_right_modules ) ) {
                $sql = "
                    INSERT
                        INTO ".$db->prefix("groups_modules_link")."
                        SET groupid = $groupid,
                            mid     = $read_right_module,
                            type    = 'R'";
                $result = $db->query($sql);
            }
        }
        foreach( $this->read_right_blocks as $read_right_block ){
            $sql = "
                INSERT INTO ".$db->prefix("groups_blocks_link")."
                    SET groupid     = $groupid,
                        block_id    = $read_right_block,
                        type        = 'R'";
            $result = $db->query($sql);
        }
        return $groupid;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function delete()
    {
        global $db;

        $sql = "
            DELETE
                FROM ".$db->prefix("groups")."
                WHERE groupid = ".$this->getVar("groupid");
        if ( !$result = $db->query($sql) ) {
            exit();
        }
        $result = $db->query("
            DELETE
                FROM ".$db->prefix("groups_users_link")."
                WHERE groupid = ".$this->getVar("groupid")."");
        $result = $db->query("
            DELETE
                FROM ".$db->prefix("groups_modules_link")."
                WHERE groupid = ".$this->getVar("groupid")."");
        $result = $db->query("
            DELETE
                FROM ".$db->prefix("groups_blocks_link")."
                WHERE groupid = ".$this->getVar("groupid")."");
        return true;
    }

    /**
     * Enter description here...
     *
     * @param string $which (module | block)
     * @param integer $id module/block id
     * @param integer $groupid
     * @param string $type R = read, A = admin
     * @return boolean true = has access
     */
    function checkRight($which, $id, $groupid=0, $type="R")
    {
        global $db;
        
        $return = false;
        if ( $which == "module" ) {
            $table  = "groups_modules_link";
            $column = "mid";
        } elseif ( $which == "block" ) {
            $table  = "groups_blocks_link";
            $column = "block_id";
        }
        $sql = "
            SELECT COUNT(*)
                FROM ".$db->prefix($table)."
                WHERE type = '".$type."'";
        if ( !empty($id) ) {
            $sql .= " AND ".$column."=".$id."";
        }
        if ( is_array($groupid) ) {
            $sql .= " AND (groupid=".$groupid[0]."";
            $size = count($groupid);
            if ( $size > 1 ) {
                for ( $i = 1; $i < $size; $i++ ) {
                    $sql .= " OR groupid=".$groupid[$i]."";
                }
            }
            $sql .= ")";
        } elseif ( $groupid != 0 ) {
            $sql .= " AND groupid=".$groupid."";
        } else {
            $grouparray = SysGroup::getByType("Anonymous");
            $sql .= " AND groupid=".$grouparray[0]."";
        }
        list($count) = $db->fetch_row($db->query($sql));
        if ( $count > 0 ) {
            $return = true;
        }
        return $return;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $user
     * @param unknown_type $asobject
     * @return unknown
     */
    function &getByUser(&$user, $asobject=false)
    {
        global $db;

        $ret = array();
        if ( strtolower(get_class($user)) == "sysuser" ) {
            $sql    = "
                SELECT g.*
                    FROM ".$db->prefix("groups")." g
                    LEFT JOIN ".$db->prefix("groups_users_link")." l
                        ON l.groupid = g.groupid
                    WHERE l.uid = ".$user->getVar("uid")."";
            $result = $db->query($sql);
            if ( !$db->num_rows($result) ) {
                $group_arr =& SysGroup::getByType("User", true);
                $group_arr[0]->addMember($user);
                if ( $asobject ) {
                    $ret[] = $group_arr[0];
                } else {
                    $ret[] = $group_arr[0]->getVar("groupid");
                }
            } else {
                while ( $myrow = $db->fetch_array($result) ) {
                    if ( $asobject ) {
                        $ret[] = new SysGroup($myrow);
                    } else {
                        $ret[] = $myrow['groupid'];
                    }
                }
            }
        }
        return $ret;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $type
     * @param unknown_type $asobject
     * @param unknown_type $sort
     * @param unknown_type $order
     * @return unknown
     */
    function &getByType($type="", $asobject=false, $sort="groupid", $order="ASC")
    {
        global $db;

        $ret = array();
        $where_query = "";
        if ( !empty($type) ) {
            $where_query = " WHERE type='".$type."'";
        }
        if ( !$asobject ) {
            $sql = "
                SELECT groupid
                    FROM ".$db->prefix("groups").""
                    .$where_query."
                    ORDER BY $sort $order";
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = $myrow['groupid'];
            }
        } else {
            $sql = "
                SELECT *
                    FROM ".$db->prefix("groups").""
                    .$where_query."
                    ORDER BY $sort $order";
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = new SysGroup($myrow);
            }
        }
        return $ret;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $criteria
     * @param unknown_type $sort
     * @param unknown_type $order
     * @return unknown
     */
    function &getAllGroupsList($criteria=array(), $sort="groupid", $order="ASC")
    {
        global $db;

        $ret = array();
        $where_query = "";
        if ( is_array($criteria) && count($criteria) > 0 ) {
            $where_query = " WHERE";
            foreach ( $criteria as $c ) {
                $where_query .= " $c AND";
            }
            $where_query = substr($where_query, 0, -4);
        }
        $sql= "
            SELECT groupid, name
                FROM ".$db->prefix("groups")."
                $where_query
                ORDER BY $sort $order";
        $result = $db->query($sql);
        while ( $myrow = $db->fetch_array($result) ) {
            $ret[$myrow['groupid']] = $myrow['name'];
        }
        return $ret;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $asobject
     * @return unknown
     */
    function &getMembers($asobject=false)
    {
        global $db;

        $ret = array();
        if ( !$asobject ) {
            $sql    = "
                SELECT uid
                    FROM ".$db->prefix("groups_users_link")."
                    WHERE groupid = ".$this->getVar("groupid")."
                    GROUP BY uid";
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = $myrow['uid'];
            }
        } else {
            $sql = "
                SELECT u.*
                    FROM".$db->prefix("groups_users_link")." l,
                        ".$db->prefix("users")." u
                    WHERE l.groupid=".$this->getVar("groupid")."
                        AND u.uid=l.uid";
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $obj   = new SysUser($myrow);
                $ret[] = $obj;
            }
        }
        return $ret;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getHtmlTags()
    {
        global $db;

        $sql       = "
            SELECT tags
                FROM ".$db->prefix("groups")."
                WHERE groupid=".$this->getVar("groupid")."";
        $result    = $db->query($sql);
        list($ret) = $db->fetch_row($sql);
        return $ret;
    }
    /**
     * Enter description here...
     *
     * @param unknown_type $user
     * @return unknown
     */
    function addMember(&$user)
    {
        global $db;

        if ( strtolower(get_class($user)) == "sysuser" ) {
            $sql = "
                INSERT
                    INTO ".$db->prefix("groups_users_link")."
                    SET groupid=".$this->getVar("groupid").",
                        uid=".$user->getVar("uid")."";
            $db->query($sql);
            return true;
        }
        return false;
    }
}
?>