<?php
/**
 * Ciamos - Content Management System
 * This class is for Ciamos abuse handling
 * @package Ciamos
 * @copyright (C) 2004-2005 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 *
 */
class SysCheckAbuse extends SysHandler {

	/*	Function: SysCheckAbuse()
	*	----------------------------------------------------------------
	*	Purpose:			Extension function for SysHandler class that 
	*						checks for possible abuse and writes it to /cache/abuse.php
	*	Arguments:			
	*	Returns/Assigns:	Sets variable $abuse to true if any vars contain
	*						possible abuse values.
	*						Redirects to /cache/abuse.php if true.
	*/ 
	function SysCheckAbuse()
	{
		global $_SERVER;

		$abuse = false;
		$sys_abuse = $_GET;
		foreach ( $sys_abuse as $key => $content) {
			if ( preg_match('/<(.*?)>/s', $content)
					|| preg_match('/cd (.*?)/s', $content)
					|| preg_match('/chmod (.*?)/s', $content)
					|| preg_match('/ls (.*?)/s', $content)
					|| preg_match('/uname (.*?)/s', $content) ) {
				$abuse = true;
				$ab_array[$key] = $content;
			}
		}
		if ( $abuse ) {
			$ab_time  = date("Y_m_d-H_i_s");

			$text .= "\n-----\n"._REMOTE_ADDR." has tried to abuse the system.\n";
			foreach ( $ab_array as $key => $var_content ) {
				$text .= 'Attacker tried to set the GET var: '.$key.' to '.$var_content."\n";
			}
			$text .= "Date: ".$ab_time." | Query String: "._QUERY_STRING." | Location: "._PHP_SELF;

			if ( $file_size == 0 ) {

				$phptext = "<"."?php
						// Nobody can see this from web browser
						echo \"You cannot view this file directly\";
						exit();
						?".">";

				if ( $file = fopen($filename, "w") ) {
					fwrite($file, $phptext);
					fclose($file);
				}
			}

			$filename = SYS_ROOT_PATH."/cache/abuse.php";
			if ( $file = fopen($filename, "a+") ) {
				fwrite($file, $text);
				fclose($file);
			}
			header('Status: 302 Found');
			header("Location: ".SYS_ROOT_URL."/abuse.php");
		}
	}
}
?>