<?php
/**
 * Ciamos - Content Management System
 * This class is for Ciamos banned handling
 * @package Ciamos
 * @copyright (C) 2004-2005 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 *
 */
class SysCheckBanned extends SysHandler {

	/*	Function: SysCheckBanned()
	*	----------------------------------------------------------------
	*	Purpose:			Extension function for SysHandler class that 
	*						checks for banned users.
	*	Arguments:			
	*	Returns/Assigns:	exit()'s if IP or user agent is banned
	*/ 
	function SysCheckBanned() 
	{
		global $sysHandler;
		/**
		 * Include unallowed words/hosts list (will be moved to core api)
		 */
			$sysBadUnames = file(SYS_MOD_PATH.'/system/cache/badunames.php');
			$sysBadEmails = file(SYS_MOD_PATH.'/system/cache/bademails.php');
			$sysBadWords  = file(SYS_MOD_PATH.'/system/cache/badwords.php');
			$sysBadIps    = file(SYS_MOD_PATH.'/system/cache/badips.php');
			$sysBadAgents = file(SYS_MOD_PATH.'/system/cache/badagents.php');

		/**
		 * Ban unwanted IP address
		 */
			if ( hasMatch($sysBadIps, _REMOTE_ADDR) || hasMatch($sysBadAgents, _HTTP_USER_AGENT) ) {
				if(!header('Status: 404 Not Found')) {
					if(hasMatch($sysBadIps, _REMOTE_ADDR)) $errmsg = "IP: "._REMOTE_ADDR;
					if(hasMatch($sysBadAgents, _HTTP_USER_AGENT)) $errmsg = "User Agent: "._HTTP_USER_AGENT.BANNED;
				}
				$sysHandler['security']->showSecurityERR('','',$errmsg." is banned",0,0);
			}

	}
}
?>