<?php
/**
 * File: $Id: syspagenav.php,v 1.4 2005/06/03 16:39:35 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_PAGENAV_INCLUDED") ) {
    return;
}
define("CIAMOS_PAGENAV_INCLUDED", true);

/**
 * Enter description here...
 *
 */
class SysPageNav
{
    var $total;
    var $perpage;
    var $current;
    var $url;

    /**
     * Enter description here...
     *
     * @param unknown $total_items
     * @param unknown $items_perpage
     * @param unknown $current_start
     * @param unknown $start_name
     * @param unknown $extra_arg
     * @return SysPageNav
     */
    function SysPageNav($total_items, $items_perpage, $current_start, $start_name="start", $extra_arg="")
    {
        $this->total   = intval($total_items);
        $this->perpage = intval($items_perpage);
        $this->current = intval($current_start);
        if ( $extra_arg != '' && ( substr($extra_arg, -5) != '&amp;' || substr($extra_arg, -1) != '&' ) ) {
            $extra_arg .= '&amp;';
        }
        $this->url = _PHP_SELF.'?'.$extra_arg.trim($start_name).'=';
    }

    /**
     * Enter description here...
     *
     * @param unknown $offset
     * @param unknown $renderstyle
     * @return unknown
     */
    function renderNav($offset=4, $renderstyle=true)
    {
        if ( $this->total < $this->perpage ) {
            return;
        }
        $total_pages = ceil($this->total / $this->perpage);
        if ( $total_pages > 1 ) {
            $ret  = '';
            $prev = ($this->current - $this->perpage);
            if ( $renderstyle ) {
                if ( $prev >= 0 ) {
                    $ret .= '<a href="'.$this->url.$prev.'">&lt;&lt;&lt;&nbsp;</a> ';
                }
            } else {
                $ret .= '<table width="100%" style="border-bottom-style:solid; border-top-style:solid; border-width:1px;" border="0" cellpadding="7" cellspacing="0"><tr>';
                if ($prev >= 0) {
                    $ret .= '<td align="left"><a href="'.$this->url.$prev.'"><b>&laquo; '._PREVIOUS.'</b></a></td>';
                } else {
                    $ret .= '<td align="left">&laquo; <i>'._PREVIOUS.'</i></td>';
                }
                $ret .= '<td align="center">';
            }

            $counter      = 1;
            $current_page = intval(floor(($this->current + $this->perpage) / $this->perpage));
            while ( $counter <= $total_pages ) {
                if ( $counter == $current_page ) {
                    $ret .= '<b>['.$counter.']</b> ';
                } elseif ( ($counter > $current_page-$offset && $counter < $current_page + $offset ) 
                        || $counter == 1 || $counter == $total_pages ) {
                    if ( $counter == $total_pages && $current_page < $total_pages - $offset ) {
                        $ret .= '... ';
                    }
                    $ret .= '<a href="'.$this->url.(($counter - 1) * $this->perpage).'">'.$counter.'</a> ';
                    if ( ($counter == 1) && ($current_page > (1 + $offset) ) ) {
                        $ret .= '... ';
                    }
                }
                $counter++;
            }
            $next = $this->current + $this->perpage;

            if ( $renderstyle ) {
                if ( $this->total > $next ) {
                    $ret .= '<a href="'.$this->url.$next.'">&nbsp;&gt;&gt;&gt;</a> ';
                }
            } else {
                if ($this->total > $next) {
                    $ret .= '<td align="right"><a href="'.$this->url.$next.'"><b>'._NEXT.' &raquo;</b></a></TD>';
                } else {
                    $ret .= '<td align="right"><i>'._NEXT.'</i> &raquo;</td>';
                }
                $ret .= '</tr></table>';
            }
        }

        return $ret;
    }

    /**
     * Enter description here...
     *
     * @param unknown $showbutton
     * @return unknown
     */
    function renderSelect($showbutton=false)
    {
        if ( $this->total < $this->perpage ) {
            return;
        }
        $total_pages = ceil($this->total / $this->perpage);
        $ret = '';
        if ( $total_pages > 1 ) {
            $ret          = '<form name="pagenavform">';
            $ret         .= '<select class="select" name="pagenavselect" id="pagenavselect" onchange="location=this.options[this.options.selectedIndex].value;">';
            $counter      = 1;
            $current_page = intval(floor(($this->current + $this->perpage) / $this->perpage));
            while ($counter <= $total_pages) {
                if ($counter == $current_page) {
                    $ret .= '<option value="'.$this->url.(($counter - 1) * $this->perpage).'" selected="selected">'.$counter.'</option>';
                } else {
                    $ret .= '<option value="'.$this->url.(($counter - 1) * $this->perpage).'">'.$counter.'</option>';
                }
                $counter++;
            }
            $ret .= '</select>';
            if ( $showbutton) {
                $ret .= '&nbsp;<input type="submit" class="button" value="'._SUBMIT.'" />';
            }
            $ret .= '</form>';
        }
        return $ret;
    }
}
?>