<?php
 /*
 * File: $Id: systemplate.php,v 1.28 2005/09/05 13:15:35 greyhead Exp $
 * Ciamos - Content Management System
 * Basic Template class
 *
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 * @author Florian Solcher (alphalogic) (@link http://www.alphalogic.org)
 *
 */
 
$template_cache = array();
$entities = array_merge(get_html_translation_table (HTML_ENTITIES, ENT_COMPAT), 
    get_html_translation_table (HTML_SPECIALCHARS, ENT_COMPAT));
foreach ( $entities as $key => $entity ) {
    $html_entities[$entity] = '[ENTITY_'.strtoupper(str_replace('&','', str_replace(';','',$entity))).']';
    $xhtml_entities['&#'.ord($key).';'] ='[ENTITY_'.strtoupper(str_replace('&','', str_replace(';','',$entity))).']';
}

/**
 * List of tags which aren't allowed to use the name attribute
 */
$no_name_attr = array('link', 'script', 'html', 'head');

Class SysTemplate 
{
    var $template_file      = '';
    var $xml_array          = array();
    var $xml_content        = '';
    var $outputVars         = array();
    var $outputVarArrays    = array();
    var $outputAttributes   = array();
    var $switches           = array();
    var $loopCount          = array();
    var $ouput              = '';
    
    /**
     * Enter description here...
     *
     * @param unknown_type $template_file
     * @return SysTemplate
     */
    function SysTemplate ($template_file = '') 
    {
        global $template_cache;

        if ( $template_file ) {
            $this->template_file = $template_file;
            if ( array_key_exists($template_file, $template_cache) ) {
                $this->xml_array = $template_cache[$template_file];
            } else {
                $this->xml2array();
            }
        }
    }
    
    /**
     * Enter description here...
     *
     * @param unknown_type $template_file
     */
    function setTemplate($template_file) 
    {
        global $template_cache;
        
        $this->template_file = $template_file;
        if ( array_key_exists($template_file, $template_cache) ) {
            $this->xml_array = $template_cache[$template_file];
        } else {
            $this->xml2array();
        }
    }       
    
    /**
     * Enter description here...
     *
     * @param unknown_type $xml_content
     */
    function parseXML($xml_content = '') 
    {
        if ( !$xml_content )  {
            $xml_content =  $this->xml_content ;
        }
        $xml_parser = xml_parser_create();
        xml_parser_set_option ($xml_parser, XML_OPTION_TARGET_ENCODING, 'UTF-8');
        xml_parser_set_option ($xml_parser, XML_OPTION_CASE_FOLDING, 1);
        xml_parser_set_option ($xml_parser, XML_OPTION_SKIP_WHITE, 0);
        xml_parse_into_struct($xml_parser, $xml_content, $xml_array);
        xml_parser_free($xml_parser);
        $this->xml_array = $xml_array;
    }
    
    /**
     * Enter description here...
     *
     * @param unknown_type $content
     * @return unknown
     */
    function unEntity($content) 
    {
        global $html_entities, $xhtml_entities;
        
        foreach ( $html_entities as $key => $value ) {
            $content = str_replace($key, $value, $content);
        }
        foreach ( $xhtml_entities as $key => $value ) {
            $content = str_replace($key, $value, $content);
        }
        return $content;
    }

    /**
     * Parses the html/xml file to a php array using the xml extension
     *
     * @param unknown_type $filename
     */
    function xml2array($filename = '') 
    {
        global $template_cache;
        
        if ( $filename ) {
            $filename =  $filename;
        } else {
            $filename =  $this->template_file;
        }
        $xml_parser = xml_parser_create();
        if ( !($fp = fopen($filename, "r")) ) {
            die(_TEMPLATE_ERROR);
        }
        $contents = fread($fp, filesize($filename));
        fclose($fp);
        $this->xml_content = $this->unEntity($contents);
        $this->parseXML();  
        $template_cache[$filename] = $this->xml_array;  
    }

    /**
     * Sets simple output vars
     *
     * @param unknown_type $xml_tag
     * @param unknown_type $value
     */
    function setOutputVar($xml_tag, $value) 
    {
        $this->outputVars[strtoupper($xml_tag)] = $this->unEntity($value);
    }

    /**
     * Sets an attribute
     *
     * @param unknown_type $xml_tag
     * @param unknown_type $name
     * @param unknown_type $attribute
     * @param unknown_type $value
     */
    function setOutputAttribute($xml_tag, $name, $attribute, $value) 
    {
        $this->outputAttributes[strtoupper($xml_tag)][$name][strtoupper($attribute)] = $value;
    }

    /**
     * Sets output arrays for loops
     *
     * @param unknown_type $xml_array_tag
     * @param unknown_type $xml_tag
     * @param unknown_type $value
     */
    function setOutputVarArray($xml_array_tag, $xml_tag, $value = '') 
    {
        if ( is_array($xml_tag) ) {
            foreach ( $xml_tag as $id => $value ) {
                $this->outputVarArrays[strtoupper($xml_array_tag)][strtoupper($id)][] = $this->unEntity($value);
                $this->loopCount[strtoupper($xml_array_tag)] = count($this->outputVarArrays[strtoupper($xml_array_tag)][strtoupper($id)]);
            }
        } else {
            $this->outputVarArrays[strtoupper($xml_array_tag)][strtoupper($xml_tag)][] = $this->unEntity($value);
            $this->loopCount[strtoupper($xml_array_tag)] = count($this->outputVarArrays[strtoupper($xml_array_tag)][strtoupper($xml_tag)]);
        }
    }

    /**
     * Sets a simple switch
     *
     * @param unknown_type $switchName
     * @param unknown_type $bool
     */
    function setSwitch($switchName, $bool) 
    {
        $this->switches[strtoupper($switchName)] = $bool; 
    }

    /**
     * Injects simple vars
     *
     */
    function injectVars() 
    {
        foreach ( $this->xml_array as $key => $item ) {
            if ( ($item['type'] == 'complete' || $item['type'] == 'open') 
                    && $item['tag'] == 'VARIABLE' 
                    && array_key_exists(strtoupper($item['attributes']['NAME']), $this->outputVars) ) {
                $this->xml_array[$key]['value'] = $this->outputVars[strtoupper($item['attributes']['NAME'])];               
            }
        }
    }

    /**
     * Inject simple attributes
     *
     */
    function injectAttributes() 
    {
        foreach ( $this->xml_array as $key => $item ) {
            if ( ($item['type'] == 'complete' || $item['type'] == 'open') ) {
                if ( is_array($item['attributes']) ) {
                    if ( array_key_exists('NAME', $item['attributes']) ) {
                        if ( is_array($this->outputAttributes[$item['tag']]) ) {
                            if ( array_key_exists($item['attributes']['NAME'], $this->outputAttributes[$item['tag']]) ) {
                                foreach ( $this->outputAttributes[$item['tag']][$item['attributes']['NAME']] as $attribute => $value ) {
                                    $this->xml_array[$key]['attributes'][$attribute] = $value;
                                }
                            }
                        }
                    }
                }               
            }
        }
    }   
    
    /**
     * Injects constants
     *
     */
    function injectConstants() 
    {
        $constants = get_defined_constants();
        foreach ( $this->xml_array as $key => $item ) {
            if ( ($item['type'] == 'complete' || $item['type'] == 'open') 
                    && ($item['tag'] == 'CONSTANT')) {
                $this->xml_array[$key]['value'] = $constants[$item['attributes']['NAME']];              
            }
        }
        /** PHP 5 version (true parameter not valid in PHP 4)
        $constants = get_defined_constants(true);
        foreach ( $this->xml_array as $key => $item ) {
            if ( ($item['type'] == 'complete' || $item['type'] == 'open') 
                    && ($item['tag'] == 'CONSTANT')) {
                $this->xml_array[$key]['value'] = $constants['user'][$item['attributes']['NAME']];              
            }
        }
        */
    }

    /**
     * Inject array
     *
     * @param unknown_type $xml_array_tag
     * @param unknown_type $xml_tags
     * @return unknown
     */
    function injectArray($xml_array_tag, $xml_tags) 
    {
        $temp_array = array();
        $i          = 0;
        $this->loopCount[$xml_array_tag]; 
        while ( $i != $this->loopCount[$xml_array_tag] ) {
            foreach ( $xml_tags as $key => $item ) {
                if ( $item['type'] == 'complete' && $item['tag'] == 'VARIABLE' ) {
                    $item['value'] = $this->outputVarArrays[$xml_array_tag][strtoupper($item['attributes']['NAME'])][$i];           
                }
                $temp_array[] = $item;              
            }
            $i++;
        }
        return $temp_array;
    }
    
    /**
     * Inject arrays
     *
     */
    function injectArrays() 
    {
        $temp_array =  '';
        $is_loop = false;
        $temp_tags = '';
        foreach ( $this->xml_array as $key => $item ) {
            if ( $item['type'] == 'open' && $item['tag']== 'LOOP' ) {
                $is_loop = true;
                $loop_level = $item['level'];
                $loop_name =  strtoupper($item['attributes']['NAME']);
            } elseif ( $item['type'] == 'close' && ($item['tag'] == 'LOOP') 
                    && $item['level'] == $loop_level) {
                $inject_array = $this->injectArray($loop_name, $temp_tags); 
                foreach ( $inject_array as $in_item ) {
                    $temp_array[] = $in_item;
                }
                $temp_tags  = '';
                $is_loop    = false;
            } elseif ( $is_loop ) {
                $temp_tags[] = $item;
            } else {
                $temp_array[] = $item; 
            }
        }
        $this->xml_array = $temp_array;
    }
    
    /**
     * Includes sub-templates
     *
     */
    function doIncludes() 
    {
        global $module_dir, $template_cache;
        
        $temp_array =  '';
        foreach ( $this->xml_array as $key => $item ) {
            $level = $item['level'];
            if ( ($item['type'] == 'complete' || $item['type'] == 'open') 
                    && $item['tag'] == 'INCLUDE' ) {
                $include_file = THEME_TEMPLATE_PATH."/".$item['attributes']['NAME'];
                if ( !array_key_exists($include_file, $template_cache) ) {
                    new SysTemplate($include_file);
                }
                foreach ($template_cache[$include_file] as $include_item) {
                    if ( $include_item['tag'] != 'TEMPLATE') {
                        $include_item['level'] += $level-1;
                        $temp_array[] = $include_item;
                    }
                }
            } else {
                $temp_array[] = $item;
            }
        }
        $this->xml_array = $temp_array;
    }
    
    /**
     * Handles switches
     *
     */
    function doSwitches() 
    {
        $temp_array = '';
        $switch_hide = false;
        foreach ( $this->xml_array as $key => $item ) {
            if ( $item['type'] == 'open'
                    && $item['tag'] == 'SWITCH' 
                    && !($switch_hide) ) {
                if ( !$this->switches[strtoupper($item['attributes']['NAME'])] )  {
                    $switch_hide    = true;
                    $switch_level   = $item['level'];
                }
            } elseif ( $item['type']  == 'close' 
                    && $item['tag']   == 'SWITCH' 
                    && $item['level'] == $switch_level && $switch_hide ) {
                $switch_hide = false;
            } elseif ( $item['type'] == 'close' && $item['tag'] == 'SWITCH' ) {
                // continue
            } elseif ( $switch_hide ) {
                // continue
            } else {
                $temp_array[] = $item;
            }
        }
        $this->xml_array = $temp_array;
    }

    /**
     * Handles hides
     *
     */
    function doHides() 
    {
        $temp_array = '';
        $hide = false;
        foreach ( $this->xml_array as $key => $item ) {
            if ( $item['type'] == 'open' && $item['tag'] == 'HIDE' ) {
                $hide   = true;
            } elseif ( $item['type'] == 'close' && $item['tag'] == 'HIDE' && $hide ) {
                $hide = false;
            } elseif( $hide ) {
                // continue
            } else {
                $temp_array[] = $item;
            }
        }
        $this->xml_array = $temp_array;
    }   

    /**
     * Strip disallowed name attributes
     *
     */
    function fixAttributes () 
    {
        global $no_name_attr;
        
        foreach ( $this->xml_array as $key => $item ) {
            if ( is_array($item['attributes']) && in_array(strtolower($item['tag']), $no_name_attr) ) {
                if ( $item['attributes']['NAME'] ) {
                    unset($this->xml_array[$key]['attributes']['NAME']);
                }
            }
        }
    }
    
    /**
     * Enter description here...
     *
     * @param unknown_type $value
     * @return unknown
     */
    function fixValue($value) 
    {
        //$value = str_replace("\n", '',  str_replace("\t", '', $value)); //later to be added as soon as there a now scripts directly on the page
        $value = str_replace("    ", " ", $value);
        $value = str_replace("   ", " ", $value);
        $value = str_replace("  ", " ", $value);
        return $value;
    }
    
    /**
     * Enter description here...
     *
     */
    function array2xml() 
    {
        foreach ( $this->xml_array as $xml_key => $xml_value ) {
            switch ( $xml_value['type'] ) {
                
                case "open":
                if ( $xml_value['tag'] == 'CONSTANT' 
                        || $xml_value['tag'] == 'VARIABLE' 
                        || $xml_value['tag'] == 'TEMPLATE' 
                        || $xml_value['tag'] == 'SWITCH') {
                    $xml .= $this->fixValue($xml_value['value']);
                    unset($xml_value['attributes']);
                } else {
                    $last_open_value = $xml_value;
                    $xml .= "\n".str_repeat("\t", $xml_value["level"] - 1);
                    $xml .= "<" . strtolower($xml_value["tag"]);            
                    if ( !isset($xml_value["attributes"]) ) {
                        $xml .= ">".$this->fixValue($xml_value['value']);
                    } else {
                        $xml .= false;
                    }
                }
                break;

                case "complete":
                if ( $xml_value['tag'] == 'CONSTANT' 
                        || $xml_value['tag'] == 'VARIABLE' 
                        || $xml_value['tag'] == 'SWITCH') {
                    $xml .= $xml_value['value'];
                    unset($xml_value['attributes']);
                } else {
                    $xml .= "\n".str_repeat("\t", $xml_value["level"] - 1);
                    $xml .= "<" . strtolower($xml_value["tag"]);
                    if ( !isset($xml_value["attributes"]) ) {
                        if ( isset($xml_value["value"]) ) {
                            $xml .= '>'.$this->fixValue($xml_value["value"]).'</'.strtolower($xml_value["tag"]).'>';
                        } else {
                            $xml .= ' />';
                        }
                        
                    }
                    //$xml .= (!isset($xml_value["attributes"]))? '>\n": false;
                }
                break;

                case "close":
                if ( $xml_value['tag'] == 'CONSTANT' 
                        || $xml_value['tag'] == 'VARIABLE' 
                        || $xml_value['tag'] == 'TEMPLATE' 
                        || $xml_value['tag'] == 'SWITCH' ) {
                    //continue
                } else {
                    if ( $last_open_value['tag'] == $xml_value['tag'] 
                           && $last_open_value['level'] == $xml_value['level']) {
                        $xml .= "</" . strtolower($xml_value["tag"]);
                        $xml .= '>';    
                    } else {
                        $xml .= "\n".str_repeat("\t", $xml_value["level"] - 1);
                        $xml .= "</" . strtolower($xml_value["tag"]);
                        $xml .= '>';
                    }
                    unset($xml_value["attributes"]);
                    //$xml .= (!isset($xml_value["attributes"]))? ">\n": false;
                }
                break;

                default:
                //$xml .= str_repeat("\t", $xml_value["level"] - 1);
                $xml .= $this->fixValue($xml_value['value']);
                break;
               
              //default:
              // break;
            }
            if ( isset($xml_value["attributes"]) ) {
                foreach ( $xml_value["attributes"] as $attribute_key => $attribute_value ) {
                    $xml .= sprintf(' %s="%s"', strtolower($attribute_key), $attribute_value);
                }
                if ( $xml_value["type"] == "complete" ) {
                    if ( isset($xml_value['value']) ) {
                        $xml .= '>'.$this->fixValue($xml_value['value']).'</'.strtolower($xml_value['tag']).'>';
                    } else {
                        if ( $xml_value['tag'] == 'SCRIPT' ) {
                            $xml .= '></script>';
                        } else {
                            $xml .= ' />';
                        }
                    }
                } else {
                    $xml .= '>'.$this->fixValue($xml_value['value']);
                }
            }
        }
        $this->output = $xml;
    }
    
    /**
     * Enter description here...
     *
     */
    function fixOutput() 
    {
        global $sysConfig;
        
        if ( $sysConfig['sourcecodestyle'] ) {
            // $this->output = str_replace("\t", "", $this->output);
            // $this->output = str_replace("\n", "", $this->output);
            // $this->output = str_replace("\r", "", $this->output);
            $this->output = str_replace("    ", " ", $this->output );
            $this->output = str_replace("   ", " ", $this->output);
            $this->output = str_replace("  ", " ", $this->output);              
            $this->output = str_replace("> <", "><", $this->output);
            // $this->output = str_replace("> ", ">", $this->output);
            // $this->output = str_replace(" <", "<", $this->output);
            
            $this->output = str_replace("\n ", "\n", $this->output);
            $this->output = str_replace("\n\n", "\n", $this->output);
        } else {
            $this->output = str_replace("\t", "", $this->output);
            // @todo :: causes problems with cdata removed line breaks from edit textareas
            // $this->output = str_replace("\n", "", $this->output);
            $this->output = str_replace("\r", "", $this->output);
            $this->output = str_replace("    ", " ", $this->output );
            $this->output = str_replace("   ", " ", $this->output);
            $this->output = str_replace("  ", " ", $this->output);              
            $this->output = str_replace("> <", "><", $this->output);
            // @todo :: causes problems with cdata e.g. some <b>output</b> phrase
            // $this->output = str_replace("> ", ">", $this->output);
            // $this->output = str_replace(" <", "<", $this->output);
        }
    }
    
    /**
     * Enter description here...
     *
     */
    function reEntity() 
    {
        global $xhtml_entities;
        
        foreach ( $xhtml_entities as $key => $value ) {
            $this->output = str_replace($value, $key, $this->output);
        }
    }
            
    /**
     * Enter description here...
     *
     * @return unknown
     */
    function render() 
    {
        $this->doIncludes();
        $this->doHides();
        $this->doSwitches();
        $this->injectConstants();
        $this->injectArrays();
        $this->injectVars();
        $this->injectAttributes();
        $this->fixAttributes();
        $this->array2xml();
        
        return $this->output;
    }
    
    /**
     * Enter description here...
     *
     * @return unknown
     */
    function display() 
    {
        $this->doIncludes();
        $this->doHides();
        $this->doSwitches();
        $this->injectConstants();
        $this->injectArrays();
        $this->injectVars();
        $this->injectAttributes();
        $this->fixAttributes();
        $this->array2xml();
        $this->output = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'."\n".$this->output;
        $this->fixOutput();
        $this->reEntity();
        
        return rtrim($this->output);     
    }   
}