<?php
/**
 * File: $Id: sysuser.php,v 1.10 2005/06/29 21:57:49 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_USER_INCLUDED") ) {
    return;
}
define("CIAMOS_USER_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysobject.php");
include_once(SYS_ROOT_PATH."/class/sysgroup.php");

/**
    * Description
    *
    * @param type $var description
    * @return type description
    */
Class SysUser extends SysObject
{
    var $inactive     = false;
    var $groups       = array();
    var $admin_groups = array();

    function SysUser($id=NULL)
    {
        global $sysConfig;

        $this->SysObject();
        $this->initVar("uid",               "int",      NULL, false);
        $this->initVar("name",              "textbox",  NULL, false, 60, false);
        $this->initVar("uname",             "textbox",  NULL, true, 25, false);
        $this->initVar("email",             "textbox",  NULL, true, 60, false);
        $this->initVar("url",               "textbox",  NULL, false, 100, false);
        $this->initVar("user_avatar",       "textbox",  NULL, false, 30);
        $this->initVar("user_regdate",      "int",      NULL, false);
        $this->initVar("user_icq",          "textbox",  NULL, false, 15, false);
        $this->initVar("user_from",         "textbox",  NULL, false, 100, true);
        $this->initVar("user_sig",          "textarea", NULL, false, NULL, true);
        $this->initVar("user_viewemail",    "int",      0, false);
        $this->initVar("actkey",            "other",    NULL, false);
        $this->initVar("user_aim",          "textbox",  NULL, false, 18, true);
        $this->initVar("user_yim",          "textbox",  NULL, false, 25, true);
        $this->initVar("user_msnm",         "textbox",  NULL, false, 25, true);
        $this->initVar("pass",              "textbox",  NULL, false, 32, false);
        $this->initVar("posts",             "int",      NULL, false);
        $this->initVar("attachsig",         "int",      0, false);
        $this->initVar("rank",              "int",      NULL, false);
        $this->initVar("level",             "int",      0, false);
        $this->initVar("theme",             "other",    NULL, false);
        $this->initVar("timezone_offset",   "other",    NULL, false);
        $this->initVar("last_login",        "int",      0, false);
        $this->initVar("umode",             "other",    NULL, false);
        $this->initVar("uorder",            "int",      1, false);
        $this->initVar("user_occ",          "textbox",  NULL, false, 100, true);
        $this->initVar("bio",               "textarea", NULL, false, NULL, true);
        $this->initVar("user_interest",     "textbox",  NULL, false, 150, true);
        $this->initVar("user_mailok",       "int",      1, false);
        $this->initVar("msg_mail",          "int",      1, false);

        if ( !empty($id) ) {
            if ( is_array($id) ) {
                $this->set($id);
            } else {
                $this->load(intval($id));
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function loginUser($uname, $pass)
    {
        global $myts, $db;
        
        $return = false;
        $uname  = $myts->makeTboxData4Save($uname);
        $sql = "
            SELECT * 
                FROM ".$db->prefix('users')." 
                WHERE uname = '$uname'";
        $result = $db->query($sql);

        if ( $db->num_rows($result) == 1 ) {
            $convert = $passed  = false;
            $myrow   = $db->fetch_array($result);
            if ( !empty($myrow['uid']) ) {
                if ( $myrow['pass'] == md5($pass) ) {
                    $passed = true;
                } elseif ( $pass == $myrow['pass'] ) {
                    $convert = $passed  = true;
                } elseif (function_exists('crypt')) {
                    if (crypt($pass, substr($myrow['pass'], 0, 2)) == $myrow['pass'] ) {
                        $convert = $passed  = true;
                    }
                }
                if ( $convert ) {
                    $newpass = md5($pass);
                    $sql = "
                        UPDATE ".$db->prefix('users')." 
                            SET pass = '$newpass' 
                            WHERE uname = '$uname'";
                    $db->query($sql);
                }
                if ( $passed ) {
                    $return = new SysUser($myrow);
                }
            }
        }
        return $return;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function updateLastLogin()
    {
        global $db, $sysSecurity;

        $sql = '
            UPDATE '.$db->prefix('users').' 
                SET last_login = '.time().' 
                WHERE uid = '.$this->getVar('uid');
        $db->query($sql);
        if ( $sysSecurity['match_ip'] ) {
            unset($sql);
            $sql = "
                INSERT 
                    INTO ".$db->prefix('security_ip_log')."
                    SET uid = '".$this->getVar('uid')."',
                        uip = '"._REMOTE_ADDR."',
                        utime = '".time()."'";
            $db->query($sql);
        }
    }

    /**
     * Logs out user
     * removes user session from session table
     *
     * @param type $var description
     * @return type description
     */
    function logoutUser()
    {
        global $db, $sysConfig;

        $sql = "
            DELETE 
                FROM ".$db->prefix("session")." 
                WHERE uid = ".$this->getVar("uid")."";
        $db->query($sql);
        if ( $sysConfig['use_sessions'] ) {
            session_unset();
            session_destroy();
        } else {
            cookie($this->cookie);
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function load($id)
    {
        global $db, $objCache;

        if ( !empty($objCache->SysUser['load'][$id]) ) {
            $this->set($objCache->SysUser['load'][$id]);
            if ( $this->getVar("level") == 0 ) {
                $this->inactive = true;
            }
            return;
        }

        $sql = "
            SELECT *
                FROM ".$db->prefix("users")."
                WHERE uid=".$id."";
        if ( !$result = $db->query($sql) ) {
            die("ERROR");
        }

        $numrows = $db->num_rows($result);
        if ( $numrows == 1 ) {
            $myrow = $db->fetch_array($result);
            $this->set($myrow);
            $objCache->SysUser['load'][$id] = $myrow;
            if ( $this->getVar("level") == 0 ) {
                $this->inactive = true;
            }
        } elseif ( $numrows == 0 ) {
            $this->inactive = true;
        } else {
            die("Duplicate User Entries!");
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function store()
    {
        global $db;

        if ( !$this->isCleaned() ) {
            if ( !$this->cleanVars() ) {
                return false;
            }
        }

        foreach ( $this->cleanVars as $k=>$v ) {
            $$k = $v;
        }

        if ( empty($uid) ) {
            $uid = $db->genId($db->prefix("users")."_uid_seq");
            $sql = "
                INSERT
                    INTO ".$db->prefix("users")."
                    SET
                        uid=$uid,
                        uname='$uname',
                        name='$name',
                        email='$email',
                        url='$url',
                        user_avatar='$user_avatar',
                        user_regdate=".time().",
                        user_icq='$user_icq',
                        user_from='$user_from',
                        user_sig='$user_sig',
                        user_viewemail='$user_viewemail',
                        actkey='$actkey',
                        user_aim='$user_aim',
                        user_yim='$user_yim',
                        user_msnm='$user_msnm',
                        pass='$pass',
                        posts='$posts',
                        attachsig='$attachsig',
                        rank='$rank',
                        level='$level',
                        theme='$theme',
                        timezone_offset='$timezone_offset',
                        last_login=0,
                        umode='$umode',
                        uorder='$uorder',
                        user_occ='$user_occ',
                        bio='$bio',
                        user_interest='$user_interest',
                        msg_mail='$msg_mail',
                        user_mailok=$user_mailok";
        }  else {
            $sql ="
                UPDATE ".$db->prefix("users")."
                    SET
                        uname='$uname',
                        name='$name',
                        email='$email',
                        url='$url',
                        user_avatar='$user_avatar',
                        user_icq='$user_icq',
                        user_from='$user_from',
                        user_sig='$user_sig',
                        user_viewemail='$user_viewemail',
                        user_aim='$user_aim',
                        user_yim='$user_yim',
                        user_msnm='$user_msnm',
                        pass='$pass',
                        attachsig='$attachsig',
                        rank='$rank',
                        theme='$theme',
                        timezone_offset='$timezone_offset',
                        umode='$umode',
                        uorder='$uorder',
                        user_occ='$user_occ',
                        bio='$bio',
                        user_interest='$user_interest',
                        msg_mail='$msg_mail',
                        user_mailok=$user_mailok
                    WHERE uid=$uid";
        }
        if ( !$result = $db->query($sql) ) {
            $this->setErrors("Could not store data in database.");
            return false;
        }
        if ( empty($uid) ) {
            $uid = $db->insert_id();
        }
        return $uid;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function delete()
    {
        global $db;

        if ( $this->getVar("uid") > 0 ) {
            $sql = "
                DELETE
                    FROM ".$db->prefix("users")."
                    WHERE uid=".$this->getVar("uid")."";
            if ( !$result = $db->query($sql) ) {
                return false;
            }
            $sql = "
                DELETE
                    FROM ".$db->prefix("groups_users_link")."
                    WHERE uid=".$this->getVar("uid")."";
            $db->query($sql);
            $sql = "
                DELETE
                    FROM ".$db->prefix("bb_forum_mods")."
                    WHERE user_id=".$this->getVar("uid")."";
            $db->query($sql);
            $sql = "
                DELETE
                    FROM ".$db->prefix("priv_msgs")."
                    WHERE to_userid=".$this->getVar("uid")."";
            $db->query($sql);

            $avatar = avatarExists($this->getVar("uid"));
            if ($avatar) {
                @unlink(SYS_ROOT_PATH. '/images/avatar/'.$avatar);
            }
            $this->logoutUser();
        }

        return true;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function activate()
    {
        global $db;

        $sql = "
            UPDATE ".$db->prefix("users")."
                SET level=1
                WHERE uid=".$this->getVar("uid")."
                    AND actkey='".$this->getVar("actkey")."'";
        if ( !$result = $db->query($sql) ) {
            return false;
        }
        return true;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function isActive()
    {
        if ( $this->inactive == true) {
            return false;
        }
        return true;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function isAdmin($moduleid=0)
    {
        $return = false;
        if ( $this->admin_groups[$moduleid] ) {
            $return = true;
        } else {
            $this->admin_groups[$moduleid] = SysGroup::checkRight("module", $moduleid, $this->groups(), "A");
            if ( $this->admin_groups[$moduleid] ) {
                $return = true;
            }
        }
        return $return;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &rank($astitle=true)
    {
        global $objCache;

        if ($astitle) {
            if ($objCache->SysUser['rank']['title'][$this->getVar('uid')]) {
                return $objCache->SysUser['rank']['title'][$this->getVar('uid')];
            }
            $objCache->SysUser['rank']['title'][$this->getVar('uid')] = $this->getRank();
            return $objCache->SysUser['rank']['title'][$this->getVar('uid')];
        } else {
            if ($objCache->SysUser['rank']['normal'][$this->getVar('uid')]) {
                return $objCache->SysUser['rank']['normal'][$this->getVar('uid')];
            }
            $objCache->SysUser['rank']['normal'][$this->getVar('uid')] = $this->getVar("rank");
            return $objCache->SysUser['rank']['normal'][$this->getVar('uid')];
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &getRank()
    {
        global $db, $myts, $objCache;

        $sql = "
                SELECT rank_title AS title, rank_image AS image
                    FROM ".$db->prefix('ranks');
        if ( $this->getVar("rank") != 0 ) {
            $sql .= "
                    WHERE rank_id = ".$this->getVar("rank")."";
        } else {
            $sql .= "
                    WHERE rank_min <= " . $this->getVar("posts") . "
                        AND rank_max >= " . $this->getVar("posts") . "
                        AND rank_special = 0";
        }
        $result = $db->query($sql);
        $myrow  = $db->fetch_array($result);
        $myrow['title'] = $myts->makeTboxData4Show($myrow['title']);
        $myrow['id']    = $this->getVar("rank");
        
        return $myrow;
    }

    /**
     * returns an array of group ids this user belongs
     *
     * @param type $var description
     * @return type description
     */
    function &groups()
    {
        if ( empty($this->groups) ) {
            $this->groups = SysGroup::getByUser($this);
        }
        return $this->groups;
    }

    /**
     * Function to get user name from a certain user id
     *
     * @param type $var description
     * @return type description
     */
    function getUnameFromId($userid)
    {
        global $sysConfig, $myts, $db, $objCache;

        if ( $objCache->SysUser['uname'][$userid] ) {
            return $objCache->SysUser['uname'][$userid];
        }
        $sql = "
            SELECT uname
                FROM ".$db->prefix("users")."
                WHERE uid = $userid";
        if ( !$result = $db->query($sql) ) {
            return false;
        }
        if ( !$arr = $db->fetch_array($result) ) {
            return false;
        }
        $uname = $myts->makeTboxData4Show($arr['uname']);
        $objCache->SysUser['uname'][$userid] = $uname;
        
        return $uname;
    }
    
    /**
     * Function to get userid from a certain username
     *
     * @param type $var description
     * @return type description
     */
    function getUidFromUname($username)
    {
        global $sysConfig, $myts, $db, $objCache;
        
        /*
        if ( $objCache->SysUser['uid'][$username] ) {
            return $objCache->SysUser['uid'][$username];
        }
        */
        $sql = "
            SELECT uid
                FROM ".$db->prefix('users')."
                WHERE uname = '$username'";
        if ( !$result = $db->query($sql) ) {
            return false;
        }
        if ( !$arr = $db->fetch_array($result) ) {
            return false;
        }
        /*
        $uname = $myts->makeTboxData4Show($arr['uid']);
        $objCache->SysUser['uid'][$username] = $uname;
        */
        return $arr['uid'];
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function incrementPost($uid)
    {
        global $db;

        $sql    = "
            UPDATE ".$db->prefix("users")."
                SET posts=posts+1
                WHERE uid=".$uid."";
        $result = $db->query($sql);
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function isOnline()
    {
        global $db, $objCache;

        if (isset($objCache->SysUser['isonline'][$this->getVar('uid')])) {
            return $objCache->SysUser['isonline'][$this->getVar('uid')];
        }
        $time = (time() - 300);
        $sql  = '
            SELECT COUNT(*)
                FROM '.$db->prefix('session').'
                WHERE uid='.$this->getVar('uid').' AND time > '.$time;
        if ( !$result = $db->query($sql) ) {
            $objCache->SysUser['isonline'][$this->getVar('uid')] = false;
            return false;
        }
        list($count) = $db->fetch_row($result);
        if ( $count > 0 ) {
            $objCache->SysUser['isonline'][$this->getVar('uid')] = true;
            return true;
        }
        $objCache->SysUser['isonline'][$this->getVar('uid')] = false;
        return false;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &getAllUsers($criteria=array(), $asobject=false, $orderby="uid ASC",
    $limit=0, $start=0, $bool='AND')
    {
        global $db;

        $ret = array();
        $where_query = "";

        if ( is_array($criteria) && count($criteria) > 0 ) {
            $where_query = " WHERE";
            foreach ( $criteria as $c ) {
                if ( $c != '' ) {
                    $where_query .= " $c $bool";
                }                }
                $where_query = substr($where_query, 0, -(strlen($bool) + 1) );
        }
        $sql = "
            SELECT *
                FROM ".$db->prefix("users")."
                $where_query
                ORDER BY $orderby";
        $result = $db->query($sql, $limit, $start);
        if ( !$asobject ) {
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = $myrow['uid'];
            }
            if ( $limit = 1 ) {
                $ret = $ret[0];
            }
        } else {
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = new SysUser($myrow);
            }
        }
        return $ret;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &getAllUsersList($criteria=array(), $orderby="uid ASC", $limit=0, $start=0)
    {
        global $myts, $db;

        $ret = array();
        $where_query = "";
        if ( is_array($criteria) && count($criteria) > 0 ) {
            $where_query = " WHERE";
            foreach ( $criteria as $c ) {
                if ( $c != '' ) {
                    $where_query .= " $c AND";
                }
            }
            $where_query = substr($where_query, 0, -4);
        }
        $sql = "
            SELECT uid, uname
                FROM ".$db->prefix("users")."
                $where_query
                ORDER BY $orderby";
        $result = $db->query($sql,$limit,$start);
        while ( $myrow = $db->fetch_array($result) ) {
            $ret[$myrow['uid']] = $myts->makeTboxData4Show($myrow['uname']);
        }
        return $ret;
    }


    /**
     * Enter description here...
     *
     * @param array $criteria array of SQL WHERE phrases to be searched for
     * @return unknown
     */
    function countAllUsers($criteria=array())
    {
        global $db;

        $where_query = "";
        if ( is_array($criteria) && count($criteria) > 0 ) {
            $where_query = " WHERE";
            foreach ( $criteria as $c ) {
                if ( $c != '' ) {
                    $where_query .= " $c AND";
                }
            }
            $where_query = substr($where_query, 0, -4);
        }

        $sql = "
            SELECT COUNT(*)
                FROM ".$db->prefix("users")."
                $where_query";
        $result    = $db->query($sql);
        list( $return ) = @$db->fetch_row($result);
        return $return;
    }
    //---------------------------------------------------------------------------------------//

    //### Methods from here will be deprecated. Use getVar() instead! ###

    //---------------------------------------------------------------------------------------//
    function uid()
    {
        return $this->getVar("uid");
    }

    function name($format="S")
    {
        return $this->getVar("name", $format);
    }

    function uname($format="S")
    {
        return $this->getVar("uname", $format);
    }

    function email($format="S")
    {
        return $this->getVar("email", $format);
    }

    function url($format="S")
    {
        return $this->getVar("url", $format);
    }

    function user_avatar($format="S")
    {
        return $this->getVar("user_avatar");
    }

    function msg_mail($format="S")
    {
        return $this->getVar("msg_mail");
    }

    function user_regdate()
    {
        return $this->getVar("user_regdate");
    }

    function user_icq($format="S")
    {
        return $this->getVar("user_icq", $format);
    }

    function user_from($format="S")
    {
        return $this->getVar("user_from", $format);
    }

    function user_sig($format="S")
    {
        return $this->getVar("user_sig", $format);
    }

    function user_viewemail()
    {
        return $this->getVar("user_viewemail");
    }

    function actkey()
    {
        return $this->getVar("actkey");
    }

    function user_aim($format="S")
    {
        return $this->getVar("user_aim", $format);
    }

    function user_yim($format="S")
    {
        return $this->getVar("user_yim", $format);
    }

    function user_msnm($format="S")
    {
        return $this->getVar("user_msnm", $format);
    }

    function pass()
    {
        return $this->getVar("pass");
    }

    function posts()
    {
        return $this->getVar("posts");
    }

    function attachsig()
    {
        return $this->getVar("attachsig");
    }

    function level()
    {
        return $this->getVar("level");
    }

    function theme()
    {
        return $this->getVar("theme");
    }

    function timezone()
    {
        return $this->getVar("timezone_offset");
    }

    function umode()
    {
        return $this->getVar("umode");
    }

    function uorder()
    {
        return $this->getVar("uorder");
    }

    function user_occ($format="S")
    {
        return $this->getVar("user_occ", $format);
    }

    function bio($format="S")
    {
        return $this->getVar("bio", $format);
    }

    function user_interest($format="S")
    {
        return $this->getVar("user_interest", $format);
    }

    function last_login()
    {
        return $this->getVar("last_login");
    }
}
?>