<?php
/**
 * File: $Id: edituser.php,v 1.32 2005/09/06 09:53:36 greyhead Exp $
 *
 * Ciamos: Edits user information
 * Ciamos - Content Management System
 *
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 *
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author The Xoops Project (@link http://www.xoops.org)
 */

$sysOption['pagetype'] = 'user';
$sysOption['page_style'] = 8;

include_once('./mainfile.php');
include_once(SYS_ROOT_PATH.'/class/sysformloader.php');
$module_template -> setTemplate(THEME_TEMPLATE_PATH.'/system.edituser.html');

global $sysHandler, $sysOption, $sysUser, $sysSecurity;

/**
 * If not a user, redirect
 */
if ( !$sysUser ) {
    $sysHandler['security']->showSecurityERR("index.php",2,_NOPERM);
}

switch ( $sys_request['op'] ) {

    case 'saveuser':

    if ( $sysUser->getVar('uid') != $uid ) {
        $sysHandler['security']->showSecurityERR("index.php",3,_NOACTION);
    }

    $email = $myts->oopsStripSlashesGPC(trim($email));
    if ( !$email || $email == '' || !checkEmail($email) ) {
        onError(_INVALIDMAIL);
        exit();
    }

    if ( !empty($sysBadEmails) && hasMatch($sysBadEmails, $email) ) {
        onError(_US_EMAILRESERVED);
        exit();
    }

    if ( $user_avatar != ''
            && substr($user_avatar, 0, 6) == 'users/'
            && $myts->oopsStripSlashesGPC(trim($user_avatar))
                != avatarExists($sysUser->getVar("uid")) ) {
        $user_avatar = '';
    }

    if ( isset($upass) ) {
        $upass = trim($upass);
    }
    if ( isset($vpass) ) {
        $vpass = trim($vpass);
    }
    if ( isset($upass) && $upass != $vpass ) {
        onError(_US_PASSNOTSAME);
    } elseif ( $upass != '' && (strlen($upass) < $sysConfig['minpass']) ) {
        onError(sprintf(_US_PWDTOOSHORT, $sysConfig['minpass']));
    } else {
        $edituser = new SysUser($uid);

        $edituser->setVar('name', $name);
        $edituser->setVar('email', $email);
        $edituser->setVar('url', formatURL($url));
        $edituser->setVar('user_avatar', $user_avatar);
        $edituser->setVar('user_icq', $user_icq);
        $edituser->setVar('user_from', $user_from);
        $edituser->setVar('user_sig', $user_sig);
        $edituser->setVar('user_viewemail', $user_viewemail);
        $edituser->setVar('user_aim', $user_aim);
        $edituser->setVar('user_yim', $user_yim);
        $edituser->setVar('user_msnm', $user_msnm);
        if ( isset($upass) && $upass != '') {
            $edituser->setVar('pass', md5($upass));
        }
        $edituser->setVar('attachsig', $attachsig);
        $edituser->setVar('timezone_offset', $timezone_offset);
        if ( !empty($theme) && $sysConfig['allow_theme'] ) {
            $edituser->setVar('theme', $theme);
        }
        $edituser->setVar('uorder', $uorder);
        $edituser->setVar('umode', $umode);
        $edituser->setVar('bio', $bio);
        $edituser->setVar('user_occ', $user_occ);
        $edituser->setVar('user_interest', $user_interest);
        $edituser->setVar('user_mailok', $user_mailok);
        $edituser->setVar('msg_mail', $msg_mail);
        if ( $usecookie ) {
            cookie($sysConfig['cookie_name'], $sysUser->getVar("uname"), 31536000);
        } else {
            cookie($sysConfig['cookie_name']);
        }
        if ( !$edituser->store() ) {
            onError($edituser->getErrors());
        } else {
            redirectHeader("userinfo.php?uid=".$uid."",1,_US_PROFUPDATED);
        }
        exit();
    }
    break;

    case 'avatarform':

    if ( $sysConfig['avatar_allow_upload'] ) {
        $form_title = "<a href='userinfo.php?uid=".$sysUser->getVar("uid")."'>"
            ._PROFILE."</a>&nbsp;::&nbsp;". _US_UPLOADMYAVATAR;

        $form = new SysThemeForm($form_title, 'uploadavatar', 'edituser.php', 'avatarfile');
        $form_array = array();

        if ( $oldavatar = avatarExists($sysUser->getVar("uid")) ) {
            $form_array[] = new SysFormLabel(_US_OLDDELETED, "<img src='".SYS_ROOT_URL."/images/avatar/".$oldavatar."' />");
        }
        $form_array[] = new SysFormLabel(_US_MAXPIXEL, $sysConfig['avatar_width']." x ".$sysConfig['avatar_height']);
        $form_array[] = new SysFormLabel(_US_MAXIMGSZ, $sysConfig['avatar_maxsize']);
        $form_array[] = new SysFormFile(_US_SELFILE, 'avatarfile', $sysConfig['avatar_maxsize']);
        $form_array[] = new SysFormHidden('op', 'avatarupload');
        $form_array[] = new SysFormButtonTray();
        $form->setExtra("enctype='multipart/form-data'");

        /**
         * Write page
         */
        include_once('include/header.php');
        $form->display($form_array, true);
        include_once('include/footer.php');
    }
    break;

    case 'avatarupload':

    if ( $sysConfig['avatar_allow_upload'] ) {
        include_once(SYS_ROOT_PATH . '/class/fileupload.php');
        
        $upload = new fileupload();
        $upload->set_upload_dir(SYS_ROOT_PATH.'/images/avatar/users', 'avatarfile');
        $upload->set_basename($sysUser->uid(), 'avatarfile');
        $oldfileexists = SYS_ROOT_PATH.'/images/avatar/users/'.$sysUser->uid();
        @unlink($oldfileexists.'gif');
        @unlink($oldfileexists.'jpg');
        @unlink($oldfileexists.'png');
        $upload->set_accepted('gif|jpg|png', 'avatarfile');
        $upload->set_overwrite(2, 'avatarfile');
        $upload->set_max_image_height($sysConfig['avatar_height'], 'avatarfile');
        $upload->set_max_image_width($sysConfig['avatar_width']  , 'avatarfile');

        $result = $upload->upload();
        if ( $result['avatarfile']['filename'] ) {
            $sql = "
                UPDATE ".$db->prefix('users')."
                    SET user_avatar='".avatarExists($sysUser->getVar('uid'))."'
                    WHERE uid=".$sysUser->getVar("uid")."";
            $db->query($sql);
            redirectHeader('user.php', 0);
        } else {
            onError($upload->errors());
            exit();
        }
    }
    break;

    case 'editprofile':
    default:
    
    $form_title = "<a href='userinfo.php?uid=".$sysUser->getVar("uid")."'>". _PROFILE ."</a>&nbsp;::&nbsp;"._US_EDITPROFILE;

    $email_cbox_value = (boolean) $sysUser->user_viewemail();
    $avatar_array  =& SysLists::getImgListAsArray(SYS_ROOT_PATH.'/images/avatar/');
    $avatar_extra = "onchange='showImgSelected(\"avatar\", \"user_avatar\", \"images/avatar\")'";
    $sig_cbox_value   = (boolean) $sysUser->getVar("attachsig"); 
    $display_options = array("0"=>_NOCOMMENTS, "flat"=>_FLAT, "thread"=>_THREADED);
    $sort_options = array("0"=>_OLDESTFIRST, "1"=>_NEWESTFIRST);
    $cookie_radio_value = (boolean) $sys_request[$sysConfig['cookie_name']];
    
    $form_array = array();
    
    $form_array[] = new SysFormLabel(_NICKNAME, $sysUser->getVar("uname"));
    $form_array[] = new SysFormText(_REALNAME, "name", 30, 60, $sysUser->getVar("name", "E"));
        $email_array[] = new SysFormText('', 'email', 30, 60, $sysUser->getVar('email', 'E'));
        $email_array[] = new SysFormCheckBox('', 'user_viewemail', $email_cbox_value, array(1=>_US_ALLOWVIEWEMAIL));
    $form_array[] = new SysFormElementTray(_EMAIL, '<br />', $email_array);
    $form_array[] = new SysFormText(_US_WEBSITE, 'url', 30, 100, $sysUser->getVar('url', 'E'));
    /**
     * Build Avatar tray
     */ 
    $a_dirlist      =& SysLists::getDirListAsArray(SYS_ROOT_PATH.'/images/avatar/');
    $a_dir_labels   = array();
    $a_count        = 0;
    $a_dir_link     = "<a href=\"javascript:openWithSelfMain('".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=avatars&amp;start=".$a_count."','avatars',600,400);\">Ciamos</a>";
    $a_count        = $a_count + count($avatar_array);
    $a_dir_labels[] = new SysFormLabel('', $a_dir_link);

    foreach ( $a_dirlist as $a_dir ) {
        if ( $a_dir == 'users' ) {
            continue;
        }
        $avatars_array =& SysLists::getImgListAsArray(SYS_ROOT_PATH."/images/avatar/".$a_dir."/", $a_dir."/");
        $avatar_array = array_merge($avatar_array, $avatars_array);
        $a_dir_link     = "<a href=\"javascript:openWithSelfMain('".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=avatars&amp;subdir=".$a_dir."&amp;start=".$a_count."','avatars',600,400);\">".$a_dir."</a>";
        $a_dir_labels[] = new SysFormLabel("", $a_dir_link);
        $a_count        = $a_count + count($avatars_array);
    }

    if ( $sysConfig['avatar_allow_upload'] ) {
        $myavatar = avatarExists($sysUser->getVar("uid"));
        if ( $myavatar ) {
            $avatar_array = array_merge($avatar_array, array($myavatar=>US_MYAVATAR));
        }
    }
        $avatar_tray[] = new SysFormSelect('', 'user_avatar', $sysUser->getVar('user_avatar'), 1, false, $avatar_array, $avatar_extra);
        $avatar_tray[] = new SysFormLabel("", "<img src='images/avatar/".$sysUser->getVar("user_avatar", "E")."' name='avatar' id='avatar' alt='' />");
        $avatar_tray   = array_merge($avatar_tray, $a_dir_labels);
    $form_array[] = new SysFormElementTray(_AVATAR, "&nbsp;", $avatar_tray);
    
    if ( $sysConfig['allow_theme'] ) {
        $usertheme = $sysUser->getVar("theme");
        if ( empty($usertheme) ) {
            $usertheme = $sysConfig['default_theme'];
        }
        $form_array[] = new SysFormSelectTheme(_THEME, "theme", $usertheme);
    }
    $form_array[] = new SysFormSelectTimezone(_US_TIMEZONE, "timezone_offset", $sysUser->getVar("timezone_offset"));
    $form_array[] = new SysFormText(_ICQ, "user_icq", 30, 100, $sysUser->getVar("user_icq", "E"));
    $form_array[] = new SysFormText(_AIM, "user_aim", 30, 100, $sysUser->getVar("user_aim", "E"));
    $form_array[] = new SysFormText(_YIM, "user_yim", 30, 100, $sysUser->getVar("user_yim", "E"));
    $form_array[] = new SysFormText(_MSNM, "user_msnm", 30, 100, $sysUser->getVar("user_msnm", "E"));
    $form_array[] = new SysFormText(_LOCATION, "user_from", 30, 100, $sysUser->getVar("user_from", "E"));
    $form_array[] = new SysFormText(_OCCUPATION, "user_occ", 30, 100, $sysUser->getVar("user_occ", "E"));
    $form_array[] = new SysFormText(_INTEREST, "user_interest", 30, 100, $sysUser->getVar("user_interest", "E"));
        $sig_array[] = new SysFormDhtmlTextArea('', 'user_sig', $sysUser->getVar('user_sig', 'E'));
        $sig_array[] = new SysFormCheckBox("", "attachsig", $sig_cbox_value, array(1=>_US_SHOWSIG));
    $form_array[] = new SysFormElementTray(_SIGNATURE, '<br />', $sig_array);
    $form_array[] = new SysFormSelect(_US_CDISPLAYMODE, "umode", $sysUser->getVar("umode"), 1, false, $display_options);
    $form_array[] = new SysFormSelect(_US_CSORTORDER, "uorder", $sysUser->getVar("uorder"), 1, false, $sort_options);
    $form_array[] = new SysFormTextArea(_US_EXTRAINFO, "bio", $sysUser->getVar("bio", "E"));
    $form_array[] = new SysFormRadioYN(_US_USECOOKIE, "usecookie", $cookie_radio_value, _YES, _NO);
        $pwd_array[] = new SysFormPassword("", "upass");
        $pwd_array[] = new SysFormPassword("", "vpass");
    $form_array[] = new SysFormElementTray(_PASSWORD."<br />"._US_TYPEPASSTWICE, '<br />', $pwd_array);
    $form_array[] = new SysFormRadioYN(_US_MAILOK, 'user_mailok', $sysUser->getVar('user_mailok'));
    $form_array[] = new SysFormRadioYN(_US_MSGMAI, 'msg_mail', $sysUser->getVar('msg_mail'));
    $form_array[] = new SysFormHidden("uid", $sysUser->getVar("uid"));
    $form_array[] = new SysFormHidden("op", "saveuser");
    $form_array[] = new SysFormButtonTray();
    
    $form        = new SysThemeForm($form_title, "userinfo", "edituser.php", 'email');

    /**
     * Write page
     */
    include_once('include/header.php');
    $module_template -> setOutputVar('form_edituser', $form->display($form_array, true, false));
    include_once('include/footer.php');
    break;
}

/**
 * Displays a message on validation error
 *
 * @param string $message
 */
function onError($message) 
{
    include_once('include/header.php');
    openTable();
    echo $message;
    closeTable();
    include_once('include/footer.php');
}
?>
