<?php
/**
* Returns resized dimension values for a given image
* Copy this function if ya like, but dont use it ..will prolly be moved.
*
* Example:
* if ( $size = resizedImage("/images/image.gif", 50, "h") ) {
*     $size = " height='$size[h]' width='$size[w]'";
*     }
* echo "<img src='".SYS_ROOT_URL."/images/image.gif' border='0'$size>";
*
* @param string $image File or URL path to image in question
* @param integer $maxsize Maximum size of image
* @param string $orientation What $maxsize applies to: height or width
* @return array An array containing the height/width values
*/
function resizedImage($image, $maxsize=150, $orientation="w" )
{
if ( $maxsize == 0 || !is_numeric($maxsize) ) {
    $maxsize = 150;
}

if ( $orientation != "w" && $orientation != "h" ) {
    $orientation = "w";
}

$size = @getimagesize($image);
$return = false;
if ( is_numeric($size[0]) && is_numeric($size[1]) ) {
    $img['w'] = $size[0];
    $img['h'] = $size[1];

    switch($orientation) {
	case "w":
	if ( $img['w'] > $maxsize ) {
	    $img['h'] = round( ( $img['h'] / ($img['w'] / $maxsize) ) );
	    $img['w'] = $maxsize;
	}
	break;

	case "h":
	if ( $img['h'] > $maxsize ) {
	    $img['w'] = round( ( $img['w'] / ($img['h'] / $maxsize) ) );
	    $img['h'] = $maxsize;
	}
	break;
    }
    $return = $img;
}
return $return;
}

/**
 * Language Dependant Images
 */
$sysIconURL          = SYS_ROOT_URL."/themes/".$sysConfig['default_theme']."/images/icons/";
$sysImageLangURL      = SYS_ROOT_URL."/themes/".$sysConfig['default_theme']."/language/".$sysConfig['language']."/images/";
$sys_image['profile'] = $sysImageLangURL."profile.gif";
$sys_image['delete']  = $sysImageLangURL."delete.gif";
$sys_image['edit']    = $sysImageLangURL."edit.gif";
$sys_image['reply']   = $sysImageLangURL."reply.gif";
$sys_image['pm']      = $sysImageLangURL."pm.gif";
$sys_image['dload']   = $sysImageLangURL."downloads.gif";
$sys_image['links']   = $sysImageLangURL."links.gif";
$sys_image['sects']   = $sysImageLangURL."sections.gif";
$sys_image['gbook']   = $sysImageLangURL."gbook.gif";

/**
 * Global Images
 */
$sysimg['m_news']     = $sysIconURL."news.gif";
$sysimg['m_even']     = $sysIconURL."calendar.gif";
$sys_image['email']   = $sysIconURL."email.gif";
$sys_image['www']     = $sysIconURL."www.gif";
$sys_image['ip']      = $sysIconURL."ip.gif";
$sys_image['icq']     = $sysIconURL."icq_add.gif";
$sys_image['aim']     = $sysIconURL."aim.gif";
$sys_image['yim']     = $sysIconURL."yim.gif";
$sys_image['msnm']    = $sysIconURL."msnm.gif";
?>