<?php
/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function siteCache($option)
{
    global $sysOption, $sysConfig, $sysUser, $meta;

    $cache_time      = $sysConfig['cache_time'];
    $browser_pattern = 'mozilla\/[0-9]|netscape|opera|konqueror|msie [0-9]|iweng|ncsa mosaic|lynx';
    $r_uri           = _REQUEST_URI;
    $u_agent         = _HTTP_USER_AGENT;
    $r_method        = _REQUEST_METHOD;

    if ( !$sysOption['nocache']
            && !empty($cache_time)
            && empty($sysUser)
            && $r_method == 'GET'
            && !empty($r_uri)
            && preg_match("/($browser_pattern)/i", $u_agent) ) {

        $curr_time   = time();
        $path        = SYS_ROOT_PATH.'/cache/system/';

        $tmp_name    = preg_replace('/[^a-z0-9_-]/i', '', $r_uri);
        $cache_file  = $path.'.'.$tmp_name.'.cache';

        $last_cached = @filemtime($cache_file);
        if ( !$last_cached ) {
            $last_cached = 0;
        }

        $cached_size = @filesize($cache_file);
        if ( !$cached_size ) {
            $cached_size = 0;
        }

        if ( ($option == 'cache') && ( ($last_cached + $cache_time) < $curr_time) ) {
            $content = ob_get_contents();

            // Cleanup stale files that might have been generated by search engines, etc.
            if ( $handle = @opendir($path) ) {
                while ( false !== ($file = @readdir($handle)) ) {
                    if ( @is_file($path.$file) ) {
                        $timestamp = @filemtime($path.$file);
                        if ( (($timestamp+$cache_time) < $curr_time) ) {
                            @unlink($path.$file);
                        }
                    }
                }
                closedir($handle);
            } // END Cleanup

            if ( $fp = fopen($cache_file, 'w') ) {
                fwrite($fp, $content.'</body></html>');
                fclose($fp);
            }
        } elseif ( ($option == 'read')
                && (($last_cached+$cache_time) > $curr_time)
                && ($cached_size > 5120) ) {
            if ( !headers_sent() ) {
                header('Last-Modified: '.gmdate("D, d M Y H:i:s", $last_cached).' GMT');
                header("Cache-Control: max-age=$cache_time, s-maxage=$cache_time, proxy-revalidate, post-check=$cache_time, pre-check=$cache_time");
                if ( !empty($meta['p3p']) ) {
                    header("P3P: CP='".$meta['p3p']."'");
                }
            }
            readfile($cache_file);
            if ( !empty($sysConfig['debug_mode']) ) {
                debugInfo($sysConfig['debug_mode']);
            }
            if ( !headers_sent() ) {
                header('ETag: '.md5(ob_get_length()));
            }
            ob_end_flush();
            exit();
        }
    } elseif ( !headers_sent() ) {
        header('ETag: '.md5(uniqid(exSeedRand())));
        header('Expires: Sat, 18 Aug 2002 05:30:00 GMT');
        header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
        header('Cache-Control: no-store, no-cache, max-age=1, s-maxage=1, must-revalidate, post-check=0, pre-check=0');
    } // END CACHE
}
?>