<?php
/**
* Description
*
* @param type $var description
* @return type description
*/
function avatarExists($uid)
{
    global $sysConfig;

    // recommend not to change this
    $allowed_ext = array("gif", "jpeg", "jpg", "png");

    foreach( $allowed_ext as $ext ) {
        if ( @file_exists(SYS_ROOT_PATH."/images/avatar/users/".$uid.".".$ext ) ) {
            return "users/".$uid.".".$ext;
        }
    }

    return false;
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function checkEmail($email)
{
    $return = false;
    if ( !empty($email)
        && preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+([\.][a-z0-9-]+)+$/i", $email) ) {
        $return = true;
    }
    return $return;
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function checkIp($ip=0)
{
    global $sysBadIps;

    return hasMatch($sysBadIps, $ip);
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function cookie($name, $value='', $time=0, $path='/')
{
    $expire = gmdate("D, d-M-Y H:i:s", time()+$time);
    $time ? header("Set-Cookie: $name=$value; expires=$expire GMT; path=$path") : header("Set-Cookie: $name=$value; path=$path");
}

/**
 * Prints allowed html tags on this site
 */
function getAllowedHtml()
{
    global $sysUser, $sysModule, $sysConfig, $db;

    if ( $sysUser ) {
        $mid = $sysModule ? $sysModule->mid() : 0;
        $groupid = 2;
        if ( $sysUser->isAdmin($mid) ) {
            $groupid = 1;
        }
        $sql = "
                SELECT tags
                    FROM ".$db->prefix("groups")."
                    WHERE groupid = $groupid";
        $query = $db->query($sql);
        list($html) = $db->fetch_row($query);
        $allowed = str_replace("|", "> <", "<".$html.">");
        $allowed = htmlspecialchars($allowed);
    }
    return $allowed;
}


/**
 * @return string New password
 * @desc Creates a random password
*/
function makepass()
{
    $chars[1] = "bcdfghjklmnpqrstvwxyz";
    $chars[]  = "BCDFGHJKLMNPQRSTVWXYZ";
    $chars[]  = "aeiouAEIOU";
    $chars[]  = "23456789";
    exSeedRand();
    $makepass = '';
    for ( $i = 0; $i < 8; $i++ ) {
        $usechars = $chars[mt_rand(1, 4)];
        $makepass .= substr($usechars, mt_rand(0, strlen($usechars)-1), 1);
    }
    return $makepass;
}

/**
 * Function to calculate server timestamp from user entered time (timestamp)
 */
function userTimeToServerTime($timestamp, $userTZ=NULL)
{
    global $sysConfig;

    if ( !isset($userTZ) ) {
        $userTZ = $sysConfig['default_TZ'];
    }
    $offset    = $userTZ - $sysConfig['server_TZ'];
    $timestamp = $timestamp - ($offset * 3600);
    return $timestamp;
}
?>