<?php
/**
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */
if ( !defined('CIAMOS_MAINFILE_INCLUDED') ) {
	header("Location: index.php");
	exit();
}
/**
 * Enter description here...
 *
 */
function addDownload()
{
    global $db, $downloadsConfig, $eh, $modversion, $myts, $mytree, $sysHandler, $sys_request, $sysConfig, $sysModule, $sysUser;

    sysCpHeader();
    $numrows = count($mytree->id_cache);

    if ( $numrows <= 0 ) {
        openTable();
        printf(_DL_NOTOPIC, "<a href='".SYS_MOD_URL."/system/admin.php?fct=topics'>");
        closeTable();
        sysCpFooter();
        return;
    }

    /**
    * If there is a valid topic, show page
    */
    if ( $numrows > 0 ) {

        // List downloads waiting for validation
        $sql2 = "
            SELECT
                    lid,
                    cid,
                    title,
                    description,
                    url,
                    homepage,
                    version,
                    size,
                    platform,
                    logourl,
                    submitter
                FROM ".$db->prefix($modversion['tables'][1])."
                WHERE status = 0
                ORDER BY date DESC";
        $result2  = $db->query($sql2);
        $numrows2 = $db->num_rows($result2);

        if ( $numrows2 > 0 ) {
            openTable();
            echo "<h4>
            <a href='index.php'>"._MAIN."</a>: "._DL_DLSWAITING." ($numrows2)</h4>";
            while (list($lid, $cid, $title, $description, $url, $homepage, $version, $size, $platform, $logourl, $uid) = $db->fetch_row($result2)) {
                $title       = $myts->makeTboxData4Edit($title);
                $url         = $myts->makeTboxData4Edit($url);
                $homepage    = $myts->makeTboxData4Edit($homepage);
                $version     = $myts->makeTboxData4Edit($version);
                $size        = $myts->makeTboxData4Edit($size);
                $platform    = $myts->makeTboxData4Edit($platform);
                $description = $myts->makeTboxData4Edit($description);
                if ( $uid != 0 ) {
                    $submitter = SysUser::getUnameFromId($uid);
                    $submitter = $myts->makeTboxData4Show($submitter);
                } else {
                    $submitter = $myts->makeTboxData4Show($sysConfig['anonymous']);
                }

                $form          = new SysThemeForm("", "approve", "index.php?op=approve");

                $form_array = array();

                $form_array[] = new SysFormLabel(_DL_SUBMITTER, "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$uid."'>".$submitter);
                $form_array[] = new SysFormText(_DL_FILETITLE, "title", 50, 100, $title);
                $form_array[] = new SysFormText(_DL_DLURL, "url", 50, 255, $url, "[ <a href='".formatURL(SYS_MOD_URL."/".$sysModule->dirname().'/cache/files/', $url)."' target='_blank'>"._DOWNLOAD."</a> ]");
                $form_array[] = new SysFormLabel(_TOPIC, $mytree->makeMySelBox('title', $cid,'','cid','cid'));
                $form_array[] = new SysFormText(_URL, "homepage", 50, 255, $homepage, "[ <a href='$homepage' target='_blank'>".VISIT."</a> ]");
                $form_array[] = new SysFormText(_VERSION, "version", 10, 10, $version);
                $form_array[] = new SysFormText(_DL_FILESIZE, "size", 10, 8, $size);
                $form_array[] = new SysFormText(_DL_PLATFORM, "platform", 45, 50, $platform);
                $form_array[] = new SysFormDhtmlTextArea('', 'filedesc', $description, 10, 50);
                $form_array[] = new SysFormButtonTray(false, true, true, true,
                    "onClick='window.location=\"index.php\"'",
                    "onClick='window.location=\"index.php?op=delNewDownload&lid=$lid\"'");
                $form_array[] = new SysFormHidden("op", "approve");
                $form_array[] = new SysFormHidden("lid", $lid);

                $form->display($form_array);
            }
            closeTable();
        }

        /**
         *  Add Download
         */
        $form = new SysThemeForm(_DL_ADDNEWFILE, "add", "index.php?op=addDownloadS");

        $form_array = $url_array = $size_array = array();

        $form_array[] = new SysFormText(_DL_FILETITLE, "title", 50, 100);
            $url_array[] = new SysFormText("", "url", 50, 255);
            $url_array[] = new SysFormFile("", "download", $downloadsConfig['upload_limit']);
            $url_array[] = new SysFormLabel(sprintf(_DL_FILE, "/".SYS_MOD_FOLDER."/".$sysModule->dirname().'/cache/files/'));
        $form_array[] = new SysFormElementTray(_DL_DLURL, "<br />", $url_array);
        $form_array[] = new SysFormText(_DL_OPTURL, "url2", 50, 255);
        $form_array[] = new SysFormText(_DL_OPTURL, "url3", 50, 255);
        $form_array[] = new SysFormText(_DL_OPTURL, "url4", 50, 255);
        $form_array[] = new SysFormRadioYN(_DL_ALL_GUESTS_DL, "guestsdl", _YES, _YES, _NO);
        $form_array[] = new SysFormRadioYN(_DL_ALL_GUESTS_VOTE, "guestsvote", _YES, _YES, _NO);
        $form_array[] = new SysFormLabel(_TOPIC, $mytree->makeMySelBox('title', 'title','','cid','cid'));
        $form_array[] = new SysFormText(_URL, "homepage", 50, 255, "http://");
        $form_array[] = new SysFormText(_VERSION, "version", 10, 10);
            $size_array[] = new SysFormText("", "size", 10, 100);
            $size_array[] = new SysFormLabel(_BYTES);
        $form_array[] = new SysFormElementTray(_DL_FILESIZE, "&nbsp;", $size_array);
        $form_array[] = new SysFormText(_DL_PLATFORM, "platform", 45, 60);
        $form_array[] = new SysFormDhtmlTextArea(_DESCRIPTION, 'filedesc', '', 10, 50);
            $image_array[] = new SysFormText("", "logourl", 50, 255);
            $image_array[] = new SysFormFile("", "image", $downloadsConfig['upload_limit']);
            $image_array[] = new SysFormLabel(sprintf(_DL_SHOT, "/".SYS_MOD_FOLDER."/".$sysModule->dirname().'/cache/images/shots/'));
        $form_array[] = new SysFormElementTray(_DL_SHOTIMAGE, "<br />", $image_array);
        $form_array[] = new SysFormButtonTray('');

        openTable();
        $form->display($form_array);
        closeTable();
    }
    sysCpFooter();
}


/**
 * Enter description here...
 *
 */
function addDownloadS()
{
    global $db, $eh, $modversion, $myts, $sysHandler, $sys_request, $sysUser;

    $table2 = $db->prefix($modversion['tables'][1]);
    include('functions_rss.php');

    $homepage    = formatURL($myts->makeTboxData4Save($sys_request['homepage']));
    $url         = $myts->makeTboxData4Save($sys_request['url']);
    if ( empty($url) ) {
       $url      = $myts->makeTboxData4Save($sys_request['download']);
    }
    $url2        = $myts->makeTboxData4Save($sys_request['url2']);
    $url3        = $myts->makeTboxData4Save($sys_request['url3']);
    $url4        = $myts->makeTboxData4Save($sys_request['url4']);
    $logourl     = $myts->makeTboxData4Save($sys_request['logourl']);
    $title       = $myts->makeTboxData4Save($sys_request['title']);
    $version     = $myts->makeTboxData4Save($sys_request['version']);
    $size        = $myts->makeTboxData4Save($sys_request['size']);
    $platform    = $myts->makeTboxData4Save($sys_request['platform']);
    $description = $myts->makeTboxData4Save($sys_request['filedesc']);
    $guestsdl    = $myts->makeTboxData4Save($sys_request['guestsdl']);
    $guestsvote  = $myts->makeTboxData4Save($sys_request['guestsvote']);
    $submitter   = intval($sysUser->uid());
    $sql = "
        SELECT COUNT(*)
            FROM $table2
            WHERE url='$url'";
    $result        = $db->query($sql);
    list($numrows) = $db->fetch_row($result);

    // Check if Download exist
    if ( $numrows > 0 ) {
        redirectHeader('index.php?op=downloadsConfigMenu', 3, _DL_ERROREXIST);
        exit();
    }

    // Check if Title is empty
    if ( empty($title) ) {
        redirectHeader('index.php?op=downloadsConfigMenu', 3, _DL_ERRORTITLE);
        exit();
    }

    // Check if Description is empty
    if ( empty($description) ) {
        redirectHeader('index.php?op=downloadsConfigMenu', 3, _DL_ERRORDESC);
        exit();
    }

    if ( empty($size) || !is_numeric($size) ) {
        $size = 0;
    }

    if ( !empty($sys_request['cid']) ) {
        $cid = intval($sys_request['cid']);
    } else {
        $cid = 0;
    }

    if ( !empty($_FILES['download']['name']) ) {
        $upload = new fileupload();
        $upload->set_upload_dir('../cache/files/', 'download');
        $upload->set_overwrite(2);
        $result = $upload->upload();

        if ( $result['download'] ) {
            $url  = $result['download']['filename'];
            $size = $result['download']['size'];
        } else {
            redirectHeader('index.php?op=downloadsConfigMenu', 3, $upload->errors());
            exit();
        }
    }

    if ( !empty($_FILES['image']['name']) ) {
        $upload = new fileupload();

        $upload->set_upload_dir('../cache/shots/', 'image');
        $upload->set_overwrite(2);
        $result = $upload->upload();

        if ( $result['image'] ) {
            $logourl = $result['image']['filename'];
        } else {
             redirectHeader('index.php?op=downloadsConfigMenu', 3, $upload->errors());
             exit();
        }
    }
    // Check if URL is empty
    if ( empty($url) ) {
        redirectHeader('index.php?op=downloadsConfigMenu', 3, _DL_ERRORURL);
        exit();
    }

    $newid = $db->genId($table2.'_lid_seq');
    $sql = "
        INSERT
            INTO $table2
            SET lid=$newid,
                cid=$cid,
                title='$title',
                description='$description',
                url='$url',
                url2='$url2',
                url3='$url3',
                url4='$url4',
                homepage='$homepage',
                version='$version',
                size='$size',
                platform='$platform',
                logourl='$logourl',
                submitter=$submitter,
                status=1,
                date=".time().",
                hits=0,
                rating=0,
                votes=0,
                comments=0,
                guestsdl='$guestsdl',
                guestsvote='$guestsvote'";
    $db->query($sql) or $eh->show('0013');
    buildRss();
    redirectHeader('index.php', 1, _DL_NEWDLADDED);
    exit();
}
?>
