<?php
/**
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */
if ( !defined('CIAMOS_MAINFILE_INCLUDED') ) {
	header("Location: index.php");
	exit();
}
/**
 * Enter description here...
 *
 */
function configDownloadsAdmin()
{
    global $downloadsConfig, $myts, $sysHandler;
    $disclaimer = join('', file('../cache/disclaimer.php'));
    $dldisclaimer  = join('', file('../cache/dldisclaimer.php'));

    $option_array1 = array(10=>10, 15=>15, 20=>20, 25=>25, 30=>30, 50=>50);
    $option_array2 = array(10=>10, 20=>20, 50=>50, 100=>100, 500=>500, 1000=>1000);
    $option_array3 = array(5=>5, 10=>10, 15=>15, 20=>20, 25=>25, 30=>30);
    $option_array4 = array(50=>50, 100=>100, 150=>150, 200=>200, 250=>250, 300=>300);

    $form = new SysThemeForm("<a href='./index.php'>"._MAIN."</a> : "._GENERALCONFIG,
        "downloadsConfigChange", "index.php?op=downloadsConfigChange");

    $form_array = array();

    $form_array[] = new SysFormSelect(_DL_DLSPERPAGE, "perpage",
        $downloadsConfig['perpage'], 1, false, $option_array1);
    $form_array[] = new SysFormSelect(_DL_HITSPOP, "popular",
        $downloadsConfig['popular'], 1 , false, $option_array2);
    $form_array[] = new SysFormSelect(_DL_DLSNEW, "newdownloads",
        $downloadsConfig['newdownloads'], 1, false, $option_array1);
    $form_array[] = new SysFormRadioYN(_DL_USESHOTS, "useshots", $downloadsConfig['useshots']);
    $form_array[] = new SysFormText(_DL_IMGWIDTH, "shotwidth", 10, 10, $downloadsConfig['shotwidth']);
    $form_array[] = new SysFormRadioYN(_DL_ANON_ADD, "anon_add", $downloadsConfig['anon_add']);
    $form_array[] = new SysFormRadioYN(_DL_CHECK_EXTERNAL, "check_external", $downloadsConfig['check_external']);
    $form_array[] = new SysFormRadioYN(_DL_REPORTB, "brokenotify",  $downloadsConfig['brokenotify']);
    $form_array[] = new SysFormRadioYN(_DL_FILESUB, "filesub", $downloadsConfig['filesub']);
    $form_array[] = new SysFormText(_DL_NOSUBMI, ": no_sub", 30, 30, $downloadsConfig['no_sub']);
    $form_array[] = new SysFormRadioYN(_UPLOADENABLE, "allow_upload", $downloadsConfig['allow_upload']);
    $form_array[] = new SysFormText(_UPLOADACCEPTED, "accepted_files", 30, 9999, $downloadsConfig['accepted_files']);
    $form_array[] = new SysFormText(_UPLOADLIMIT, "upload_limit", 30, 30, $downloadsConfig['upload_limit'], _BYTES);
    $form_array[] = new SysFormRadioYN(_RSS_ENABLE, "rss_enable", $downloadsConfig['rss_enable']);
    $form_array[] = new SysFormSelect(_RSS_MAXITEMS, "rss_maxitems",
        $downloadsConfig['rss_maxitems'], 1, false, $option_array3);
    $form_array[] = new SysFormSelect(_RSS_MAXDESC, "rss_maxdescription",
        $downloadsConfig['rss_maxdescription'], 1, false, $option_array4);
    $form_array[] = new SysFormRadioYN(_DL_SUBDISC, "showdisc", $downloadsConfig['showdisc']);
    $form_array[] = new SysFormDhtmlTextArea(_DL_SUB_DISCLAIMER, 'disclaimer', $disclaimer, 10, 20);
    $form_array[] = new SysFormRadioYN(_DL_SHOWDISC, "dldisc", $downloadsConfig['dldisc']);
    $form_array[] = new SysFormDhtmlTextArea(_DL_DISCLAIMER, 'dldisclaimer', $dldisclaimer, 10, 20);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden("op", "downloadsConfigChange");

    /**
     * Write page
     */
    sysCpHeader();
    openTable();
    $form->display($form_array);
    closeTable();
    sysCpFooter();
}


/**
 * Save downloads configuration file
 *
 */
function changeDownloadsConfig()
{
    global $_SERVER, $myts, $sysHandler, $sys_request;


    $content  = "<?php\n";
    $content .= "\$downloadsConfig['popular']            = ".intval($sys_request['popular']).";\n";
    $content .= "\$downloadsConfig['newdownloads']       = ".intval($sys_request['newdownloads']).";\n";
    $content .= "\$downloadsConfig['perpage']            = ".intval($sys_request['perpage']).";\n";
    $content .= "\$downloadsConfig['useshots']           = ".intval($sys_request['useshots']).";\n";
    $content .= "\$downloadsConfig['shotwidth']          = ".intval($sys_request['shotwidth']).";\n";
    $content .= "\$downloadsConfig['anon_add']           = ".intval($sys_request['anon_add']).";\n";
    $content .= "\$downloadsConfig['check_external']     = ".intval($sys_request['check_external']).";\n";
    $content .= "\$downloadsConfig['brokenotify']        = ".intval($sys_request['brokenotify']).";\n";
    $content .= "\$downloadsConfig['rss_enable']         = ".intval($sys_request['rss_enable']).";\n";
    $content .= "\$downloadsConfig['rss_maxitems']       = ".intval($sys_request['rss_maxitems']).";\n";
    $content .= "\$downloadsConfig['rss_maxdescription'] = ".intval($sys_request['rss_maxdescription']).";\n";
    $content .= "\$downloadsConfig['allow_upload']       = ".intval($sys_request['allow_upload']).";\n";
    $content .= "\$downloadsConfig['accepted_files']     = '".$sys_request['accepted_files']."';\n";
    $content .= "\$downloadsConfig['upload_limit']       = ".intval($sys_request['upload_limit']).";\n";
    $content .= "\$downloadsConfig['no_sub']             = '".$sys_request['no_sub']."';\n";
    $content .= "\$downloadsConfig['filesub']            = ".intval($sys_request['filesub']).";\n";
    $content .= "\$downloadsConfig['showdisc']           = ".intval($sys_request['showdisc']).";\n";
    $content .= "\$downloadsConfig['dldisc']             = ".intval($sys_request['dldisc']).";\n";
    $content .= "?>";

    $filename = "../cache/config.php";
    if ( $file = fopen($filename, "w") ) {
        fwrite($file, $content);
        fclose($file);
    } else {
        redirectHeader("index.php", 1, _NOTUPDATED);
        exit();
    }

    $filename = "../cache/disclaimer.php";
    if ( $file = fopen($filename, "wb") ) {
        $disclaimer = $myts->oopsStripSlashesGPC($sys_request['disclaimer']);
        fwrite($file, $disclaimer);
        fclose($file);
    } else {
        redirectHeader("index.php", 1, _NOTUPDATED);
        exit();
    }

    $filename = "../cache/dldisclaimer.php";
    if ( $file = fopen($filename, "wb") ) {
        $dldisclaimer = $myts->oopsStripSlashesGPC($sys_request['dldisclaimer']);
        fwrite($file, $dldisclaimer);
        fclose($file);
    } else {
        redirectHeader("index.php", 1, _NOTUPDATED);
        exit();
    }
    redirectHeader("index.php", 1, _UPDATED);
    exit();
}
?>