<?php
/**
 * File: $Id: modfile.php,v 1.31 2005/05/31 22:31:46 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author: James Knickelbein <www.journeymilwaukee.com>
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */
include_once('include/header.php');

include_once(SYS_ROOT_PATH."/class/fileupload.php");
include_once(SYS_ROOT_PATH."/class/module.errorhandler.php");
include_once(SYS_ROOT_PATH."/class/sysform/formdhtmltextarea.php");
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

global $sysHandler;

$eh     = new ErrorHandler();
$mytree = new DataTree($sysModule->mid());

if ( !empty($sys_request['submit']) ) {
    if ( $sysUser ) {
        $modifysubmitter = $sysUser->uid();
    } else {
        $sysHandler['security']->showSecurityERR(SYS_ROOT_URL."/user.php", 2, _DL_MUSTREGFIRST);
        exit();
    }

    $lid         = intval($sys_request["lid"]);
    $cid         = intval($sys_request["cid"]);
    $homepage    = formatURL($myts->makeTboxData4Save($sys_request["homepage"]));
    $url         = $myts->makeTboxData4Save($sys_request["url"]);
    $title       = $myts->makeTboxData4Save($sys_request["title"]);
    $version     = $myts->makeTboxData4Save($sys_request["version"]);
    $platform    = $myts->makeTboxData4Save($sys_request["platform"]);
    $description = $myts->makeTboxData4Save($sys_request["filedesc"]);
    $size        = $sys_request["size"];

    /**
     * Check if Title exists
     */
    if ( empty($title) ) {
        $eh->show("1001");
    }

    /**
     * Check if Description exists
     */
    if ( empty($description) ) {
        $eh->show("1008");
    }

    if ( empty($size) || !is_numeric($size) ) {
        $size = 0;
    }

    if ( ($downloadsConfig['allow_upload'] == true)
            && !empty($_FILES['download']['name']) ) {
        $upload = new fileupload();
        $upload->set_upload_dir("./cache/files/", 'download');
        $upload->set_accepted($downloadsConfig['accepted_files'], 'download');
        $upload->set_overwrite(1, 'download');
        $result = $upload->upload();
        if ( $result['download']['filename'] ) {
            $url  = $result['download']['filename'];
            $size = $result['download']['size'];
        } else {
            redirectHeader("modfile.php?lid=$lid", 3, $upload->errors());
            exit();
        }
    }

    /**
     * Check if URL exists
     */
    if ( empty($url) ) {
        $eh->show("1016");
    }

    $newid = $db->genId($db->prefix($modversion['tables'][2])."_requestid_seq");
    $sql   = "
        INSERT
            INTO ".$db->prefix($modversion['tables'][2])."
            SET requestid=$newid,
                lid=$lid,
                cid=$cid,
                title='$title',
                url='$url',
                homepage='$homepage',
                version='$version',
                size='$size',
                platform='$platform',
                description='$description',
                modifysubmitter=$modifysubmitter";
    if ( !$db->query($sql) ) {
        $eh->show("0013");
    }
    redirectHeader("index.php", 2, _DL_THANKSFORINFO);
    exit();

} else {
    $lid = intval($sys_request['lid']);

    if ( !$sysUser ) {
         $sysHandler['security']->showSecurityERR(SYS_ROOT_URL."/user.php", 2, _DL_MUSTREGFIRST);
        exit();
    }

    include_once("include/header.php");
    $sql = "
        SELECT  cid,
                title,
                description,
                url,
                homepage,
                version,
                size,
                platform,
                submitter
            FROM ".$db->prefix($modversion['tables'][1])."
            WHERE lid = $lid AND status > 0";
    $result = $db->query($sql);
    list($cid, $title, $description, $url, $homepage, $version, $size,
        $platform, $submitter) = $db->fetch_row($result);
    $title       = $myts->makeTboxData4Edit($title);
    $url         = $myts->makeTboxData4Edit($url);
    $homepage    = $myts->makeTboxData4Edit($homepage);
    $version     = $myts->makeTboxData4Edit($version);
    $size        = $myts->makeTboxData4Edit($size);
    $platform    = $myts->makeTboxData4Edit($platform);
    $description = $myts->makeTboxData4Edit($description);

    $form = new SysThemeForm(_DL_REQUESTMOD, '', 'modfile.php');

    $form_array = $url_array = $tray_array = array();

    $form_array[] = new SysFormLabel(_DL_FILEID, $lid);
    $form_array[] = new SysFormText(_DL_FILETITLE, 'title', 50, 100, $title);
        $url_array[] = new SysFormText('', 'url', 50, 255, $url);
        if ( ( $sysUser->uid() == $submitter || $sysUser->isAdmin($sysModule->mid()) )
                && $downloadsConfig['allow_upload'] ) {
            $url_array[] = new SysFormFile('', 'download', $downloadsConfig['upload_limit']);
        }
    $form_array[] = new SysFormElementTray(_DL_DLURL, '&nbsp;', $url_array);
    $form_array[] = new SysFormLabel(_TOPIC, $mytree->makeMySelBox('title', $cid,'','cid','cid'));
    $form_array[] = new SysFormText(_URL, 'homepage', 50, 255, $homepage);
    $form_array[] = new SysFormText(_VERSION, 'version', 10, 10, $version);
        $tray_array[] = new SysFormText('', 'size', 10, 8, $size);
        $tray_array[] = new SysFormLabel('', _BYTES);
    $form_array[] = new SysFormElementTray(_DL_FILESIZE, '&nbsp;', $tray_array);
    $form_array[] = new SysFormText(_DL_PLATFORM, 'platform', 45, 50, $platform);
    $form_array[] = new SysFormDhtmlTextArea(_DESCRIPTION, 'filedesc', $description, 10, 50);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('lid', $lid);

    /**
     * Write page
     */
    $module_template->setSwitch('modfile', true);
    $module_template->setOutputVar('showModifyFile', $form->display($form_array, false, false));
}

include_once('include/footer.php');
?>
