<?php
/**
 * File: $Id: submit.php,v 1.35 2005/05/31 22:31:46 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author James Knickelbein (@link http://www.journeymilwaukee.com )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */
include_once('include/header.php');
include_once(SYS_ROOT_PATH."/class/fileupload.php");
include_once(SYS_ROOT_PATH."/class/module.errorhandler.php");
include_once(SYS_ROOT_PATH."/class/sysform/formdhtmltextarea.php");

global $downloadsConfig, $sys_request, $sysUser;

if ( !$downloadsConfig['filesub'] ) {
    redirectHeader(SYS_ROOT_URL."/index.php", 1, $downloadsConfig['no_sub']);
    exit();
}
if ( !$sysUser && $downloadsConfig['anon_add'] == false ) {
    redirectHeader(SYS_ROOT_URL."/user.php", 2, _DL_MUSTREGFIRST);
    exit();
}
$eh     = new ErrorHandler();
$mytree = new DataTree($sysModule->mid());
if ( !empty($sys_request['submit']) ) {

    /**
     * There is a file submission
     */
    $submitter = false;
    if ( empty($sys_request['submitter']) ) {
        if ( $sysUser ) {
            $submitter = $sysUser->uid();
        }
    } else {
        $submitter = $sys_request['submitter'];
    }
    $cid = false;
    if ( !empty($sys_request['cid']) ) {
        $cid = intval($sys_request['cid']);
    }
    $url         = formatURL($myts->makeTboxData4Save($sys_request['url']));
    $homepage    = formatURL($myts->makeTboxData4Save($sys_request['homepage']));
    $title       = $myts->makeTboxData4Save($sys_request['title']);
    $version     = $myts->makeTboxData4Save($sys_request['version']);
    $platform    = $myts->makeTboxData4Save($sys_request['platform']);
    $description = $myts->makeTboxData4Save($sys_request['filedesc']);
    $size        = $sys_request["size"];
    $date        = time();

    /**
     * Check if Title exists
     */
    if ( empty($title) ) {
        $eh->show("1001");
    }

    /**
     * Check if Description exist
     */
    if ( empty($description) ) {
        $eh->show("1008");
    }
    if ( empty($size) || !is_numeric($size) ) {
        $size = 0;
    }
    if ( ($downloadsConfig['allow_upload'] == true)
            && !empty($_FILES['download']['name']) ) {
        $upload = new fileupload();
        $upload->set_upload_dir('./cache/files/', 'download');
        $upload->set_accepted($downloadsConfig['accepted_files'], 'download');
        $upload->set_overwrite(1, 'download');
        $result = $upload->upload();
        if ( $result['download']['filename'] ) {
            $url  = $result['download']['filename'];
            $size = $result['download']['size'];
        } else {
            redirectHeader('submit.php', 3, $upload->errors());
            exit();
        }
    }
    if ( empty($url) ) {
        $eh->show("1016");
    }
    $approve = false;
    $thanks = _DL_RECEIVED."<br />"._DL_WHENAPPROVED;
    if ( $downloadsConfig['autoapprove'] == true ) {
        $approve = true;
        $thanks = _THANKSUBMIT;
    }
    $newid = $db->genId($table[2]."_lid_seq");
    $sql   = "
        INSERT
            INTO $table[1]
            SET lid=$newid,
                cid=$cid,
                title='$title',
                description='$description',
                url='$url',
                homepage='$homepage',
                version='$version',
                size=$size,
                platform='$platform',
                submitter=$submitter,
                status=0,
                date=$date,
                hits=0,
                rating=0,
                votes=0";
    if ( !$db->query($sql) ) {
        $eh->show("0013");
    }
    redirectHeader("index.php", 2, _DL_RECEIVED."<br />"._DL_WHENAPPROVED."");
    exit();

} else {
    /**
     * Show file submission form
     */
    include_once(SYS_ROOT_PATH.'/class/xml-rss.php');
    include_once(SYS_ROOT_PATH.'/class/systree.php');
    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    include_once(SYS_ROOT_PATH."/class/syslists.php");
    include_once(SYS_ROOT_PATH.'/class/fileupload.php');
    include_once("include/header.php");

    $uid = 0;
    if ( $sysUser ) {
        $uid = $sysUser->uid();
    }
    if ( $downloadsConfig['showdisc'] == true ) {
        $disclaimer = join('', file("./cache/disclaimer.php"));
        $myts->setType('admin');
        echo $myts->makeTareaData4Show($disclaimer, 1, 1, 1)."<br />";
    }

    $form = new SysThemeForm(_DL_ADDNEWFILE, "submit", "submit.php?submit=1");

    $form_array  = array();
    $size_array  = array();
    $url_array   = array();
    $image_array = array();

    $form_array[] = new SysFormText(_DL_FILETITLE, "title", 50, 100);
        $url_array[] = new SysFormText("", "url", 50, 255);
    if ( $downloadsConfig['allow_upload'] ) {
        $url_array[] = new SysFormFile("", "download", $downloadsConfig['upload_limit']);
        $url_array[] = new SysFormLabel(sprintf(_DL_FILE, "/".SYS_MOD_FOLDER."/".$sysModule->dirname().'/cache/files/'));
    }
    $form_array[] = new SysFormElementTray(_DL_DLURL, "<br />", $url_array);
    $form_array[] = new SysFormLabel(_TOPIC, $mytree->makeMySelBox('title', 'title','','cid','cid'));
    $form_array[] = new SysFormText(_URL, "homepage", 50, 255, "http://");
    $form_array[] = new SysFormText(_VERSION, "version", 10, 10);
        $size_array[] = new SysFormText("", "size", 10, 100);
        $size_array[] = new SysFormLabel(_BYTES);
    $form_array[] = new SysFormElementTray(_DL_FILESIZE, "&nbsp;", $size_array);
    $form_array[] = new SysFormText(_DL_PLATFORM, "platform", 45, 60);
    $form_array[] = new SysFormDhtmlTextArea(_DESCRIPTION, 'filedesc', '', 10, 50);
        $image_array[] = new SysFormText("", "logourl", 50, 255);
        $image_array[] = new SysFormFile("", "image", $downloadsConfig['upload_limit']);
        $image_array[] = new SysFormLabel(sprintf(_DL_SHOT, "/".SYS_MOD_FOLDER."/".$sysModule->dirname().'/cache/images/shots/'));
    $form_array[] = new SysFormElementTray(_DL_SHOTIMAGE, "<br />", $image_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden("submitter", $uid);

    /**
     * Write page
     */
    $module_template->setSwitch('submit', true);
    $module_template->setOutputVar('showSubmit', $form->display($form_array, false, false));
}
include_once('include/footer.php');
?>