<?php
/**
 * File: $Id: viewtopic.php,v 1.3 2005/07/05 17:21:09 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author James Knickelbein (@link http://www.journeymilwaukee.com )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */
include_once('include/header.php');

global $sysModule, $sys_request, $downloadsConfig, $table, $sysHandler;

$mytree = new DataTree($sysModule->mid());
$cid    = intval($sys_request['cid']);

$module_template->setSwitch('viewTopic', true);

$desc    = $mytree->getTopicDescription($cid);
$thiscat = $mytree->getSingleItem($cid);
$imgurl  = $thiscat['topic_imgurl'];

if ( $desc ) {
    $module_template->setSwitch('showDesc', true);
    $myts->setType('admin');
    $desc = $myts->makeTareaData4Show($desc, 1, 1, 1);
    /**
     * This checks to see if an image is set for the subtopic
     * If there is, it shows the image
     */
    if ( !empty($imgurl) && $imgurl != "http://" ) {
        $imgurl_img = "<img src='".formatURL(SYS_MOD_URL.'/system/cache/topics/', $imgurl)."'
            border='0' alt='image' />";
        $module_template->setSwitch('showImgUrl', true);
        $module_template->setOutputVar('imgurl_img', $imgurl_img);
    }
    $module_template->setOutputVar('desc', $myts->makeTareaData4Show($desc, 1, 1, 1));
}
$show = $downloadsConfig['perpage'];
if ( $sys_request['show'] != "" ) {
    $show = intval($sys_request['show']);
}
$min = 0;
if ( isset($sys_request['min']) ) {
    $min = intval($sys_request['min']);
}
if ( !isset($max) ) {
    $max = $min + $show;
}
$orderby = "title ASC";

if ( isset($sys_request['orderby']) ) {
    $orderby = convertOrderByIn($sys_request['orderby']);
}

$waytoparents = $mytree->getAllParentsArray($cid);
$pathstring = "<a href='index.php'>"._ALL."</a>";
// Tell dlformat.php not to show pathstring
$pagepath = true;
foreach ( $waytoparents as $key => $cat ) {
    $bold = "normal";
    if ( $key+1 == count($waytoparents) ) {
        $bold = "bold";
    }
    $pathstring .= "&nbsp;::&nbsp;<a style='font-weight:$bold;' href='viewtopic.php?cid=".$cat['topic_id']."'>".$cat['topic_title']."</a>";
}

$module_template->setOutputVar('pathstring', $pathstring);
/**
 *  get child topic objects
 */
$arr = array();
$arr = $mytree->getFirstChild($cid, "topic_title");

if ( count($arr) > 0 ) {
    $module_template->setSwitch('showTopics', true);

    $scount = 0;
    foreach ( $arr as $ele ) {
        $title = $myts->makeTboxData4Show($ele['topic_title']);
        $totaldownload = getTotalItems($ele['topic_id'], 1);
        $imgurl = $ele['topic_imgurl'];
        if ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.'.$imgurl) ) {
            $imgurl = SYS_MOD_URL.'/system/cache/topics/'.$mid.'.'.$imgurl;
        } elseif ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$imgurl) ) {
            $imgurl = SYS_MOD_URL.'/system/cache/topics/'.$imgurl;
        }
        $imgurl_img = "<img src='".$imgurl."' />";
        $topic_link = "<a href='viewtopic.php?cid=".$ele['topic_id']."'>$title</a>";
       
        $scount++;
        $newrow = "";
        if ( $scount == 4 ) {
            $module_template->setSwitch('newRow', true);
            $scount = 0;
        }
        $module_template->setOutputVarArray('topic_loop', 'imgurl_img', $imgurl_img);
        $module_template->setOutputVarArray('topic_loop', 'topic_link', $topic_link);
        $module_template->setOutputVarArray('topic_loop', 'totaldownload', $totaldownload);
    }
}
$sql = "
    SELECT COUNT(*)
        FROM $table[1]
        WHERE cid=$cid AND status>0";
$fullcountresult=$db->query($sql);
list($numrows) = $db->fetch_row($fullcountresult);

if ( $numrows > 0 ) {

    /**
     * if 2 or more items in result, show the sort menu
     */
    if ( $numrows > 1 ) {
        $module_template->setSwitch('showSortBy', true);
        $orderbyTrans = convertOrderByTrans($orderby);
        $cursortby = sprintf(_DL_CURSORTBY, $orderbyTrans);

        $module_template->setOutputVar('title_sort', showSort('title', $cid));
        $module_template->setOutputVar('date_sort', showSort('date', $cid));
        $module_template->setOutputVar('rating_sort', showSort('rating', $cid));
        $module_template->setOutputVar('hits_sort', showSort('hits', $cid));
        $module_template->setOutputVar('cursortby', $cursortby);
    }

    $sql = "
        SELECT
                lid,
                title,
                url,
                homepage,
                version,
                size,
                platform,
                logourl,
                status,
                date,
                hits,
                rating,
                votes,
                comments,
                description
            FROM $table[1]
            WHERE cid = $cid AND status > 0
            ORDER BY $orderby";

    $result = $db->query($sql, $show, $min);
    while (list($lid, $dtitle, $url, $homepage, $version, $size, $platform, $logourl, $status, $time, $hits, $rating, $votes, $comments, $description)=$db->fetch_row($result)) {
        include("include/dlformat.php");
    }

    $orderby = convertOrderByOut($orderby);
    /**
     * Calculates how many pages exist.  Which page one should be on, etc...
     */
    $downloadpages = ceil($numrows / $show);
    /**
     *Page Numbering
     */
    if ( $downloadpages != 1 && $downloadpages != 0 ) {
        $prev = $min - $show;
        $navbar = "";
        if ( $prev >= 0 ) {
            $navbar .= "
            &nbsp;<a href='viewtopic.php?cid=$cid&min=$prev&orderby=$orderby&show=$show'>
            <b>&lt; "._PREVIOUS." ]</b></a>&nbsp;";
        }
        $counter = 1;
        $currentpage = ($max / $show);
        while ( $counter <= $linkpages ) {
            $mintemp = (($show * $counter) - $show);
            if ( $counter == $currentpage ) {
                $navbar .= "<b>$counter</b>&nbsp;";
            } else {
                $navbar .= "<a href='viewtopic.php?cid=$cid&min=$mintemp&orderby=$orderby&show=$show'>$counter</a>&nbsp;";
            }
            $counter++;
        }

        if ( $numrows>$max ) {
            $navbar .= "
        &nbsp;<a href='viewtopic.php?cid=$cid&min=$max&orderby=$orderby&show=$show'>
        <b>[ "._NEXT." &gt;</b></a>";
        }
        $module_template->setSwitch('showNavbar', true);
        $module_template->setOutputVar('navbar', $navbar);
    }
}

include_once('include/footer.php');

/**
 * Creates a pair of up and down arrow links
 *
 * @param string $sortby the required sort link
 * @param integer $cid the topic id
 * @return string a pair of html image links
 */
function showSort($sortby, $cid) 
{
    return "<a href='viewtopic.php?cid=$cid&orderby=".$sortby."A'>
                <img src='images/up.gif' border='0' align='middle' alt='' />
            </a>
            <a href='viewtopic.php?cid=$cid&orderby=".$sortby."D'>
                <img src='images/down.gif' border='0' align='middle' alt='' />
            </a>";   
} 
?>
