<?php
/**
 * File: $Id: canaccess.inc.php,v 1.9 2005/04/01 14:50:01 vi0lat0r Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @desc This included snippet decides if the user is authorised to access a forum
 *
 * Based on phpBB (@link http://www.phpBB.com )
 *
 * @license GPL
 *
 */

$canpost = false;

/**
 * Forum type = 1 private, 0 public
 */
if ( $forumdata['forum_type'] == 1 ) {
    /**
     * This is an private forum and only an admin or authorised user can access
     */
    if ( $sysUser
            && ( $sysUser->isAdmin($sysModule->mid() )
            || checkPrivForumAuth($sysUser->uid(), $forum, true)) ) {
        $canpost = true;
    }
} else {
    /**
     * This is a public forum. Switch on Forum access :
     * 1 registered users only; 2 open; 3 moderators and admins only
     */
    switch ( $forumdata['forum_access'] ) {
        case 1:
            if ( $sysUser ) {
                $canpost = true;
            }
            break;
            
        case 2:
            $canpost = true;
            break;
            
        case 3:
            if ( $sysUser
                    && ( $sysUser->isAdmin($sysModule->mid())
                    || isModerator($forum, $sysUser->uid())) ) {
                $canpost = true;
            }
            break;
    }
}

if ( !$canpost ) {
    $sysHandler['security']->showSecurityERR("viewthread.php?thread_id=$thread_id&post_id=$post_id&order=$order&viewmode=$viewmode&pid=$pid&forum=$forum",2,_BB_NORIGHTTOPOST);
    exit();
}

?>