<?php
/**
 * File: $Id: index.php,v 1.39 2005/07/08 16:39:46 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * Based on phpBB (@link http://www.phpBB.com )
 *
 * @license GPL
 *
 */

include_once("include/header.php");

$module_template->setSwitch('showIndex', true);

/**
 * Get an array of Topics which are valid for the Forum module
 * (includes all valid topics & subtopics)
 */
$mytree = new DataTree($sysModule->mid());
$topics_array = $mytree->getChildTreeArray();
$total_topics = count($topics_array);

// $module_template->setOutputVar('bb_width',  $bbwidth);
$module_template->setOutputVar('site_name',     sprintf(_BB_WELCOME, $meta['title']));
$module_template->setOutputVar('total_threads', getTotalThreads());
$module_template->setOutputVar('total_posts',   getTotalPosts('0', 'all'));
$module_template->setOutputVar('now',           sprintf(_BB_TIMENOW, formatTimestamp(time(), "m")));
$module_template->setOutputVar('last_visit',    sprintf(_BB_LASTVISIT, formatTimestamp($last_visit, "m")));

// @todo clean up topics array items
/**
 * If there are valid topics for Forums
 */
if ( !$total_topics ) {
    // Show "There are no valid topics for the forums module"
} else {
    // $viewtopic is the current 'head topic', false => there is no topic selected.
    if ( !$viewtopic ) {
        $viewtopic = false;
    }
    $sql = "
        SELECT f.*, u.uname, u.uid, p.thread_id, p.post_time, p.subject, p.icon
            FROM ".$db->prefix('bb_forums')." f
            LEFT JOIN ".$db->prefix('bb_posts')." p
                ON p.post_id = f.forum_last_post_id
            LEFT JOIN ".$db->prefix('users')." u
                ON u.uid = p.uid
            ORDER BY f.topic_id, f.forum_name";

    if ( !$result = $db->query($sql) ) {
        die(_ERROR."<br />$sql");
    }
    /**
     * Transfer forum data to array:
     *  [forum_id] => n 
     *  [forum_name] => New Forum 
     *  [forum_desc] => Another new forum 
     *  [forum_access] => n 
     *  [forum_threads] => n 
     *  [forum_posts] => n 
     *  [forum_last_post_id] =>n 
     *  [topic_id] => n 
     *  [forum_type] => n 
     *  [allow_html] => bool 
     *  [allow_sig] => bool 
     *  [posts_per_page] => n 
     *  [hot_threshold] => n 
     *  [threads_per_page] => n 
     *  Last Post:
     *   [uname] => string 
     *   [uid] => n 
     *   [thread_id] => n 
     *   [post_time] => date-time 
     *   [subject] => string
     *   [icon] => n
     */
     
    while ( $forum_data = $db->fetch_array($result) ) {
        $forum_row[] = $forum_data;
    }
    /**
     * Step through Topics (showing Topic Title & ID)
     */
    $t = 0;
    $show_forums = "";
    // Start loop A - step through all topics for forum module
    foreach ( $topics_array as $topic) {
        $show_topic_header = false;
        
        /**
         * Get topic data:
         *  [topic_id] => n 
         *  [topic_pid] => n 
         *  [topic_imgurl] => string
         *  [topic_title] => string 
         *  [topic_admins] => n|n 
         *  [topic_viewer] => n|n 
         *  [topic_modules] => n|n|n|n
         *  [prefix] => . 
         *  [level] => n
         */
        $title = $myts->makeTboxData4Show($topic['topic_title']);
        foreach ( $forum_row as $forum ) {
            $forum_row = array();
            if ( $forum['topic_id'] == $topic['topic_id'] ) {
                /**
                 * Show topic header (once only)
                 */
                if ( !$show_topic_header ) {
                    $topic_title = "";
                    foreach ( $mytree->getAllParentsArray($topic['topic_id']) as $t ) {
                        $topic_title .= $t['topic_title']."&nbsp;:&nbsp;"; 
                    }
                    $topic_title = substr($topic_title, 0, -13);
                    $show_forums .= "
                    <tr align='left'>
                        <td colspan='6' class='$bg3'>
                            <a href='./index.php?viewtopic=".$topic['topic_id']."'>
                                <b>$topic_title</b>
                            </a>
                        </td>
                    </tr>";
                    $show_topic_header = true;
                }
                /**
                 * Display forum info
                 *//*
                    if ( ( $forum['forum_id'] != $loopedthreads[$x] ) 
                            && ( $viewsubtopics == 0) ) {
                            */
                        if ( $forum['post_time'] ) {
                            $forum['subject'] = $myts->makeTboxData4Show($forum['subject']);
                            $last_post  = formatTimestamp($forum['post_time'], "m") . "<br />";
                            $last_post .= "<a href='".SYS_MOD_URL."/".$sysModule->dirname()."/viewthread.php?post_id=".$forum['forum_last_post_id']."&amp;thread_id=".$forum['thread_id']."&amp;forum=".$forum['forum_id']."#".$forum['forum_last_post_id']."'>";
                            if ( $forum['icon'] ) {
                                $last_post .= "<img src='".SYS_ROOT_URL."/images/subject/".$forum['icon']."' border='0' alt='' />";
                            } else {
                                $last_post .= "<img src='".SYS_ROOT_URL."/images/subject/icon1.gif' border='0' alt='' />";
                            }
                            $last_post .= "</a><br />"._BY2."&nbsp;";
                            if ( $forum['uid'] != 0 && $forum['uname'] ) {
                                $last_post .= "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$forum['uid']."'>" . $myts->makeTboxData4Show($forum['uname'])."</a>";
                            } else {
                                $last_post .= $sysConfig['anonymous'];
                            }
                        }
                        $last_post_datetime = $forum['post_time'];
                        if ( empty($last_post) ) {
                            $last_post = _BB_NOPOSTS;
                        }
                        $show_forums .= "<tr align='left'>";
                           if ( ( ($last_post_datetime > $last_visit) && ($last_post != _BB_NOPOSTS) )
                                && isset($sys_request['bbthread_time'][$forum['thread_id']]) ) {
                            $show_forums .= "<td class='bg3' align='center' width='5%'>
                                <img src='".$bbImage['newposts']."' alt='' />
                              </td>";
                        } else {
                            $show_forums .= "<td class='bg3' align='center' width='5%'>
                                <img src='".$bbImage['folder']."' alt='' />
                              </td>";
                        }
                        $name         = $myts->makeTboxData4Show($forum['forum_name']);
                        $total_posts  = $forum["forum_posts"];
                        $total_threads = $forum["forum_threads"];
                        $myts->setType('admin');
                        $desc         = $myts->makeTareaData4Show($forum['forum_desc'], 1, 1, 1);
                        $forum_link   = SYS_MOD_URL."/".$sysModule->dirname()."/viewforum.php?forum=".$forum["forum_id"];
                        /* Allow edit from System Admin only 
                        if ( $sysUser && $sysUser->isAdmin($sysModule->mid()) ) {
                            $admin_link = "<a href='admin/admin_forums.php?mode=editforum&forum=".$forum["forum_id"]."'><img src='".$bbImage['editicon']."' alt='"._EDIT."' border='0' /></a>";
                        }
                        */
                        $show_forums .= "
                            <td class='bg1' onmouseover='this.className=\"bg3\"; this.style.cursor=\"hand\";' onmouseout='this.className=\"bg1\";' onclick='window.location.href=\"$forum_link\";'>
                            $admin_link <a href='$forum_link'><b>$name</b></a>
                            <br />$desc</td>
                            <td class='bg3' width='5%'  align='center'>$total_threads</td>
                            <td class='bg1' width='5%'  align='center'>$total_posts</td>
                            <td class='bg3' width='15%' align='center' onmouseover='this.className=\"bg1\";' onmouseout='this.className=\"bg3\";'>$last_post</td>
                            <td class='bg1' width='5%'  align='center' onmouseover='this.className=\"bg3\";' onmouseout='this.className=\"bg1\";'>";
                        $show_forums .= listModerators($forum['forum_id']);
                        $show_forums .= "</td></tr>";
                    //}
                    //$loopedthreads[$x] = $forum_row[$x]['forum_id'];
                    //

            } else {
                $forum_row[] = $forum;
            }

        }


      

        //Commented because shows Topic_title twice

        /*if($viewtopic==-1) {
            if( ($forum_row[$t]["forum_id"]>0) && ($topic['topic_pid']==0) ) {
            echo "
                <tr align='left'>
                    <td colspan='6' class='bg4'>
                        <a href='./index.php?viewtopic=".$topic['topic_id']."'>
                            <b>$title</b>
                        </a>
                    </td>
                </tr>";
            }
        }*/
        
        // cumulate title with level
        // are there any forums for this topic & this user?
        // if yes, or level 'top' show title
        // if yes, show forums
        // next topic
        
        /*
        // Old code
        $get_toptopic  = $mytree->getSingleItem($topic['topic_id']);
        $get_realtopic = $mytree->getAllChildId($topic['topic_id']);

        // Start loop B - step through all child topics
        for ( $rt = 0; !empty($get_realtopic[$rt]); $rt++ ) {
            $realtopic = $mytree->getSingleItem($get_realtopic[$rt]);
            // Start loop C - step through forums
            for ( $x = 0; $x < $size; $x++ ) {
                if ( $old_subtopic != $forum_row[$x]['topic_id'] ) {
                    if ( $forum_row[$x]['topic_id'] == $realtopic['topic_id'] ) {
                        if ( $realtopic["topic_id"] ) {
                            if ( ( $viewtopic == -1 ) 
                                    || ( $viewtopic == $topic['topic_id'] ) 
                                    || ( ($viewtopic != -1 ) && ( $realtopic['topic_id'] == $viewtopic) ) ) {
                                if ( $viewtopic == $realtopic['topic_id'] ) {
                                    $bgclass='bg4';
                                } else {
                                    $bgclass='bg3';
                                }
                                $show_forums .= "
                                <tr align='left'>
                                    <td colspan='6' class='".$bgclass."'>
                                        <a href='./index.php?viewtopic=".$realtopic['topic_id']."'>
                                            <b>".$realtopic['topic_title']."</b>
                                        </a>
                                    </td>
                                </tr>";
                                $module_template->setOutputVar('topic_title_row', $topic_title_row);
                                $notsub = false;
                                $old_subtopic = $forum_row[$x]['topic_id'];
                            } elseif ( !$viewtopic ) {
                                $notsub = false;
                            } else {
                                $notsub = true;
                            }
                        }
                    }
                }
                unset($last_post);
                
                if ( ( ( $forum_row[$x]['topic_id'] == $topic['topic_id'] ) 
                        || ($forum_row[$x]['topic_id'] == $realtopic['topic_id']) ) 
                        && ( $notsub == 0 ) ) {
                    if ( $forum_row[$x]['forum_type'] == 1 ) {
                        if ( !$sysUser ) {
                            continue;
                        } elseif ( !$sysUser->isAdmin($sysModule->mid())
                                && !checkPrivForumAuth($sysUser->uid(), $forum_row[$x]['forum_id'], 0) ) {
                            continue;
                        }
                    }
                    if ( $viewtopic != -1 ) {
                        if ( $forum_row[$x]['topic_id'] == $viewtopic ) {
                            $viewsubtopics = 0;
                        } else {
                            $viewsubtopics = 1;
                        }
                    } else {
                        $viewsubtopics = 0;
                    }
                    if ( ( $forum_row[$x]['forum_id'] != $loopedthreads[$x] ) 
                            && ($viewsubtopics==0) ) {
// :: moved to new code : //
                            
                            }
                    $loopedthreads[$x] = $forum_row[$x]['forum_id'];
                }
            }
            // End loop C
                
        }
        

        $t++;

        // End Loop B
        // End old code
        */
    } 
    // End Loop A
    
    $module_template->setOutputVar('show_forums', $show_forums);
    /*
    if ($viewtopic == -1) {
        if( ( $forum_row[$t]["forum_id"] > 0) && ($topic['topic_pid'] == 0) ) {
            echo "
                <tr align='left'>
                <td colspan='6' class='bg4'>
                <a href='./index.php?viewtopic=".$topic['topic_id']."'>
                <b>$title</b>
                </a>
                </td>
                </tr>";
        }
    }
    */
    $get_toptopic     = $mytree->getSingleItem($topic['topic_id']);
    $get_realtopic[0] = $topic['topic_id'];
    $get_realtopic    = $mytree->getAllChildId($topic['topic_id'],'',$get_realtopic);

    for ( $rt = 0; !empty($get_realtopic[$rt]); $rt++ ) {
        $realtopic = $mytree->getSingleItem($get_realtopic[$rt]);

        for ( $x = 0; $x < $size; $x++ ) {
            if ( $old_subtopic != $forum_row[$x]['topic_id'] ) {
                if ( $forum_row[$x]['topic_id'] == $realtopic['topic_id'] ) {
                    if ( $realtopic["topic_id"] ) {
                        if( ( $viewtopic == -1 ) 
                                || ($viewtopic == $topic['topic_id']) 
                                || (($viewtopic != -1) && ($realtopic['topic_id'] == $viewtopic)) ) {
                            if ( $viewtopic == $realtopic['topic_id'] ) {
                                $bgclass='bg4';
                            } else {
                                $bgclass='bg3';
                            }
                            echo "<table>
                                <tr align='left'>
                                    <td colspan='6' class='".$bgclass."'>
                                        <a href='./index.php?viewtopic=".$realtopic['topic_id']."'>
                                            <b>".$realtopic['topic_title']."</b>
                                        </a>
                                    </td>
                                </tr>";
                            $notsub = false;
                            $old_subtopic=$forum_row[$x]['topic_id'];
                        } else
                        if ( $viewtopic == -1 ) {
                            $notsub = false;
                        } else {
                            $notsub = true;
                        }
                    }
                }
            }
            unset($last_post);
            if ( ( ($forum_row[$x]['topic_id'] == $topic['topic_id']) 
                    || ($forum_row[$x]['topic_id'] == $realtopic['topic_id'])) 
                    && ($notsub == false) ) {
                if ( $forum_row[$x]['forum_type'] == 1 ) {
                    if ( !$sysUser ) {
                        continue;
                    } elseif ( !$sysUser->isAdmin($sysModule->mid())
                            && !checkPrivForumAuth($sysUser->uid(), $forum_row[$x]['forum_id'], 0) ) {
                        continue;
                    }
                }
                if ( $viewtopic != -1 ) {
                    if ( $forum_row[$x]['topic_id'] == $viewtopic ) {
                        $viewsubtopics = false;
                    } else {
                        $viewsubtopics = true;
                    }
                } else {
                    $viewsubtopics = false;
                }
                if ( ($forum_row[$x]['forum_id'] != $loopedthreads[$x]) && ($viewsubtopics == 0) ) {
                    if ( $forum_row[$x]['post_time'] ) {
                        $forum_row[$x]['subject'] = $myts->makeTboxData4Show($forum_row[$x]['subject']);
                        $last_post  = formatTimestamp($forum_row[$x]['post_time'], "m") . "<br />";
                        $last_post .= "<a href='".SYS_MOD_URL."/".$sysModule->dirname()."/viewthread.php?post_id=".$forum_row[$x]['forum_last_post_id']."&amp;thread_id=".$forum_row[$x]['thread_id']."&amp;forum=".$forum_row[$x]['forum_id']."#".$forum_row[$x]['forum_last_post_id']."'>";
                        if ( $forum_row[$x]['icon'] ) {
                            $last_post .= "<img src='".SYS_ROOT_URL."/images/subject/".$forum_row[$x]['icon']."' border='0' alt='' />";
                        } else {
                            $last_post .= "<img src='".SYS_ROOT_URL."/images/subject/icon1.gif' border='0' alt='' />";
                        }
                        $last_post .= "</a><br />"._BY2."&nbsp;";
                        if ( $forum_row[$x]['uid'] != 0 && $forum_row[$x]['uname'] ) {
                            $last_post .= "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$forum_row[$x]['uid']."'>" . $myts->makeTboxData4Show($forum_row[$x]['uname'])."</a>";
                        } else {
                            $last_post .= $sysConfig['anonymous'];
                        }
                    }
                    $last_post_datetime = $forum_row[$x]['post_time'];
                    if ( empty($last_post) ) {
                        $last_post = _BB_NOPOSTS;
                    }
                    echo "<tr align='left'>";

                    if ( (($last_post_datetime > $last_visit) && ($last_post != _BB_NOPOSTS))
                    && !isset($sys_request['bbthread_time'][$forum_row[$x]['thread_id']]) ) {
                        echo "<td class='bg3' align='center' width='5%'>
                                <img src='".$bbImage['newposts']."' alt='' />
                              </td>";
                    } else {
                        echo "<td class='bg3' align='center' width='5%'>
                                <img src='".$bbImage['folder']."' alt='' />
                              </td>";
                    }
                    $name         = $myts->makeTboxData4Show($forum_row[$x]['forum_name']);
                    $total_posts  = $forum_row[$x]["forum_posts"];
                    $total_threads = $forum_row[$x]["forum_threads"];
                    $myts->setType('admin');
                    $desc         = $myts->makeTareaData4Show($forum_row[$x]['forum_desc'], 1, 1, 1);
                    $forum_link   = SYS_MOD_URL."/".$sysModule->dirname()."/viewforum.php?forum=".$forum_row[$x]["forum_id"];
                    if ( $sysUser && $sysUser->isAdmin($sysModule->mid()) ) {
                        $admin_link = "<a href='admin/admin_forums.php?mode=editforum&forum=".$forum_row[$x]["forum_id"]."'><img src='".$bbImage['editicon']."' alt='"._EDIT."' border='0' /></a>";
                    }
                    echo "
        <td class='bg1' onmouseover='this.className=\"bg3\"; this.style.cursor=\"hand\";' onmouseout='this.className=\"bg1\";' onclick='window.location.href=\"$forum_link\";'>
        $admin_link <a href='$forum_link'><b>$name</b></a>
        <br />$desc</td>
        <td class='bg3' width='5%' align='center'>$total_threads</td>
        <td class='bg1' width='5%' align='center'>$total_posts</td>
        <td class='bg3' width='15%' align='center' onmouseover='this.className=\"bg1\";' onmouseout='this.className=\"bg3\";'>$last_post</td>
        <td class='bg1' width='5%' align='center' onmouseover='this.className=\"bg3\";' onmouseout='this.className=\"bg1\";'>";
                    listModerators($forum_row[$x]['forum_id']);
                    echo "</td></tr>";
                }
                $loopedthreads[$x] = $forum_row[$x]['forum_id'];
            }
        }
    }
    $t++;
}
echo "      </table>
        </td>
    </tr>
</table>";



$newpost_img = "<img src='".$bbImage['newposts']."' alt='new posts' />";
$folder_img = "<img src='".$bbImage['folder']."' alt='no new posts' />";
$search_form = "<form name='search' action='search.php' method='post'>
    <input type='text' class='text' name='term'  size='20'>
    <input type='hidden' name='forum' value='all'>
    <input type='hidden' name='sortby' value='p.post_time desc'>
    <input type='hidden' name='searchboth' value='both'>
    <input type='hidden' name='submit' value='"._SEARCH."'></form>";
            
$advsearch_link = "<a href='$module_url/search.php'>"._BB_ADVSEARCH."</a>";

$module_template->setOutputVar('newpost_img', $newpost_img);
$module_template->setOutputVar('folder_img', $folder_img);
$module_template->setOutputVar('search_form', $search_form);
$module_template->setOutputVar('advsearch_link', $advsearch_link);

include_once("include/footer.php");
?>
