<?php
/**
 * File: $Id: viewthread.php,v 1.17 2005/07/08 16:39:47 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * Based on phpBB (@link http://www.phpBB.com )
 *
 * @license GPL
 *
 */

include_once("include/header.php");

$forum    = intval($forum);
$thread_id = intval($thread_id);

if ( empty($forum) ) {
    redirectHeader('index.php', 2, _BB_ERRORFORUM);
    exit();
} elseif ( empty($thread_id) ) {
    redirectHeader('viewforum.php?forum='.$forum.'', 2, _BB_ERRORTHREAD);
    exit();
}

include_once("class/class.forumposts.php");

$sql = "
    SELECT
           t.thread_title,
           t.thread_status,
           t.thread_sticky,
           f.forum_name,
           f.forum_access,
           f.forum_type,
           f.allow_html,
           f.allow_sig,
           f.posts_per_page,
           f.hot_threshold,
           f.threads_per_page
       FROM ".$db->prefix("bb_threads")." t
       LEFT JOIN ".$db->prefix("bb_forums")." f ON f.forum_id = t.forum_id
       WHERE t.thread_id = $thread_id AND t.forum_id = $forum";

if ( !$result = $db->query($sql) ) {
    $error = "<h4>"._BB_ERROROCCURED."</h4><hr />"._BB_COULDNOTQUERY;
    redirectHeader("index.php", 2, $error);
    exit();
}

if ( !$forumdata = $db->fetch_array($result) ) {
    redirectHeader("index.php", 2, _BB_FORUMNOEXIST);
    exit();
}

/**
 * Check forum access
 */
if ( $forumdata['forum_type'] == 1 ) {
    if ( $sysUser
            && ( $sysUser->isAdmin($sysModule->mid())
            || ( checkPrivForumAuth($sysUser->uid(), $forum, true)) ) ) {
        // continue
    } else {
        $sysHandler['security']->showSecurityERR("index.php", 2, _BB_NORIGHTTOACCESS);
        exit();
    }
}

/**
 * Check if user can post
 */
$canpost = false;
if ( $forumdata['forum_access'] == 2 ) {
    $canpost = true;
} elseif ( !$sysUser) {
    $canpost = false;
} elseif ( $forumdata['forum_access'] == 1 ) {
    $canpost = true;
} elseif ( $sysUser->isAdmin
        || isModerator($forum, $sysUser->getVar("uid")) ) {
    $canpost = true;
}

$total = getTotalPosts($thread_id, "thread");
if ( $total > $forumdata['posts_per_page'] ) {
    $times = 0;
    for ( $x = 0; $x < $total; $x += $forumdata['posts_per_page'] ) {
        $times++;
    }
    $pages = $times;
}

$forumdata['thread_title'] = $myts->makeTboxData4Show($forumdata['thread_title']);

cookie("bbthread_time[$thread_id]", time());

include_once(SYS_ROOT_PATH."/include/header.php");
$module_template->setSwitch('viewThread', true);

$forum_index = "<a href='".$bbUrl['root']."index.php'>
                <img src='".$bbImage['f_open']."' alt='/' />&nbsp;"._BB_FORUMINDEX."</a>";
$forum_name = "<a href='". $bbUrl['root']."viewforum.php?forum=$forum&amp;$total_forum'>
                <img src='".$bbImage['f_open']."' alt='/' />&nbsp;
                ".$myts->makeTboxData4Show($forumdata['forum_name'])."</a>";
$thread_title = "<img src='".$bbImage['f_content']."' alt='/' />&nbsp;
                <strong>".$forumdata['thread_title']."</strong>";

if ( $canpost ) {
    $forum_newthread = "      <input type='button' class='button' value='"._BB_POSTNEW."' onclick='location.href=\"newthread.php?forum=".$forum."\"' />";
} else {
    $forum_newthread = "      <a href='".SYS_ROOT_URL."/register.php'>"._BB_REGTOPOST."</a>";
}
$module_template->setOutputVar('forum_index', $forum_index);
$module_template->setOutputVar('forum_name', $forum_name);
$module_template->setOutputVar('thread_title', $thread_title);
$module_template->setOutputVar('forum_newthread', $forum_newthread);

$total_forum = getTotalPosts($forum, 'forum');

if ( $post_id ) {
    $forumpost = new ForumPosts($post_id);
} else {
    $forumpost = new ForumPosts();
}

if ( $sysUser ) {
    if ( !isset($order) ) {
        $order = $sysUser->getVar("uorder");
    }
    if ( !isset($viewmode) && $sysUser->getVar("umode") != "0" ) {
        $viewmode = $sysUser->getVar("umode");
    }
} else {
    if ( !isset($order) ) {
        $order = $sysConfig['com_order'];
    }
    if ( !isset($viewmode) && ($sysConfig['com_mode'] != "0") ) {
        $viewmode = $sysConfig['com_mode'];
    }
}

if ( $order) {
    $qorder = "post_time DESC";
} else {
    $qorder = "post_time ASC";
}
$forumpost->setOrder($qorder);

if ( !isset($post_id) || $post_id == "" ) {
    $pid=0;
    $forumpost->setThreadId($thread_id);
    $forumpost->setParent($pid);
}

if ( $viewmode == "thread" ) {
    $postsArray = $forumpost->getTopPosts();
} else {
    $viewmode = "flat";
    if ( isset($start) ) {
        $postsArray = $forumpost->getAllPosts($forumdata['posts_per_page'], $start);
    } else {
        $postsArray = $forumpost->getAllPosts($forumdata['posts_per_page']);
    }
}

include("include/navbar.php");

$adminview = false;
if ( $sysUser && ( $sysUser->isAdmin($sysModule->mid())
            || isModerator($forum, $sysUser->uid()) ) ) {
    $adminview = true;
}

if ( $viewmode == "flat" ) {
    $count = 0;
    foreach ( $postsArray as $obj ) {
        if ( !( $count % 2 ) ) {
            $row_color = 1;
        } else {
            $row_color = 2;
        }
        $forumpost->setType($obj->type);
        $show_posts = $obj->showPost($viewmode, $order, $canpost, $forumdata['thread_status'], $forumdata['allow_sig'], $adminview, $row_color);
        $module_template->setOutputVarArray('show_posts_loop', 'show_posts', $show_posts);
        $count++;
    }
}

//if the mode is thread, show thread
if ( $viewmode == "thread" ) {
    foreach ( $postsArray as $obj ) {
        $forumpost->setType($obj->type);
        $show_posts = $obj->showPost($viewmode, $order, $canpost, $forumdata['thread_status'], $forumdata['allow_sig'], $adminview);
        $module_template->setOutputVarArray('show_posts_loop', 'show_posts', $show_posts);
        //if not in the top page, show links
        if ( $forumpost->parent() ) {
            $module_template->setSwitch('showLinks', true);
            $show_links = "&nbsp;<a href='".PHP_SELF."?forum=$forum&amp;thread_id=$thread_id&amp;viewmode=$viewmode&amp;order=$order'>"._TOP."</a>
                &nbsp;|&nbsp;<a href='"._PHP_SELF."?forum=$forum&amp;thread_id=$thread_id&amp;post_id=".$forumpost->parent()."&amp;viewmode=".$viewmode."&amp;order=".$order."#".$forumpost->parent()."'>"._PARENT."</a>";
            $module_template->setOutputVar('show_links', $show_links);
        }
        $treeArray = $forumpost->getPostTree($obj->postid());
        if ( count($treeArray) > 0 ) {
            $module_template->setSwitch('showTree', true);
            $show_tree = $obj->showTreeHead();
            $count = 0;
            foreach ($treeArray as $treeItem) {
                if ( !($count % 2) ) {
                    $color_num = 1;
                } else {
                    $color_num = 2;
                }
                $show_tree .= $treeItem->showTreeItem($viewmode, $order, $color_num);
                $count++;
            }
            $show_tree .= $obj->showTreeFoot();
        }
        $module_template->setOutputVar('show_tree', $show_tree);
    }
}

if ( !isset($refresh) && $viewmode != "thread" ) {
    $sql = "
        UPDATE ".$db->prefix("bb_threads")."
            SET thread_views = thread_views + 1
            WHERE thread_id = $thread_id";
    $db->query($sql);
}

if ( !$forumpost->parent() ) {
    $module_template->setSwitch('showNavbar', true);
    include("include/navbar.php");
}

/**
 * Moderator bar
 */
if ( !empty($sysUser) && ( $sysUser->isAdmin($sysModule->mid())
            || isModerator($forum, $sysUser->uid()) ) ) {
    $module_template->setSwitch('showModbar', true);
    $mod_bar = "";
    $link_root = "<a href='".$bbUrl['root']."threadmanager.php?thread_id=$thread_id&amp;forum=$forum&amp;mode=";
    if ( $forumdata['thread_status'] ) {
        $mod_bar .= $link_root."unlock'>
            <img src='".$bbImage['unlockthread']."' alt='"._BB_UNLOCKTHREAD."' /></a> ";
    } else {
        $mod_bar .= $link_root."lock'>
            <img src='".$bbImage['lockthread']."' alt='"._BB_LOCKTHREAD."' /></a> ";
    }
    $mod_bar .= $link_root."move'>
        <img src='".$bbImage['movethread']."' alt='"._BB_MOVETHREAD."' /></a> ";
    $mod_bar .= $link_root."del'>
        <img src='".$bbImage['delthread']."' alt='"._BB_DELETETHREAD."' /></a> ";

    if ( $forumdata['thread_sticky'] == 0 ) {
        $mod_bar .= $link_root."sticky'>
            <img src='".$bbImage['stickythread']."' alt='"._BB_STICKYTHREAD."' /></a>";
    } else {
        $mod_bar .= $link_root."unsticky'>
            <img src='".$bbImage['unstickythread']."' alt='"._BB_UNSTICKYTHREAD."' /></a>";
    }
    $module_template->setOutputVar('mod_bar', $mod_bar);
}

/**
 * Forum jump box
 */
$module_template->setOutputVar('jump_box', makeJumpbox());

include_once("include/footer.php");
?>
