<?php
/**
 * File: $Id: submit.php,v 1.20 2005/07/05 17:21:11 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author: James Knickelbein (@link http://www.journeymilwaukee.com )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html }
 *
 */

include_once("include/header.php");
include_once(SYS_ROOT_PATH."/class/module.errorhandler.php");
include_once(SYS_ROOT_PATH."/class/sysform/formdhtmltextarea.php");
include_once(SYS_ROOT_PATH."/class/datatree.php");
if ( !$sysUser && empty($linksConfig['anon_add']) ) {
    redirectHeader(SYS_ROOT_URL."/user.php", 2, _LK_MUSTREGFIRST);
    exit();
}

$mytree = New DataTree($sysModule->mid());
$eh     = new ErrorHandler();

if ( isset($sys_request['submit']) ) {
    if ( empty($sys_request['submitter']) ) {
        $submitter = 0;
        if ( $sysUser ) {
            $submitter = $sysUser->uid();
        }
    }

    $cid         = intval($sys_request['cid']);
    $url         = formatURL($myts->makeTboxData4Save($sys_request['url']));
    $title       = $myts->makeTboxData4Save($sys_request['title']);
    $email       = $myts->makeTboxData4Save($sys_request['email']);
    $description = $myts->makeTboxData4Save($sys_request['linkdesc']);
    $date        = time();

    // Check if Title exist
    if ( empty($title) ) {
        $eh->show("1001");
    }

    // Check if URL exist
    if ( empty($url) ) {
        $eh->show("1016");
    }

    // Check if Description exist
    if ( empty($description) ) {
        $eh->show("1008");
    }

    $newid = $db->genId($db->prefix("links")."_lid_seq");
    $sql   = "
        INSERT
            INTO ".$db->prefix("links")."
            SET lid         = $newid,
                cid         = $cid,
                title       = '$title',
                description = '$description',
                url         = '$url',
                email       = '$email',
                submitter   = $submitter,
                status      = 0,
                date        = $date,
                hits        = 0,
                rating      = 0,
                votes       = 0";
    $db->query($sql) or $eh->show("0013");
    redirectHeader("index.php", 2, _LK_RECEIVED."<br />"._LK_WHENAPPROVED."");
    exit();

} else {
    $uid = 0;
    if ( $sysUser ) {
        $uid = $sysUser->uid();
    }
    $disclaimer = join('', file("./cache/disclaimer.php"));
    $page_title = "<div class='BlockTitle'>"._LK_ADDNEWLINK."</div>";

    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    $form = new SysThemeForm($page_title, 'submitLink', 'submit.php');
    $form_array = array();

    $form_array[] = new SysFormLabel('', $disclaimer);

    $form_array[] = new SysFormText(_LK_SITETITLE, 'title', 50, 100);
    $form_array[] = new SysFormText(_URL, 'url', 50, 255, 'http://');
    $form_array[] = new SysFormLabel(_TOPIC, $mytree->makeMySelBox('topic_title', 'topic_title','','cid','cid'));
    if ( !$sysUser ) {
        $form_array[] = new SysFormText(_EMAIL, 'email', 50, 60);
    } else {
        $form_array[] = new SysFormLabel(_EMAIL, $sysUser->getVar("email"));
    }
    $form_array[] = new SysFormDhtmlTextArea(_DESCRIPTION, 'linkdesc', '', 6, 50);

    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('submitter', $uid);


    /**
     * Write page
     */
    $module_template->setSwitch('submit', true);
    $module_template->setOutputVar('showSubmit', $form->display($form_array, false, false));
}

include_once("include/footer.php");
?>
