<?php
/**
 * File: $Id: viewtopic.php,v 1.2 2005/07/05 17:21:11 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author: James Knickelbein (@link http://www.journeymilwaukee.com )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html }
 *
 */

include_once("include/header.php");

$mytree = New DataTree($sysModule->mid());
$cid    = intval($sys_request['cid']);

$module_template->setSwitch('viewTopic', true);

$thiscat = $mytree->getSingleItem($cid);
$imgurl  = $thiscat['topic_imgurl'];
$desc    = $mytree->getTopicDescription($cid);

if ( $desc ) {
    $module_template->setSwitch('showDesc', true);
    $myts->setType('admin');
    $desc = $myts->makeTareaData4Show($desc, 1, 1, 1);
    /**
     * This checks to see if an image is set for the subtopic
     * If there is, it shows the image
     */
    if ( !empty($imgurl) && $imgurl != "http://" ) {
        $imgurl_img = "<img src='".formatURL(SYS_MOD_URL.'/system/cache/topics/', $imgurl)."'
            border='0' alt='image' />";
        $module_template->setSwitch('showImgUrl', true);
        $module_template->setOutputVar('imgurl_img', $imgurl_img);
    }
    $module_template->setOutputVar('desc', $myts->makeTareaData4Show($desc, 1, 1, 1));
}


if ( $sys_request['show'] != "" ) {
    $show = intval($sys_request['show']);
} else {
    $show = $linksConfig['perpage'];
}

if ( !isset($sys_request['min']) ) {
    $min = 0;
} else {
    $min = intval($sys_request['min']);
}

if ( !isset($max) ) {
    $max = $min + $show;
}

if ( isset($sys_request['orderby']) ) {
    $orderby = convertOrderByIn($sys_request['orderby']);
} else {
    $orderby = "title ASC";
}

$waytoparents = $mytree->getAllParentsArray($cid);
$pathstring = "<a href='index.php'>"._ALL."</a>";
// Tell linkformat.php not to show pathstring
$pagepath = true;
foreach ( $waytoparents as $key => $cat ) {
    $bold = "normal";
    if ( $key+1 == count($waytoparents) ) {
        $bold = "bold";
    }
    $pathstring .= "&nbsp;::&nbsp;<a style='font-weight:$bold;' href='viewtopic.php?cid=".$cat['topic_id']."'>".$cat['topic_title']."</a>";
}
$module_template->setOutputVar('pathstring', $pathstring);

/**
 * get child topic objects
 */
$arr = array();
$arr = $mytree->getFirstChild($cid, "title");

if ( count($arr) > 0 ) {
    $module_template->setSwitch('showTopics', true);
    $scount = 0;
    foreach ( $arr as $ele ) {
        $title = $myts->makeTboxData4Show($ele['topic_title']);
        $totallink = getTotalItems($ele['topic_id'], 1);
        $imgurl = $ele['topic_imgurl'];
        if ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.'.$imgurl) ) {
            $imgurl = SYS_MOD_URL.'/system/cache/topics/'.$mid.'.'.$imgurl;
        } elseif ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$imgurl) ) {
            $imgurl = SYS_MOD_URL.'/system/cache/topics/'.$imgurl;
        }
        $imgurl_img = "<img src='".$imgurl."' />";
        $topic_link = "<a href='viewtopic.php?cid=".$ele['topic_id']."'>$title</a>";

        $scount++;
        $newrow = "";
        if ( $scount == 4 ) {
            $module_template->setSwitch('newRow', true);
            $scount = 0;
        }
        $module_template->setOutputVarArray('topic_loop', 'imgurl_img', $imgurl_img);
        $module_template->setOutputVarArray('topic_loop', 'topic_link', $topic_link);
        $module_template->setOutputVarArray('topic_loop', 'totallink', $totallink);
    }
}
//
$sql = "
    SELECT COUNT(*)
        FROM ".$db->prefix("links")."
        WHERE cid=$cid AND status>0";
$fullcountresult=$db->query($sql);
list($numrows) = $db->fetch_row($fullcountresult);

if ( $numrows > 0 ) {

    /**
     * if 2 or more items in result, show the sort menu
     */
    if ( $numrows > 1 ) {
        $module_template->setSwitch('showSortBy', true);
        $orderbyTrans = convertOrderByTrans($orderby);
        $cursortby = sprintf(_DL_CURSORTBY, $orderbyTrans);

        $module_template->setOutputVar('title_sort', showSort('title', $cid));
        $module_template->setOutputVar('date_sort', showSort('date', $cid));
        $module_template->setOutputVar('rating_sort', showSort('rating', $cid));
        $module_template->setOutputVar('hits_sort', showSort('hits', $cid));
        $module_template->setOutputVar('cursortby', $cursortby);
    }
    $sql = "
        SELECT lid,
                title,
                url,
                email,
                logourl,
                status,
                date,
                hits,
                rating,
                votes,
                comments,
                description
            FROM ".$db->prefix("links")."
            WHERE cid = $cid AND status > 0
            ORDER BY $orderby";

    $result = $db->query($sql, $show, $min);
    
    //
    while (list($lid, $ltitle, $url, $email, $logourl, $status, $time, $hits, 
            $rating, $votes, $comments, $description) = $db->fetch_row($result)) {
        $rating      = number_format($rating, 2);
        $ltitle      = $myts->makeTboxData4Show($ltitle);
        $url         = $myts->makeTboxData4Show($url);
        $email       = $myts->makeTboxData4Show($email);
        $logourl     = $myts->makeTboxData4Show($logourl);
        $datetime    = formatTimestamp($time, "s");
        $description = $myts->makeTareaData4Show($description, 1, 1, 1);
        include("include/linkformat.php");
    }
    $orderby = convertOrderByOut($orderby);
   
    /**
     *Page Numbering
     */
    $linkpages = ceil($numrows / $show);
    if ( $linkpages != 1 && $linkpages != 0 ) {
        $prev = $min - $show;
        $navbar = "";
        if ( $prev >= 0 ) {
            $navbar .= "
            &nbsp;<a href='viewtopic.php?cid=$cid&min=$prev&orderby=$orderby&show=$show'>
            <b>&lt; "._PREVIOUS." ]</b></a>&nbsp;";
        }
        $counter = 1;
        $currentpage = ($max / $show);
        while ( $counter <= $linkpages ) {
            $mintemp = (($show * $counter) - $show);
            if ( $counter == $currentpage ) {
                $navbar .= "<b>$counter</b>&nbsp;";
            } else {
                $navbar .= "<a href='viewtopic.php?cid=$cid&min=$mintemp&orderby=$orderby&show=$show'>$counter</a>&nbsp;";
            }
            $counter++;
        }

        if ( $numrows>$max ) {
            $navbar .= "
        &nbsp;<a href='viewtopic.php?cid=$cid&min=$max&orderby=$orderby&show=$show'>
        <b>[ "._NEXT." &gt;</b></a>";
        }
        $module_template->setSwitch('showNavbar', true);
        $module_template->setOutputVar('navbar', $navbar);
    }
}
include_once("include/footer.php");

/**
 * Creates a pair of up and down arrow links
 *
 * @param string $sortby the required sort link
 * @param integer $cid the topic id
 * @return string a pair of html image links
 */
function showSort($sortby, $cid) 
{
    return "<a href='viewtopic.php?cid=$cid&orderby=".$sortby."A'>
                <img src='images/up.gif' border='0' align='middle' alt='' />
            </a>
            <a href='viewtopic.php?cid=$cid&orderby=".$sortby."D'>
                <img src='images/down.gif' border='0' align='middle' alt='' />
            </a>";   
} 
?>
