<?php
/**
 * File: $Id: index.php,v 1.55 2005/09/06 09:53:37 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author The Xoops Project (@link http://www.xoops.org )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */

include_once('../../../mainfile.php');
include_once(SYS_ROOT_PATH.'/include/cp_functions.php');

$sysModule = getSysModule();
if ( !$sysUser || !$sysUser->isAdmin($sysModule->mid()) ) {
        $sysHandler['security']->showSecurityERR(SYS_ROOT_URL.'/', 3, _NOPERM);
}

include_once(SYS_ROOT_PATH."/class/datatree.php");
include_once(SYS_MOD_PATH."/".$sysModule->dirname()."/class/class.newsstory.php");
include_once(SYS_ROOT_PATH."/class/module.errorhandler.php");
include_once(SYS_MOD_PATH."/".$sysModule->dirname()."/cache/config.php");
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

$mytree = new Datatree($sysModule->mid(), true, 'admins');

/**
 * Show new submissions
 *
 * @param type $var description
 * @return type description
 */
function newSubmissions()
{
    global $sysConfig, $db, $mytree, $action_image;

    $storyarray = $mytree->contentQuery('news_stories', '*', 'published = 0', 
        'storyid DESC', 'topicid', '100');

    if ( count($storyarray) > 0 ) {
        $table_array = array();
        $table_array[0]['title']  = new sysFormLabel('', _TITLE);
        $table_array[0]['posted'] = new sysFormLabel('', _POSTED);
        $table_array[0]['poster'] = new sysFormLabel('', _POSTER);
        $table_array[0]['action'] = new sysFormLabel('', _ACTION);
        
        foreach ( $storyarray as $newstory ) {
            if ( $newstory['storyid'] != $oldstory ) {
                $sid = $newstory['storyid'];
                $newsstory = new NewsStory($sid);
                $title = $newsstory->title();
                if ( !$title ) {
                    $title = _AD_NOSUBJECT;
                }
                $title_link  =  "<a href='index.php?op=edit&amp;storyid=$sid'>$title</a>";
                $created     = formatTimestamp($newsstory->created());
                $poster_link = "<a href='".SYS_ROOT_URL."/userinfo.php?uid=$sid'>".$newsstory->uname()."</a>";
                $action_link = "<a href='index.php?op=delete&amp;storyid=$sid'>".$action_image['delete']."</a>";

                $table_array[$sid]['title']  = new SysFormLabel('', $title_link);
                $table_array[$sid]['posted'] = new SysFormLabel('', $created);
                $table_array[$sid]['poster'] = new SysFormLabel('', $poster_link);
                $table_array[$sid]['action'] = new SysFormLabel('', $action_link);
                $oldstory = $sid;
            }
        }
        $form = new SysThemeForm(_NW_NEWSUB, 'newSubsTable', 'noAction');
        $form_array = array();
        $form_array[] = new SysFormElementTable('Forum Users', $table_array);
        
        $form->display($form_array, true);
    }
}

/**
 * Shows automated stories
 *
 * @param type $var description
 * @return type description
 */
function autoStories()
{
    global $db, $sysConfig, $sysModule, $action_image;

    $storyarray = NewsStory::getAllAutoStory();
    if ( count($storyarray) > 0 ) {
        $title_array = array('id' => _NW_STORYID, 'title' => _TITLE, 'topic' => _TOPIC,
            'poster' => _POSTER, 'program' => _NW_PROGRAMMED, 'action' => _ACTION);
        foreach ( $title_array as $name => $title ) {
            $table_array[0][$name]   = new SysFormLabel('', $title);
        }
        foreach ( $storyarray as $autostory ) {
            $topic = $autostory->topic();
            $sid = $autostory->storyid();
            $title_link  = "<a href='".SYS_MOD_URL."/".$sysModule->dirname()."/article.php?storyid=$sid'>".$autostory->title()."</a>";
            $poster_link = "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$autostory->uid()."'>".$autostory->uname()."</a>";
            $action_link = "<a href='index.php?op=edit&amp;storyid=$sid'>".$action_image['edit']."</a>
                <a href='index.php?op=delete&amp;storyid=$sid'>".$action_image['delete']."</a>";
          
            $table_array[$sid]['id']      = new SysFormLabel('', $sid);
            $table_array[$sid]['title']   = new SysFormLabel('', $title_link);
            $table_array[$sid]['topic']   = new SysFormLabel('', $topic->topic_title());
            $table_array[$sid]['poster']  = new SysFormLabel('', $poster_link);
            $table_array[$sid]['program'] = new SysFormLabel('', formatTimestamp($autostory->published()));
            $table_array[$sid]['action']  = new SysFormLabel('', $action_link);
        }
        $form = new SysThemeForm(_NW_AUTOARTICLES, 'autoArticles', 'noAction');
        $form_array = array();
        $form_array[] = new SysFormElementTable('', $table_array, true);
        
        $form->display($form_array, true);
    }
}

/**
 * Shows last 10 published stories
 *
 * @param type $var description
 * @return type description
 */
function lastStories()
{
    global $db, $sysConfig, $sysModule, $mytree, $action_image;
    
    $title_array = array('id' => _NW_STORYID, 'title' => _TITLE, 'topic' => _TOPIC,
    'poster' => _POSTER, 'publish' => _NW_PUBLISHED, 'action' => _ACTION);
    foreach ( $title_array as $name => $title ) {
        $table_array[0][$name]   = new SysFormLabel('', $title);
    }
    $storyarray = $mytree->contentQuery('news_stories', '*', 'published > 0', 'storyid DESC', 'topicid', '100');
    
    $i = 10;
    foreach ( $storyarray as $story ) {
        /**
         * Making sure that story hasn't already been shown
         */
        if ( ( $story['storyid'] != $oldstory ) && $i > 0 ) {
            $story = new NewsStory($story['storyid']);
            $topic = $story->topic();
            
            $sid = $story->storyid();
            $title_link  = "<a href='".SYS_MOD_URL."/".$sysModule->dirname()."/article.php?storyid=$sid'>".$story->title()."</a>";
            $poster_link = "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$story->uid()."'>".$story->uname()."</a>";
            $action_link = "<a href='index.php?op=edit&amp;storyid=$sid'>".$action_image['edit']."</a>
                <a href='index.php?op=delete&amp;storyid=$sid'>".$action_image['delete']."</a>";
          
            $table_array[$sid]['id']      = new SysFormLabel('', $sid);
            $table_array[$sid]['title']   = new SysFormLabel('', $title_link);
            $table_array[$sid]['topic']   = new SysFormLabel('', $topic->topic_title());
            $table_array[$sid]['poster']  = new SysFormLabel('', $poster_link);
            $table_array[$sid]['publish'] = new SysFormLabel('', formatTimestamp($story->published()));
            $table_array[$sid]['action']  = new SysFormLabel('', $action_link);
            
            $oldstory = $story->storyid();
            $i--;
        }
    }

    $form = new SysThemeForm(_NW_LAST10ARTS, 'lastTen', 'index.php');
    $form_array = array();
    $form_array[] = new SysFormElementTable('', $table_array, true);
    $form_array[] = new SysFormText(_NW_STORYID, 'storyid', 10, 10);
    $form_array[] = new SysFormRadio(_ACTION, 'op', '', array('edit'=>_EDIT, 'delete'=>_DELETE));
    $form_array[] = new SysFormButtonTray();

    $form->display($form_array, true);
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function newsConfig()
{
    global $sysConfig, $sysModule, $newsConfig;

    $page_title = "<div class='FormTitle'>"._NW_CONFIG."</div>";
    $n5to30_array = array (5=>5, 10=>10, 15=>15, 20=>20, 25=>25, 30=>30);
    $n50to300_array = array (50=>50, 100=>100, 150=>150, 200=>200, 250=>250, 300=>300);

    $titletrackback = $showdetails = $showauthor =
    $showrealname = $showrelatedlinks = '0';
    if ( $newsConfig["titletrackback"] ) {
        $titletrackback = '1';
    }
    if ( $newsConfig['showdetails'] ) {
        $showdetails = '1';
    }
    if ( $newsConfig['showauthor'] ) {
        $showauthor = '1';
    }
    if ( $newsConfig['showrealname'] ) {
        $showrealname = '1';
    }
    if ( $newsConfig['showrelatedlinks'] ) {
        $showrelatedlinks = '1';
    }

    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    $form = new SysThemeForm($page_title, 'newsConfig', 'index.php');
    $form_array = array();

    $form_array[] = new SysFormLabel(_GENERALCONFIG, '', true);
    $form_array[] = new SysFormSelect(_NW_STORYHOME, 'storyhome',
        $newsConfig['storyhome'], 1, false, $n5to30_array);
    $form_array[] = new SysFormRadioYN(_NW_DISPLAYNAV, 'displaynav', $newsConfig['displaynav']);
    $form_array[] = new SysFormRadioYN(_NW_ANONSUBMIT, 'anonsubmit', $newsConfig['anonsubmit']);
    $form_array[] = new SysFormRadioYN(_NW_NOTIFYSUBMIT, 'notifysubmit', $newsConfig['notifysubmit']);
    $form_array[] = new SysFormLabel(_NW_LAYOUTCONF, '', true);
    $form_array[] = new SysFormRadioYN(_NW_TITLETRACKBACK, 'titletrackback', $titletrackback);
    $form_array[] = new SysFormRadioYN(_NW_SHOWDETAILS, 'showdetails', $showdetails);
    $form_array[] = new SysFormRadioYN(_NW_SHOWAUTHOR, 'showauthor', $showauthor);
    $form_array[] = new SysFormRadioYN(_NW_SHOWREALNAME, 'showrealname', $showrealname);
    $form_array[] = new SysFormRadioYN(_NW_SHOWRELATEDLINKS, 'showrelatedlinks', $showrelatedlinks);
    $form_array[] = new SysFormLabel(_RSS_CONF, '', true);
    $form_array[] = new SysFormRadioYN(_RSS_ENABLE, 'rss_enable', $newsConfig['rss_enable']);
    $form_array[] = new SysFormSelect(_RSS_MAXITEMS, 'rss_maxitems',
        $newsConfig['rss_maxitems'], 1, false, $n5to30_array);
    $form_array[] = new SysFormSelect(_RSS_MAXDESC, 'rss_maxdescription',
    $newsConfig['rss_maxdescription'], 1, false, $n50to300_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'newsConfigS');

    /**
     * Write page
     */
    sysCpHeader();
    $form->display($form_array, true);
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function newsConfigS()
{
    global $sys_request, $sysHandler, $_SERVER;

    // $sysHandler['security']->checkVars('op', 'index.php', 2, _NOREFERRER);

    $content .= "<?php\n";
    $content .= "\$newsConfig['anonsubmit']         = ".intval($sys_request['anonsubmit']).";\n";
    $content .= "\$newsConfig['storyhome']          = ".intval($sys_request['storyhome']).";\n";
    $content .= "\$newsConfig['notifysubmit']       = ".intval($sys_request['notifysubmit']).";\n";
    $content .= "\$newsConfig['displaynav']         = ".intval($sys_request['displaynav']).";\n";
    $content .= "\$newsConfig['titletrackback']     = ".intval($sys_request['titletrackback']).";\n";
    $content .= "\$newsConfig['showdetails']        = ".intval($sys_request['showdetails']).";\n";
    $content .= "\$newsConfig['showauthor']         = ".intval($sys_request['showauthor']).";\n";
    $content .= "\$newsConfig['showrealname']       = ".intval($sys_request['showrealname']).";\n";
    $content .= "\$newsConfig['showrelatedlinks']   = ".intval($sys_request['showrelatedlinks']).";\n";
    $content .= "\$newsConfig['rss_enable']         = ".intval($sys_request['rss_enable']).";\n";
    $content .= "\$newsConfig['rss_maxitems']       = ".intval($sys_request['rss_maxitems']).";\n";
    $content .= "\$newsConfig['rss_maxdescription'] = ".intval($sys_request['rss_maxdescription']).";\n";
    $content .= "?>";

    $filename = "../cache/config.php";

    if ( $file = fopen($filename, "w") ) {
        fwrite($file, $content);
        fclose($file);
    } else {
        redirectHeader("index.php?op=newsConfig", 1, _NOTUPDATED);
        exit();
    }

    redirectHeader("index.php", 1, _UPDATED);
    exit();
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function buildRss()
{
    global $db, $newsConfig, $module_url;

    if ( $newsConfig['rss_enable'] ) {

        $sql = "
            SELECT title, storyid, hometext
                FROM ".$db->prefix("news_stories")."
                WHERE published > 0 AND published < ".(time()+10)."
                ORDER BY published DESC";

        $query = $db->query($sql, $newsConfig['rss_maxitems']);

        if ( $query ) {
            include_once(SYS_ROOT_PATH . "/class/xml-rss.php");
            $rss = new xml_rss('../cache/news.xml');
            $rss->channel_title .= " :: "._NW_NAME;
            $rss->image_title   .= " :: "._NW_NAME;
            $rss->max_items            = $newsConfig['rss_maxitems'];
            $rss->max_item_description = $newsConfig['rss_maxdescription'];

            while ( list($title, $link, $description) = $db->fetch_row($query) ) {
                $link = $module_url.'/article.php?storyid=' . $link;
                $rss->build($title, $link, $description);
            }
            $rss->save();
        }
    }
}
/**
 * Set $op to read submit button values from storyform.php
 */
$op = $sys_request['op'];
if ( $sys_request['preview'] ) {
    $op = 'preview';
} elseif ( $sys_request['delete'] || $sys_request['op'] == 'delete') {
    $op = 'delete';
}

switch( $op ) {

    case "edit":
    
        $story         = new NewsStory($storyid);
        if ( !$mytree->accessTopic($story->topicid()) ) {
            redirectHeader('index.php', 3, _NOPERM);;
            exit();
        }
        sysCpHeader();
        openTable();
        echo "<div class='FormTitle'>"._NW_EDITARTICLE."</div>";
        $title         = $story->title("Edit");
        $hometext      = $story->hometext("Edit");
        $bodytext      = $story->bodytext("Edit");
        $allow_html    = intval($story->allow_html());
        $allow_smileys = intval($story->allow_smileys());
        $allow_bbcode  = intval($story->allow_bbcode());
        $ihome         = intval($story->ihome());
        $topicid       = intval($story->topicid());
        $published     = $story->published();
        $type          = $story->type();
        $topicdisplay  = $story->topicdisplay();
        $topicalign    = $story->topicalign(false);
        $isedit        = true;
        include_once("storyform.inc.php");
        closeTable();
        break;

    case "newarticle":
    
        sysCpHeader();
        newSubmissions();
        autoStories();
        lastStories();
        $form_title = _NW_POSTNEWARTICLE;
        $type = 'admin';
        include_once("storyform.inc.php");
        break;

    case "preview":
    
        sysCpHeader();
        if ( isset($storyid)) {
            $story = new NewsStory($storyid);
            $published = $story->published();
        } else {
            $story = new NewsStory();
        }
        $story->setTitle($sys_request['title']);
        $story->setHomeText($sys_request['hometext']);
        $story->setBodyText($sys_request['bodytext']);
        $story->setHtml($sys_request['allow_html']);
        $story->setSmileys($sys_request['allow_smileys']);
        $story->setBBcode($sys_request['allow_bbcode']);
        $story->setTopicalign($sys_request['topicalign']);
        $story->setType($sys_request['type']);
        $story->setTopicdisplay(intval($sys_request['topicdisplay']));
        $autohour   = $sys_request['autohour'];
        $automin    = $sys_request['automin'];
        $automonth  = $sys_request['automonth'];
        $autoday    = $sys_request['autoday'];
        $autoyear   = $sys_request['autoyear'];
        // @todo :: remove sysTopic
        $xt         = new SysTopic($db->prefix("news_topics"));
        $p_title    = $story->title("Preview");
        $p_hometext = $story->hometext("Preview");
        $p_bodytext = $story->bodytext("Preview");
        $title      = $story->title("InForm");
        $hometext   = $story->hometext("InForm");
        $bodytext   = $story->bodytext("InForm");
        openTable();
        openTable("70%");
        if ( $topicdisplay ) {
            if ( $topicalign == "L" ) {
                $align = "left";
            } else {
                $align = "right";
            }
            if ( empty($topicid) ) {
                $warning = "<div style='text-align: center;'><blink><b>"._AR_SELECTTOPIC."</b></blink></div>";
                $timage  = "";
            } else {
                // @todo :: remove SysTopic
                $xt      = new SysTopic($db->prefix("news_topics"), $topicid);
                $warning = "";
                if ( $xt->topic_imgurl() ) {
                    // @todo :: change image link
                    $timage  = "<img src='".formatURL(SYS_MOD_URL."/".$sysModule->dirname()."/cache/topics/", $xt->topic_imgurl())."' align='$align' border='0' hspace='10' vspace=10' alt='".$xt->topic_title("P")."' />";
                }
            }
        } else {
            $timage = "";
        }
        if ( !empty($p_bodytext) ) {
            echo "<b>".$p_title."</b><br /><br />".$timage."".$p_hometext."<br /><br />".$p_bodytext."<br /><br />";
        } else {
            echo "<b>".$p_title."</b><br /><br />".$timage."".$p_hometext."<br /><br />";
        }
        echo $warning;
        closeTable();
        include_once("storyform.inc.php");
        break;

    case "save":
    
        global $sys_request;

        if ( empty($sys_request['storyid']) ) {
            $story = new NewsStory();
            $story->setUid($sysUser->uid());
            if ( $sys_request['autodate'] ) {
                $pubdate   = mktime($sys_request['autohour'], $sys_request['automin'], 0, $sys_request['automonth'], $sys_request['autoday'], $sys_request['autoyear']);
                $offset    = $sysUser->timezone() - $sysConfig['server_TZ'];
                $pubdate   = ($pubdate - ($offset * 3600));
                $story->setPublished($pubdate);
            } else {
                $story->setPublished(time());
            }
            $story->setType($sys_request['type']);
            $story->setHostname(_REMOTE_ADDR);
        } else {
            $story = new NewsStory($sys_request['storyid']);
            if ( $sys_request['autodate'] ) {
                $pubdate = mktime($sys_request['autohour'], $sys_request['automin'], 0, $sys_request['automonth'], $sys_request['autoday'], $sys_request['autoyear']);
                $offset  = $sysUser->timezone();
                $offset  = ($offset - $sysConfig['server_TZ']);
                $pubdate = ($pubdate - ($offset * 3600));
                $story->setPublished($pubdate);
            } elseif ( ( $story->published() == 0 ) && $sys_request['approve'] ) {
                $story->setPublished(time());
                $isnew = 1;
            } else {
                if ( $sys_request['movetotop'] ) {
                    $story->setPublished(time());
                }
            }
        }
        $story->setApproved($sys_request['approve']);
        $story->setTopicId($sys_request['topicid']);
        $story->setTitle($sys_request['title']);
        $story->setHometext($sys_request['hometext']);
        $story->setBodytext($sys_request['bodytext']);
        $story->setHtml($sys_request['allow_html']);
        $story->setSmileys($sys_request['allow_smileys']);
        $story->setBBcode($sys_request['allow_bbcode']);
        $story->setIhome($sys_request['ihome']);
        $story->setTopicalign($sys_request['topicalign']);
        $story->setTopicdisplay(intval($sys_request['topicdisplay']));

        $story->store();
        
        if ( !empty($isnew) && $story->notifypub() && $story->uid() != 0 ) {
            $poster   = new SysUser($story->uid());
            $subject  = _NW_ARTPUBLISHED;
            $message  = sprintf(_HELLO, $poster->uname());
            $message .= "\n\n"._NW_YOURARTPUB."\n\n";
            $message .= _TITLE." : ".$story->title()."\n"._URL." : ".SYS_MOD_URL."/".$sysModule->dirname()."/article.php?storyid=".$story->storyid()."\n"._NW_PUBLISHEDC.formatTimestamp($story->published(),"m",0)."\n\n";
            $message .= $meta['title']."\n".SYS_ROOT_URL."";

            $sysMailer =& getMailer();
            $sysMailer->useMail();
            $sysMailer->setToEmails($poster->getVar("email"));
            $sysMailer->setFromEmail($sysConfig['adminmail']);
            $sysMailer->setFromName($meta['title']);
            $sysMailer->setSubject($subject);
            $sysMailer->setBody($message);
            $sysMailer->send();
        }
        buildRss();
        redirectHeader("index.php?op=newarticle", 1, _UPDATED);
        exit();
        break;

    case "delete":

        if ( $ok ) {
            $story = new NewsStory($storyid);
            $story->delete();
            buildRss();
            redirectHeader("index.php?op=newarticle", 1, _UPDATED);
            exit();
        } else {
            $story = new NewsStory($storyid);
            if ( !$mytree->accessTopic($story->topicid()) ) {
                $sysHandler['security']->showSecurityERR('index.php', 3, _NOPERM);;
                exit();
            }
            sysCpHeader();
            openTable();
            echo "<h4 style='color:#ff0000'>"._NW_RUSUREDEL."</h4>";
            echo "<table><tr><td>";
            echo myTextForm("index.php?op=delete&storyid=".$storyid."&ok=1" , _YES);
            echo "</td><td>";
            echo myTextForm("javascript:history.go(-1)" , _NO);
            echo "</td></tr></table>";
            closeTable();
        }
        break;

    case "newsConfig":
        newsConfig();
        break;

    case "newsConfigS":
        newsConfigS();
        break;

    default:
        sysCpHeader();
        break;
}
sysCpFooter();
?>
