<?php
/**
 * File: $Id: index.php,v 1.27 2005/05/12 17:36:09 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @Author: Half-Dead
 * @license Proprietary (@link /manual/licenses/half-dead.txt)
 */

include_once('admin_header.php');

$sysModule = getSysModule();
$module_url = SYS_MOD_URL.'/'.$sysModule->dirname();
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function managePartners()
{
    global $db, $myts, $module_url;

    $form_title = "<div class='FormTitle'>"._PA_PARTNERADMIN."</div>";
    $sql = "
        SELECT id, hits, url, weight, image, title, description, status
            FROM ".$db->prefix("partners")."
            ORDER BY status DESC, weight ASC, title DESC";
    $result = $db->query($sql);
    $image_text = '';
    $edit_path   ="<a href='index.php?op=edit_partner&amp;id=";
    $delete_path ="<a href='index.php?op=delete_partner&amp;id=";

    $form = new SysThemeForm($form_title, 'partnerAdmin', './index.php');
    $form_array = array();

    foreach (array(_TITLE, _DESCRIPTION, _IMAGE, _HITS, _WEIGHT, _ACTION) as $text) {
        $partner_array[0][] = new SysFormLabel('', "<strong>$text</strong>");
    }
    while ( list($id, $hits, $url, $weight, $image, $title, $description, $status) = $db->fetch_row($result) ) {
        $partner_array[$id]['title'] = new SysFormLabel('', "<a href='$url' target='_blank'>$title</a>");
        $partner_array[$id]['desc'] = new SysFormLabel('', $description);
        if ( !empty($image) ) {
            $image_text = "<a href='$url' target='_blank'>
                <img src='".formatURL($module_url."/cache/images/", $image)."'
                alt='$title' border='0' /></a>";
        }
        $partner_array[$id]['image'] = new SysFormLabel('', $image_text);
        $partner_array[$id]['hits'] = new SysFormLabel('', $hits);
        if ( !empty($status) ) {
            $partner_array[$id]['weight'] = new SysFormText('', "weight[$id]", 3, 3, $weight);
        } else {
            $partner_array[$id]['weight'] = new SysFormLabel('', '');
        }
        $partner_array[$id]['action'] = new SysFormLabel('', $edit_path.$id."'>"._EDIT."</a>
            &nbsp;|&nbsp;".$delete_path.$id."&amp;ok=0'>"._DELETE."</a>");
    }
    $form_array[] = new SysFormElementTable('', $partner_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'reorder_partners');

    sysCpHeader();
    $form->display($form_array, true);

    $form_title = "<div class='FormTitle'>"._ADD."</div>";
    $form = new SysThemeForm($form_title, 'addPartner', 'index.php');
    $form_array = array();

    $form_array[] = new SysFormText(_TITLE, 'title', 35, 60);
    $form_array[] = new SysFormText(_URL, 'url', 35, 255);
    $form_array[] = new SysFormText(_WEIGHT, 'weight', 3, 3);
        $image_array[] = new SysFormText('', 'image', 35, 255);
        $image_array[] = new SysFormFile('', 'image1', 5000);
    $form_array[] = new SysFormElementTray(_IMAGE, '&nbsp;::&nbsp;', $image_array);
    $form_array[] = new SysFormTextArea(_DESCRIPTION, 'description', '', 6, 50);
    $form_array[] = new SysFormRadioYN(_ACTIVE, 'status', '');
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'add_partner');

    $form->display($form_array, true);
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function editPartner($id)
{
    global $db, $myts, $module_url;

    $form_title = "<div class='FormTitle'><a href='index.php'>"._MAIN."</a> :: "._EDIT."</div>";

    $sql = "
        SELECT weight, hits, url, image, title, description, status
            FROM ".$db->prefix("partners")."
            WHERE id = $id";
    $result = $db->query($sql);
    list( $weight, $hits, $url, $image, $title, $description, $status) = $db->fetch_row($result );

    $image_text = '';
    if ( $image ) {
        $image_text = "<img src='".formatURL($module_url."/cache/images/", $image)."' border='0' /><br />";
    }
    $form = new SysThemeForm($form_title, 'editPartner', _PHP_SELF);
    $form_array = array();

    $form_array[] = new SysFormText(_TITLE, 'title', 35, 60, $title);
    $form_array[] = new SysFormText(_URL, 'url', 35, 255, $url);
    $form_array[] = new SysFormText(_PA_HITS, 'hits', 3, 8, $hits);
    $form_array[] = new SysFormText(_WEIGHT, 'weight', 3, 3, $weight);
        $image_array[] = new SysFormText($image_text, 'image', 35, 255);
        $image_array[] = new SysFormFile('', 'image1', 5000);
    $form_array[] = new SysFormElementTray(_IMAGE, '&nbsp;::&nbsp;', $image_array);
    $form_array[] = new SysFormTextArea(_DESCRIPTION, 'description', '', 6, 50, $description);
    $form_array[] = new SysFormRadioYN(_ACTIVE, 'status', $status);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'change_partner');
    $form_array[] = new SysFormHidden('id', $id);

    sysCpHeader();
    $form->display($form_array, true);
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function changePartner($id, $weight, $hits, $url, $image, $title, $description, $status)
{
    global $db, $myts;

    if ( empty($title) || empty($url) ) {
        redirectHeader("index.php", 1, _PA_BESURE);
        exit();
    }

    $url          = formatURL($url);
    $title        = $myts->makeTboxData4Save($title);
    $description  = $myts->makeTboxData4Save($description);

    if ( !is_numeric($weight) ) {
        $weight = 0;
    }

    if ( !is_numeric($hits) ) {
        $hits = 0;
    }

    if ( !empty($_FILES['image1']['name']) ) {
        include_once(SYS_ROOT_PATH."/class/fileupload.php");
        $upload = new fileupload();
        $upload->set_upload_dir($module_path."/cache/images/", 'image1');
        $upload->set_accepted("gif|jpg|png", 'image1');
        $upload->set_overwrite(1, 'image1');
        $result = $upload->upload();
        if ( $result['image1']['filename'] ) {
            $sql = "
                SELECT image
                    FROM ".$db->prefix("partners")."
                    WHERE id = $id";
            $old = $db->query($sql);
            list($oldimage) = $db->fetch_row($old);
            @unlink($module_path."/cache/images/".basename($oldimage));
            $image = $result['image1']['filename'];
        } else {
            redirectHeader("index.php", 3, $upload->errors());
            exit();
        }
    }

    $sql = "
        UPDATE ".$db->prefix("partners")."
            SET
                hits        = $hits,
                weight      = $weight,
                url         = '$url',
                image       = '$image',
                title       = '$title',
                description = '$description',
                status      = $status
            WHERE id = $id";

    if ($db->query($sql)) {
        redirectHeader("index.php", 1, _UPDATED);
    } else {
        redirectHeader("index.php", 1, _NOTUPDATED);
    }
    exit();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function addPartner($weight, $url, $image, $title, $description, $status)
{
    global $db, $myts;

    if ( empty($title) || empty($url) ) {
        redirectHeader("index.php", 1, _PA_BESURE);
        exit();
    }

    $url          = formatURL($url);
    $title        = $myts->makeTboxData4Save($title);
    $description  = $myts->makeTboxData4Save($description);

    if ( !is_numeric($weight) ) {
        $weight = 0;
    }

    if ( !empty($_FILES['image1']['name']) ) {
        include_once(SYS_ROOT_PATH."/class/fileupload.php");
        $upload = new fileupload();
        $upload->set_upload_dir($module_path."/cache/images/", 'image1');
        $upload->set_accepted("gif|jpg|png", 'image1');
        $upload->set_overwrite(1, 'image1');
        $result = $upload->upload();
        if ($result['image1']['filename']) {
            $image = $result['image1']['filename'];
        } else {
            redirectHeader("index.php", 3, $upload->errors());
            exit();
        }
    }

    $newid = $db->genId($db->prefix("partners")."_num_seq");

    $sql = "
       INSERT
           INTO ".$db->prefix("partners")."
           SET
               id=$newid,
               hits=0,
               weight=$weight,
               url='$url',
               image='$image',
               title='$title',
               description='$description',
               status=$status";
    $message = _NOTUPDATED;
    if ( $db->query($sql) ) {
        $message = _UPDATED;
    }
    redirectHeader("index.php", 1, $message);
    exit();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function delPartner($id, $ok=0)
{
    global $db;

    if ( $ok ) {

        $sql = "
            SELECT image
                FROM ".$db->prefix("partners")."
                WHERE id=$id";
        $old = $db->query($sql);
        list($oldimage) = $db->fetch_row($old);
        @unlink($module_path."/cache/images/".basename($oldimage));

        $sql = "
            DELETE
                FROM ".$db->prefix("partners")."
                WHERE id = $id";
        $message = _NOTUPDATED;
        if ( $db->query($sql) ) {
            $message = _UPDATED;
        }
        redirectHeader("index.php", 1, $message);
        exit();
    } else {
        sysCpHeader();
        openTable();
        echo "<b>"._PA_SURETODELETE."</b>
            <table><tr><td>"
            .myTextForm("index.php?op=delete_partner&amp;id=".$id."&amp;ok=1", _YES)
            ."</td><td>"
            .myTextForm("index.php" , _NO)
            ."</td></tr></table>";
        closeTable();
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function reorderPartners($weight)
{
    global $db;

    foreach ( $weight as $id => $order ) {
        if ( isset($id) && is_numeric($id) && isset($order) ) {
            if ( !is_numeric($order) ) {
                $order = 0;
            }
            $sql = "
                UPDATE ".$db->prefix("partners")."
                    SET weight='$order'
                    WHERE id = $id";
            $db->query($sql);
        }
    }
    redirectHeader("./index.php", 1, _UPDATED);
    exit();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function configurePartners()
{
    sysCpHeader();
    openTable();

    echo "<h4>"._CONFIG."</h4>";
    include_once('../cache/config.php');
    include_once('./settings.inc.php');

    closeTable();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function savePartners()
{
    global $sys_request;

    $partners_cookietime = 86400;
    if ( is_numeric($sys_request["partners_cookietime"]) ) {
        $partners_cookietime = $sys_request["partners_cookietime"];
    }
    $partners_limit = 0;
    if ( is_numeric($sys_request["partners_limit"]) ) {
        $partners_limit = $sys_request["partners_limit"];
    }
    $partners_blimit = 0;
    if ( is_numeric($sys_request["partners_blimit"]) ) {
        $partners_blimit = $sys_request["partners_blimit"];
    }
    $content = '
<?php
// '._PA_COMMON.'
$partners_cookietime = '.$partners_cookietime.';

// '._PA_MAIN.'
$partners_randomize = '.$sys_request["partners_randomize"].';
$partners_limit     = '.$partners_limit.';
$partners_show      = '.$sys_request["partners_show"].';
$partners_order     = "'.$sys_request["partners_order"].'";
$partners_orderd    = "'.$sys_request["partners_orderd"].'";

// '._PA_BLOCK.'
$partners_brandomize = '.$sys_request["partners_brandomize"].';
$partners_blimit     = '.$partners_blimit.';
$partners_bshow      = '.$sys_request["partners_bshow"].';
$partners_border     = "'.$sys_request["partners_border"].'";
$partners_borderd    = "'.$sys_request["partners_borderd"].'";
?>';
    $message = _NOTUPDATED;
    if ( $fp = fopen('../cache/config.php', "w") ) {
        fwrite($fp, $content);
        fclose($fp);
        $message = _UPDATED;
    }
    redirectHeader("./index.php", 1, $message);
    exit();
}

switch ( $sys_request['op'] ) {

    case "change_partner":
    changePartner($sys_request["id"], $sys_request["weight"], $sys_request["hits"],
        $sys_request["url"], $sys_request["image"], $sys_request["title"],
        $sys_request["description"], $sys_request["status"]);
    break;

    case "add_partner":
    addPartner($sys_request["weight"], $sys_request["url"], $sys_request["image"],
        $sys_request["title"], $sys_request["description"], $sys_request["status"]);
    break;

    case "delete_partner":
    delPartner($sys_request['id'], $sys_request['ok']);
    break;

    case "edit_partner":
    editPartner($sys_request['id']);
    break;

    case "reorder_partners":
    reorderPartners($sys_request["weight"]);
    break;

    case "configure_partners":
    configurePartners();
    break;

    case "save_partners":
    savePartners();
    break;

    default:
    managePartners();
    break;
}
sysCpFooter();
?>
