<?php
/**
 * File: $Id: polloption.php,v 1.10 2005/06/03 16:39:45 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

include_once(SYS_ROOT_PATH."/class/sysobject.php");

/**
 * Enter description here...
 *
 */
class SysPollOption extends SysObject
{
    function SysPollOption($id=NULL)
    {
        $this->SysObject();
        $this->initVar("option_id", "int", NULL, false);
        $this->initVar("poll_id", "int", NULL, false);
        $this->initVar("option_text", "textbox", NULL, true, 255, true);
        $this->initVar("option_count", "int", 0, false);
        $this->initVar("option_color", "other", NULL, false);
        if ( !empty($id) ) {
            if ( is_array($id) ) {
                $this->set($id);
            } else {
                $this->load(intval($id));
            }
        }
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function store()
    {
        global $db;

        if ( !$this->isCleaned() ) {
            if ( !$this->cleanVars() ) {
                return false;
            }
        }

        foreach ( $this->cleanVars as $k=>$v ) {
            $$k = $v;
        }

        if ( empty($option_id) ) {
            $option_id = $db->genId($db->prefix("poll_data")."_option_id_seq");
            $sql = "
                INSERT
                    INTO ".$db->prefix("poll_data")."
                    SET
                        option_id=$option_id,
                        poll_id=$poll_id,
                        option_text='$option_text',
                        option_count=$option_count,
                        option_color='$option_color'";

        } else {
            $sql = "
                UPDATE ".$db->prefix("poll_data")."
                    SET option_text='$option_text', option_count='$option_count', option_color='$option_color'
                    WHERE option_id=".$option_id."";
        }

        if ( !$result = $db->query($sql) ) {
            $this->setErrors(_NOTUPDATED);
            return false;
        }

        if ( empty($option_id) ) {
            return $db->insert_id();
        }

        return $option_id;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function load($id)
    {
        global $db;

        $sql   = "
            SELECT *
                FROM ".$db->prefix("poll_data")."
                WHERE option_id=".$id."";
        $myrow = @$db->fetch_array($db->query($sql));
        $this->set($myrow);
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function delete()
    {
        global $db;

        $sql = "
            DELETE
                FROM ".$db->prefix("poll_data")."
                WHERE option_id=".$this->getVar("option_id")."";
        if ( !$db->query($sql) ) {
            return false;
        }

        return true;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function updateCount()
    {
        global $db;

        $votes = SysPollLog::getTotalVotesByOptionId($this->getVar("option_id"));
        $sql   = "
            UPDATE ".$db->prefix("poll_data")."
                SET option_count=$votes
                WHERE option_id=".$this->getVar("option_id")."";
        $db->query($sql);
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function &getAllByPollId($poll_id)
    {
        global $db;

        $poll_id = intval($poll_id);
        $ret     = array();
        $sql     = "
            SELECT *
                FROM ".$db->prefix("poll_data")."
                WHERE poll_id=$poll_id
                ORDER BY option_id";
        $result = $db->query($sql);

        while ( $myrow = @$db->fetch_array($result) ) {
            $ret[] = new SysPollOption($myrow);
        }
        return $ret;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function deleteByPollId($poll_id)
    {
        global $db;

        $sql = "
            DELETE
                FROM ".$db->prefix("poll_data")."
                WHERE poll_id=".intval($poll_id);
        if ( !$db->query($sql) ) {
            return false;
        }
        return true;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function resetCountByPollId($poll_id)
    {
        global $db;

        $sql = "
            UPDATE ".$db->prefix("poll_data")."
                SET option_count=0
                WHERE poll_id=".intval($poll_id);
        if ( !$db->query($sql) ) {
            return false;
        }
        return true;
    }
}
?>
