<?php
/**
 * File: $Id: index.php,v 1.20 2005/06/03 16:39:45 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

include_once('../../mainfile.php');
include_once('./include/constants.php');
include_once(SYS_MOD_PATH."/".$sysModule->dirname()."/class/poll.php");
include_once(SYS_MOD_PATH."/".$sysModule->dirname()."/class/polloption.php");
include_once(SYS_MOD_PATH."/".$sysModule->dirname()."/class/polllog.php");
include_once(SYS_MOD_PATH."/".$sysModule->dirname()."/class/pollrenderer.php");

if ( $sys_request['poll_id'] ) {
    $poll_id = intval($sys_request['poll_id']);
}
$module_template->setSwitch('index', true);

if ( empty($poll_id) ) {
    if ( $sysConfig['startpage'] == $module_dir ) {
        $sysOption['show_rblock'] = true;
        include_once(SYS_ROOT_PATH."/include/header.php");
        $module_template -> setOutputVar('center_blocks', makeCBlock());
    } else {
        $sysOption['show_rblock'] = false;
        include_once(SYS_ROOT_PATH."/include/header.php");
    }
    
    $module_template->setSwitch('showResults', true);
    $limit = 50;
    if ( $sys_request['limit'] ) {
        $limit = intval($sys_request['limit']);
    }
    $start = 0;
    if ( $sys_request['start'] ) {
        $start = intval($sys_request['start']);
    }
    
    // add 1 to $limit to know whether there are more polls
    $polls_arr =& SysPoll::getAll(array(), true, "weight ASC, end_time DESC", $limit+1, $start);
    $polls_count = count($polls_arr);
    if ( $polls_count > $limit ) {
        $max = $limit;
    } else {
        $max = $polls_count;
    }
    for ( $i = 0; $i < $max; $i++ ) {
        if ( $polls_arr[$i]->getVar("end_time") > time() ) {
            $end = formatTimestamp($polls_arr[$i]->getVar("end_time"),"m");
        } else {
            $end = "<span style='color:#ff0000;'>"._PL_EXPIRED."</span>";
        }
        $question_link = "<a href='index.php?poll_id=".$polls_arr[$i]->getVar("poll_id")."'>".$polls_arr[$i]->getVar("question")."</a>";
        $total_voters  = $polls_arr[$i]->getVar("voters");
        $total_votes   = $polls_arr[$i]->getVar("votes");
        $results_link  = "<a href='pollresults.php?poll_id=".$polls_arr[$i]->getVar("poll_id")."'>"._PL_RESULTS."</a>";
        $module_template->setOutputVarArray('results_loop', 'question_link', $question_link);
        $module_template->setOutputVarArray('results_loop', 'total_voters', $total_voters);
        $module_template->setOutputVarArray('results_loop', 'total_votes', $total_votes);
        $module_template->setOutputVarArray('results_loop', 'end', $end);
        $module_template->setOutputVarArray('results_loop', 'results_link', $results_link);
    }
    /**
     * Show NavBar
     */
    include_once(SYS_ROOT_PATH.'/class/syspagenav.php');
    $nav = new SysPageNav($polls_count, $limit, $start);
    $module_template->setOutputVar('navbar', $nav->renderNav());

} elseif ( $sys_request['option_id'] ) {
    $voted_polls = array();
    if ( $sys_request['voted_polls'] ) {
        $voted_polls = $sys_request['voted_polls'];
    }
    $mail_author = false;
    $poll = new SysPoll($poll_id);
    if ( !$poll->hasExpired() ) {
        if ( empty($voted_polls[$poll_id]) ) {
            if ( $sysUser ) {
                if ( SysPollLog::hasVoted($poll_id, _REMOTE_ADDR, $sysUser->getVar("uid")) ) {
                    $msg = _PL_ALREADYVOTED;
                } else {
                    $poll->vote($sys_request['option_id'], _REMOTE_ADDR, $sysUser->getVar("uid"));
                    $poll->updateCount();
                    $msg = _PL_THANKSFORVOTE;
                }
            } elseif ( SysPollLog::hasVoted($poll_id, _REMOTE_ADDR) ) {
                $msg = _PL_ALREADYVOTED;
            } else {
                $poll->vote($sys_request['option_id'], _REMOTE_ADDR);
                $poll->updateCount();
                $msg = _PL_THANKSFORVOTE;
            }
            cookie("voted_polls[$poll_id]", 1, 31536000);
        } else {
            $msg = _PL_ALREADYVOTED;
        }
    } else {
        $msg = _PL_SORRYEXPIRED;
        if ( $poll->getVar("mail_status") != POLL_MAILED ) {
            $sysMailer =& getMailer();
            $sysMailer->useMail();
            $sysMailer->setTemplateDir(SYS_MOD_PATH.$sysModule->dirname());
            $sysMailer->setTemplate("mail_results.tpl");
            $author = new SysUser($poll->getVar("user_id"));
            $sysMailer->setToUsers($poll->getVar("uid"));
            $sysMailer->assign("POLL_QUESTION", $poll->getVar("question"));
            $sysMailer->assign("POLL_START", formatTimestamp($poll->getVar("start_time"), "l", $author->timezone()));
            $sysMailer->assign("POLL_END", formatTimestamp($poll->getVar("end_time"), "l", $author->timezone()));
            $sysMailer->assign("POLL_VOTES", $poll->getVar("votes"));
            $sysMailer->assign("POLL_VOTERS", $poll->getVar("voters"));
            $sysMailer->assign("POLL_ID", $poll->getVar("poll_id"));
            $sysMailer->assign("SITENAME", $meta['title']);
            $sysMailer->assign("ADMINMAIL", $sysConfig['adminmail']);
            $sysMailer->assign("SITEURL", $sysConfig['SYS_ROOT_URL']."/");
            $sysMailer->setFromEmail($sysConfig['adminmail']);
            $sysMailer->setFromName($meta['title']);
            $sysMailer->setSubject(sprintf(_PL_YOURPOLLAT, $author->uname(), $meta['title']));
            if ( $sysMailer->send() != false ) {
                $poll->setVar("mail_status", POLL_MAILED);
                $poll->store();
            }
        }
    }
    redirectHeader(SYS_MOD_URL."/".$sysModule->dirname()."/pollresults.php?poll_id=$poll_id", 1, $msg);
    exit();

} elseif ( $poll_id ) {
    include_once(SYS_ROOT_PATH."/include/header.php");
    $poll     = new SysPoll($poll_id);
    $renderer = new SysPollRenderer($poll);
    $module_template->setSwitch('showPoll', true);
    $module_template->setOutputVar('render_poll', $renderer->renderForm('160'));
}
$module_template->setOutputVar('mod_footer', "Ciamos Poll module");
include_once(SYS_ROOT_PATH."/include/footer.php");
?>
