<?php
/**
 * File: $Id: blocksadmin.php,v 1.44 2005/09/06 12:17:52 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

/**
 * Check if the user is authorised
 */
if ( !$sysUser->isAdmin($sysModule->mid()) ) {
    redirect_header(SYS_ROOT_URL."/index.php", 2, _NOPERM, 0, 3);
    //echo "Access Denied";
    //return;
}

$side_array = array(
    BLOCK_ABSOLUTETOP       =>_BK_ATOP,
    SYS_SIDEBLOCK_LEFT      =>_BK_SBLEFT,
    SYS_SIDEBLOCK_RIGHT     =>_BK_SBRIGHT,
    SYS_CENTERBLOCK_LEFT    =>_BK_CBLEFT,
    SYS_CENTERBLOCK_CENTER  =>_BK_CBRIGHT,
    SYS_CENTERBLOCK_RIGHT   =>_BK_CBCENTER,
    BLOCK_ABSOLUTEBOTTOM    =>_BK_ABOTTOM );
$ctype_array = array ('H' => _BK_HTML, 'P' => _BK_PHP, 'S' => _BK_AFWSMILE, 'T' => _BK_AFNOSMILE);

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function listBlocks()
{
    global $sysUser, $side_array, $ctype_array;
    
    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    $table_array = array();
    $table_array[0]['desc']     = new SysFormLabel('', _BK_BLKDESC);
    $table_array[0]['module']   = new SysFormLabel('', 'Module');
    $table_array[0]['title']    = new SysFormLabel('', _TITLE);
    $table_array[0]['side']     = new SysFormLabel('', _BK_SIDE);
    $table_array[0]['design']   = new SysFormLabel('', _BK_DESIGN);
    $table_array[0]['weight']   = new SysFormLabel('', _WEIGHT);
    $table_array[0]['visible']  = new SysFormLabel('', _BK_VISIBLE);
    $table_array[0]['action']   = new SysFormLabel('', _ACTION);
    $table_array[0]['hidden']   = new SysFormLabel('', '');
    
    $blockside_array = array(
        BLOCK_ABSOLUTETOP   =>"<strong>"._BK_ABSOLUTETOPBADMIN."</strong>",
        SYS_SIDEBLOCK_LEFT  =>"<strong>"._BK_LSIDEBADMIN."</strong>",
        SYS_CENTERBLOCK_ALL =>"<strong>"._BK_CENTERBADMIN."</strong>",
        SYS_SIDEBLOCK_RIGHT =>"<strong>"._BK_RSIDEBADMIN."</strong>",
        BLOCK_ABSOLUTEBOTTOM=>"<strong>"._BK_ABSOLUTEBOTTOMBADMIN."</strong>" );
        
    foreach ( $blockside_array as $side => $title ) {
        $table_array[] = new SysFormLabel('', $title, true);
        $arr =& SysBlock::getAllBlocks("object", $side, NULL, " side ASC, visible DESC, weight ASC");
        foreach ( $arr as $ele ) {
            $table_array[] = showBlockAdmin($ele);
        }
    }

    $form = new SysThemeForm(_BK_BADMIN, 'blocksadmin', 'admin.php');
    $form_array = array();
    
    $form_array[] = new SysFormElementTable('', $table_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('fct', 'blocksadmin');
    $form_array[] = new SysFormHidden('op', 'order');
    
    sysCpHeader();
    $form->display($form_array, true);

    /**
     * Show 'add a new block'
     */
    $form = new SysThemeForm(_BK_ADDBLOCK, 'addBlock', 'admin.php?fct=blocksadmin');
    $form_array = array();
    
    $form_array[] = new SysFormSelect(_BK_BLKTYPE, 'block[side]', '', 1, false, $side_array);
    $form_array[] = new SysFormSelect(_BK_DESIGN, 'block[design]', '', 1, false, getDesign());
    $form_array[] = new SysFormText(_WEIGHT, 'block[weight]', 2, 2);
    $form_array[] = new SysFormCheckBox(_BK_VISIBLE, 'block[visible]', '1', array(1=>'&nbsp'));
    $form_array[] = new SysFormText(_TITLE, 'block[title]', 60, 60);
    $form_array[] = new SysFormTextArea(_CONTENT, 'block[content]', '', 10, 60);
    $form_array[] = new SysFormLabel(_BK_USEFULTAGS, sprintf(_BK_BLOCKTAG1, "{X_SITEURL}", SYS_ROOT_URL."/"));
    $form_array[] = new SysFormSelect(_BK_CTYPE, 'block[ctype]', 'T', 1, false, $ctype_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'save');
        
    $form->display($form_array, true);
    sysCpFooter();
}

/**
 * Enter description here...
 *
 * @return array 
 */
function getDesign()
{
    $dir = SYS_ROOT_PATH."/themes/".getTheme()."/blocks/custom/";
    $handle = opendir($dir);
    $values = array();
    array_push($values, 'standard');
    while ( false !== ($file = readdir($handle)) ) {
        if ( @is_file($dir.$file) ) {
            $path_part = pathinfo($dir.$file);
            $extension = $path_part["extension"];
            $tplext = ".tpl";
            $filename = basename ($file, ".$extension");
            if ( ".$extension" == $tplext ) {
                array_push($values, $filename);
            }
        }
    }
    closedir($handle);
    return $values;
}

/**
 * Enter description here...
 *
 * @param unknown_type $ele
 * @return unknown
 */
function showBlockAdmin($ele)
{
    global $side_array;
    
    $sysModule = new SysModule($ele->getVar("mid"));
    $module = $sysModule->dirname();
    $bid = $ele->getVar('bid');
    $title = "&nbsp;";
    if ( $ele->getVar("title") != "" ) {
        $title = $ele->getVar("title");
    }

    $visible = (string) $ele->getVar('visible');
    $action = "<a href='admin.php?fct=blocksadmin&amp;op=edit&amp;bid=".$ele->getVar("bid")."'>
        <img src='".SYS_ROOT_URL."/images/editor/edit.gif' alt='"._EDIT."' border='0' /></a>";
    if ( $ele->isCustom() ) {
        $action .= "&nbsp;<a href='admin.php?fct=blocksadmin&amp;op=delete&amp;bid=".$ele->getVar("bid")."'>
            <img src='".SYS_ROOT_URL."/images/editor/delete.gif' alt='"._DELETE."' border='0' /></a>";
    }
    $hidden_array = array();
    $hidden_array[] = new SysFormHidden("block[$bid][old][side]", $ele->getVar('side'));
    $hidden_array[] = new SysFormHidden("block[$bid][old][weight]", $ele->getVar('weight'));
    $hidden_array[] = new SysFormHidden("block[$bid][old][visible]", $ele->getVar('visible'));
    $hidden_array[] = new SysFormHidden("block[$bid][old][design]", $ele->getVar('design'));
    $hidden_array[] = new SysFormHidden("block[$bid][bid]", $bid);
    
    $block_array[$bid]['desc']    = new SysFormLabel('', $ele->getVar("name"));
    $block_array[$bid]['module']  = new SysFormLabel('', $module);
    $block_array[$bid]['title']   = new SysFormLabel('', $title);

    $block_array[$bid]['side']    = new SysFormSelect('', "block[$bid][new][side]", 
        (string)$ele->getVar('side'), 1, false, $side_array );
        
    $block_array[$bid]['design']  = new SysFormSelect('', "block[$bid][new][design]", 
        $ele->getVar('design'), 1, false, getDesign());

    $block_array[$bid]['weight']  = new SysFormText('', "block[$bid][new][weight]", 2, 2, $ele->getVar('weight'));
    $block_array[$bid]['visible'] = new SysFormCheckBox('', "block[$bid][new][visible]", $visible, array('1'=>'&nbsp;'));
    $block_array[$bid]['action']  = new SysFormLabel('', $action);
    $block_array[$bid]['hidden']  = new SysFormElementTray('', '', $hidden_array);
    
    return $block_array[$bid];
}
/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function saveBlock($block)
{
    if ( !$block['visible'] ) {
        $block['visible'] = '0';
    }
    $myblock = new SysBlock();
    $myblock->setVar("side",    $block['side']);
    $myblock->setVar("weight",  $block['weight']);
    $myblock->setVar("visible", $block['visible']);
    $myblock->setVar("weight",  $block['weight']);
    $myblock->setVar("title",   $block['title']);
    $myblock->setVar("content", $block['content']);
    $myblock->setVar("c_type",  $block['c_type']);
    $myblock->setVar("type",    "C");
    $myblock->setVar("design",  $block['design']);

    switch ( $bctype ) {

        case 'H':
        $name = _BK_CUSTOMHTML;
        break;

        case 'P':
        $name = _BK_CUSTOMPHP;
        break;

        case 'S':
        $name = _BK_CUSTOMSMILE;
        break;

        case 'T':
        default:
        $name = _BK_CUSTOMNOSMILE;
        break;
    }
    $myblock->setVar("name", $name);

    if ( !$myblock->storeBlock() ) {
        sysCpHeader();
        echo $myblock->getErrors();
        sysCpFooter();
        exit();
    }
    redirectHeader("admin.php?fct=blocksadmin", 1, _UPDATED);
    exit();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function editBlock($bid, $block)
{
    global $myts, $sys_request, $side_array, $ctype_array;
    
    $myblock = new SysBlock($bid);
    
    /**
     * Show preview
     */
    if ( $sys_request['preview'] ) {
        $btitle   = $myts->oopsStripSlashesGPC($block['title']);
        $bcontent = $myts->oopsStripSlashesGPC($block['content']);

        $myblock->setVar("title",    $block['title']);
        $myblock->setVar("content",  $block['content']);
        $myblock->setVar("c_type",   $block['c_type']);
        $myblock->setVar("position", $block['position']);
        $myblock->setVar("design",   $block['design']);

        if ( isset($block['options']) && (count($lock['options']) > 0) ) {
            $options = implode("|", $lock['options']);
            $myblock->setVar("options", $options);
        }

        $block = $myblock->buildBlock($myblock);
        /*readfile(SYS_MOD_PATH .'/system/cache/header.php');
        $themecss = getCss(getTheme());
        $htmlhead = "<link rel='stylesheet' media='all' href='".$themecss."' type='text/css' />\n";*/
        $preview = "<div class='FormTitle'>"._BK_BPREVIEW."</div>
            <!--<div class='leftside'>
            <div style='border:1px solid #dddddd; padding:8px; margin-bottom:6px;'>-->
            <table cellpadding='3' cellspacing='3' 
                style='border:1px solid #dddddd; padding:6px; margin-bottom:6px;'>
                <tr>
                    <td class='bg2'><!--<div class='BlockTitle'>--><strong>".$block['title']."</strong><!--</div>--></td>
                </tr>
                <tr>
                    <td class='bg1'><!--<div class='BlockContent'>-->".$block['content']."<!--</div>--></td>
                </tr>
            </table>
            <!--</div>
            </div>
            <br />-->";
    }
    /**
     * Edit block
     */
    $mods_array = SysModule :: getAllModulesList();
    $mods_array['sys'] = _SYSTEM_PAGES;
    if ( $myblock->getVar('vis_mod') == 'ALL' ) {
        $value_array = $mods_array;
    } else {
        $value_array = explode('|', $myblock->getVar('vis_mod'));
    }
    
    $form_title = "<a href='".SYS_MOD_URL."/system/admin.php?fct=blocksadmin'>"._EDIT."</a>: " ._BK_EDITBLOCK;

    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    $form = new SysThemeForm($form_title, 'editBlock', 'admin.php?fct=blocksadmin');
    $form_array = array();
    
    $form_array[] = new SysFormLabel(_NAME, $myblock->getVar('name'));
    $form_array[] = new SysFormHidden('name', $myblock->getVar('name'));
    $form_array[] = new SysFormSelect(_BK_BLKTYPE, 'block[side]', 
        $myblock->getVar('side'), 1, false, $side_array);
    $form_array[] = new SysFormSelect(_BK_DESIGN, 'block[design]', 
        $myblock->getVar('design'), 1, false, getDesign());
    $form_array[] = new SysFormText(_WEIGHT, 'block[weight]', 2, 2, 
        $myblock->getVar('weight'));
    $form_array[] = new SysFormCheckBox(_BK_VISIBLE, 'block[visible]', 
        $myblock->getVar('visible'), array(1=>'&nbsp'));
    $form_array[] = new SysFormSelect(_BK_VIS_MODULES, 'block[vismods]', 
        $value_array, 5, true, $mods_array);
    $form_array[] = new SysFormText(_TITLE, 'block[title]', 60, 60, 
        $myblock->getVar('title', 'E'));
    $form_array[] = new SysFormTextArea(_CONTENT, 'block[content]', 
        $myblock->getContent("E"), 10, 60);
    $form_array[] = new SysFormLabel(_BK_USEFULTAGS, 
        sprintf(_BK_BLOCKTAG1, "{X_SITEURL}", SYS_ROOT_URL."/"));
    $form_array[] = new SysFormSelect(_BK_CTYPE, 'block[c_type]',
        $myblock->getVar('c_type'), 1, false, $ctype_array);
        
    if ( !$myblock->isCustom() ) {
        $form_array[] = new SysFormSelect(_BK_POSCONTT, 'block[position]', 
            $myblock->getVar("position"), 1, false, array('0'=>_BK_ABOVEORG, '1'=>_BK_AFTERORG));
    }
    $edit_form = $myblock->getOptions();
    if ( $edit_form ) {
        $form_array[] = new SysFormLabel(_OPTIONS, $edit_form);
    }

    $form_array[] = new SysFormButtonTray(true);
    $form_array[] = new SysFormHidden('bid', $myblock->getVar('bid'));
    $form_array[] = new SysFormHidden('op', 'edit');

    sysCpHeader();
    if ( $preview) {
        echo $preview;
    }
    $form->display($form_array, true);
    sysCpFooter();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function updateBlock($bid, $block)
{
    global $db, $myts, $sys_request;

    $myblock = new SysBlock($bid);
    $name    = $sys_request['name'];
    $myblock->setVar("side",     $block['side']);
    $myblock->setVar("weight",   $block['weight']);
    $myblock->setVar("position", $block['position']);
    $myblock->setVar("visible",  $block['visible']);
    $myblock->setVar("weight",   $block['weight']);
    $myblock->setVar("title",    $block['title']);
    $myblock->setVar("content",  $block['content']);
    $myblock->setVar("design",   $block['design']);
    //implode couldnt accept unset arrays
    if (!isset($block['vismods'])) {
        $block['vismods'] = array();
    }
    $myblock->setVar("vis_mod", implode('|',$block['vismods']));

    if ( isset($block['options']) && (count($block['options']) > 0) ) {
        $options = implode("|", $block['options']);
        $myblock->setVar("options", $options);
    }

    $myblock->setVar("c_type", $block['c_type']);

    switch ( $block['c_type'] ) {
        case "H":
        if ( !isset($name) ) {
            $name = _BK_CUSTOMHTML;
        }
        break;

        case "P":
        if ( !isset($name) ) {
            $name = _BK_CUSTOMPHP;
        }
        break;

        case "S":
        if ( !isset($name) ) {
            $name = _BK_CUSTOMSMILE;
        }
        break;

        default:
        if ( !isset($name) ) {
            $name = _BK_CUSTOMNOSMILE;
        }
        break;
    }
    $sql = "
        UPDATE ".$db->prefix('newblocks')."
            SET name = '$name'
            WHERE bid = $bid";
    $db->query($sql);

    $myblock->storeBlock();
    redirectHeader("admin.php?fct=blocksadmin&op=edit&bid=$bid", 1, _UPDATED);
    exit();
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function delBlock($bid)
{
    $myblock = new SysBlock($bid);
    if ( $myblock->getVar("type") == "S" ) {
        $message = _BK_SYSTEMCANT;
        redirectHeader("admin.php?fct=blocksadmin", 4, $message);
        exit();
    } elseif ($myblock->getVar("type") == "M") {
        $message = _BK_MODULECANT;
        redirectHeader("admin.php?fct=blocksadmin", 4, $message);
        exit();
    } else {
        sysCpHeader();
        echo "<h4 style='text-align:left;'>".sprintf(_BK_RUSUREDEL, $myblock->getVar("title"))."</h4>";
        echo "<table><tr><td>";
        echo myTextForm("admin.php?fct=blocksadmin&op=delete_ok&bid=".$myblock->getVar("bid") , _YES);
        echo "</td><td>";
        echo myTextForm("admin.php?fct=blocksadmin" , _NO);
        echo "</td></tr></table>";
        sysCpFooter();
    }
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function delBlockOk($bid)
{
    $myblock = new SysBlock($bid);
    $myblock->delete();
    redirectHeader("admin.php?fct=blocksadmin", 1, _UPDATED);
    exit();
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function orderBlocks($bid, $block)
{
    $myblock = new SysBlock($bid);
    
    $myblock->setVar("weight",  $block['weight']);
    $myblock->setVar("visible", $block['visible']);
    $myblock->setVar("side",    $block['side']);
    $myblock->setVar("design",  $block['design']);
    $myblock->storeBlock();
}
?>
