<?php
/**
 * File: $Id: functions.php,v 1.1 2005/06/05 18:41:14 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @Author: Half-Dead
 *
 * @licence : Proprietary
 *
 */

function buildData($result)
{
    global $meta;

    /**
     * Data to build the keywords from
     */
    $meta_text  = $result["title"] . ",";
    $meta_text .= $result["keywords"] . ",";
    $meta_text .= $meta['title'] . ",";
    $meta_text .= $meta['slogan'] . ",";
    $meta_text .= $meta['keywords'] . ",";
    $meta_text .= $meta['description'];

    /**
     * Remove html tags & "
     */
    $htmlless = strip_tags($meta_text);
    $htmlless = str_replace('"', "", $htmlless);

    /**
     * Convert all html characters back to acii characters
     */
    $trans    = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
    $trans    = array_flip($trans);
    $htmlless = strtr($htmlless, $trans);

    // Find this:
    $search = array(
        "/[^\x30-\x39\x41-\x5A\x61-\x7A\xC0-\xFF_'-]/",
        "/--/",
        "/__/",
        "/\s+/",
        "/ (.{1,3}),/",
        "/(, )$/" );

    // And replace with this:
    $replace = array(
        " ",
        "",
        "",
        ", ",
        "",
        "" );

    // Search n replace the above
    $metatags = preg_replace($search, $replace, $htmlless);

    // Put words into an array
    $metatags = explode(", ", strtolower($metatags));

    // Grab the wanted/unwanted list
    include_once(SYS_MOD_PATH . "/system/cache/unwanted.php");
    include_once(SYS_MOD_PATH . "/system/cache/wanted.php");

    // Remove unwanted words
    $metatags = array_diff($metatags, $unwanted);

    // Add wanted keywords to the array
    $metatags = array_merge((array)$wanted, (array)$metatags);

    // Remove all doubles from the array
    $metatags = array_unique($metatags);

    // Shuffle the words in the array
    shuffle($metatags);

    // Reduce the array to the maximum no. of allowed keywords.
    while (count($metatags) > $meta["max_words"]) {
        array_pop($metatags);
    }

    // Put the array back into a string
    $metatags = implode(", ", $metatags);

    // Fixes a lil slip
    $metatags = preg_replace("/, , /", ", ", $metatags);

    // And build the actual title/meta tags
    return ucwords($metatags);
}

global $sys_request, $sysModule;

/**
 * See if a module dir is set & if so which
 */
if ( !empty($sysModule) ) {
    $module_dir = $sysModule->dirname() . "/";
    $path = SYS_MOD_PATH . "/system/admin/metagenerator/include/extractors/".$module_dir;
    if ( @is_dir($path) ) {
        // See if that modules extractors directory has any exctraction plugins
        if ( $handle = @opendir($path) ) {
            while ( false !== ($file = readdir($handle)) ) {
                if ( $file != "." && $file != ".." ) {
                    $extractors[] = preg_replace("/\.php/i", "", $file);
                }
            }
            closedir($handle);
        }
        /**
         * If we found any plugins, we see if a matching variable was set, and process the data if so.
         */
        foreach ( $extractors as $value ) {
            if ( isset($sys_request["$value"]) ) {
                if ( @is_file(SYS_MOD_PATH . "/system/admin/metagenerator/include/extractors/".$module_dir.$value.".php") ) {
                    include_once(SYS_MOD_PATH . "/system/admin/metagenerator/include/extractors/".$module_dir.$value.".php");
                    $result = get_meta($sys_request["$value"], $meta['max_depth']);

                    // echo "Found file: $value.php";
                    /**
                     * The actual keywords & title, 
                     * if buil_data returns a emtpty data, we use the defaut one.
                     */
                    $meta['keywords'] = buildData($result);
                    $meta['title']    = $meta['title'] . ": " . $result["title"];
                }
                break;
            }
        }
    }
}
?>
