<?php
/**
 * File: $Id: main.php,v 1.25 2005/05/13 20:06:32 alphalogic Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( !preg_match("/admin\.php/i", _PHP_SELF) ) {
    exit();
}

global $sys_request, $sysHandler, $sysModule, $sysSecurity, $sysUser;

if ( !$sysUser->isAdmin($sysModule->mid()) ) {
   $sysHandler['security']->showSecurityERR(SYS_ROOT_URL.'/', 2, _NOPERM);
}

include_once(SYS_MOD_PATH."/system/admin/modulesadmin/modulesadmin.php");

switch ( $sys_request['op'] ) {

    case "confirm":
    
    $error = array();
    if ( @!is_writable(SYS_MOD_PATH."/system/cache/adminmenu.php") ) {
        if ( @!chmod(SYS_MOD_PATH."/system/cache/adminmenu.php", 0666) ) {
            $error[] = sprintf(_MUSTWABLE, "<b>".SYS_MOD_PATH."/system/cache/adminmenu.php</b>");
        }
    }
    if ( count($error) > 0 ) {
        $return  = "";
        foreach ( $error as $er ) {
            $return .= $er."<br />";
        }
        $return .= "<p><a href='admin.php?fct=modulesadmin'>"._MD_BTOMADMIN."</a></p>";
        sysCpHeader();
        openTable();
        echo $return;
        closeTable();
        sysCpFooter();
        exit();
    }
    /**
     * Build module admin confirmation table
     */
    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    
    $table_array[-1][] = new SysFormLabel('', _MD_MODULE);
    $table_array[-1][] = new SysFormLabel('', _ACTION);
    $table_array[-1][] = new SysFormLabel('', _MD_ORDER);
    
    $size = count($module);
    for ( $i = 0 ; $i < $size; $i++ ) {
        if ( $newstatus[$i] != "nochange" ) {
            switch ( $newstatus[$i] ) {
                
                case "deactivate":
                $statustext = _DEACTIVATE;
                break;
                
                case "activate":
                $statustext = _ACTIVATE;
                break;
                
                case "install":
                $statustext = _INSTALL;
                break;
                
                case "uninstall":
                $statustext = _UNINSTALL;
                break;
                
                case "update":
                $statustext = _UPDATE;
                break;
            }
            $statustext = "<span style='color:#ff0000;font-weight:bold;'>".$statustext."</span>";
        } else {
            $statustext = _MD_NOCHANGE;
        }
        if ( $statustext != _MD_NOCHANGE || $oldweight[$i] != $weight[$i] || $weight[$i] == "" ) {
            $table_array[$i][] = new SysFormLabel('', $name[$i]);
            $table_array[$i][] = new SysFormLabel('', $statustext);
            if ( $oldweight[$i] != $weight[$i] ) {
                $show_weight[$i] = "<span style='color:#ff0000;font-weight:bold;'>".$weight[$i]."</span>";
            } else {
                $show_weight[$i] = $weight[$i];
            }
            $table_array[$i][] = new SysFormLabel('', $show_weight[$i]);
            $table_array[$i][] = new SysFormHidden('module[]',    $module[$i]);
            $table_array[$i][] = new SysFormHidden('oldstatus[]', $oldstatus[$i]);
            $table_array[$i][] = new SysFormHidden('newstatus[]', $newstatus[$i]);
            $table_array[$i][] = new SysFormHidden('oldweight[]', $oldweight[$i]);
            $table_array[$i][] = new SysFormHidden('weight[]',    $weight[$i]);
        }
    }
    
    $form = new SysThemeForm(_MD_PCMFM, 'confirmModuleAdmin', 'admin.php');
    $form_array = array();
    $form_array[] = new SysFormElementTable('', $table_array, true);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('fct', 'modulesadmin');
    $form_array[] = new SysFormHidden('op', 'submit');
    
    sysCpHeader();
    $form->display($form_array, true);
    sysCpFooter();
    break;

    case "submit":

    $size  = count($newstatus);
    $ret   = array();
    $write = false;
    for ( $i = 0 ; $i < $size; $i++ ) {
        $reorder = true;
        switch ( $newstatus[$i] ) {
            case "install":
                $ret[] = installModule($module[$i]);
                $write = true;
                break;
            case "activate":
                $ret[] = activateModule($module[$i]);
                $write = true;
                break;
            case "deactivate":
                $ret[] = deactivateModule($module[$i]);
                $write = true;
                break;
            case "update":
                $ret[] = updateModule($module[$i]);
                $write = true;
                break;
            case "uninstall":
                $ret[] = uninstallModule($module[$i]);
                $reorder = false;
                $write = true;
                break;
            default:
                break;
        }
        if ( $oldstatus[$i] == 0 && $newstatus[$i] != "install" ) {
            $reorder = false;
        }
        if ( $reorder == true && $oldweight[$i] != $weight[$i] ) {
            $ret[] = orderModules($module[$i], $weight[$i]);
            $write = true;
        }
    }
    if ( $write ) {
        $contents = getModuleAdminMenu();
        if ( !writeModuleAdminMenu($contents) ) {
            $ret[] = "<p>"._MD_FAILWRITE."</p>";
        }
    }
    sysCpHeader();
    openTable();
    if ( count($ret) > 0 ) {
        foreach ( $ret as $msg ) {
            echo $msg;
        }
    }
    echo "<div><a href='admin.php?fct=modulesadmin'>"._MD_BTOMADMIN."</a></div>
          <div><a href='admin.php?fct=useradmin&amp;fct=group'>"._MD_EDITACCESS."</a></div>";

    closeTable();
    sysCpFooter();
    break;

    default:
    listModules();
    break;
}
?>
