<?php
/**
 * File: $Id: modulesadmin.php,v 1.25 2005/06/05 15:43:07 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( !$sysUser->isAdmin($sysModule->mid()) ) {
    redirectHeader(SYS_ROOT_URL."/", 3, _NOPERM);
}

/**
 * Description
 *
 */
function listModules()
{
    global $sysConfig, $sysUser, $db, $sysModule;
    
    include_once(SYS_ROOT_PATH."/class/sysformloader.php");
    
    $table_array[0]['title']    = new sysFormLabel('', _MD_MODULE);
    $table_array[0]['version']  = new sysFormLabel('', _VERSION);
    $table_array[0]['lastup']   = new sysFormLabel('', _MD_LASTUP);
    $table_array[0]['status']   = new sysFormLabel('', "Status");
    $table_array[0]['action']   = new sysFormLabel('', _ACTION);
    $table_array[0]['order']    = new sysFormLabel('', _MD_ORDER."<br /><small>"._MD_ORDER0."</small>");
    $table_array[0]['info']     = new sysFormLabel('', _INFO);
    
    $listed_mods    = array();
    $installed_mods =& SysModule::getInstalledModules();
    
    /**
     * List installed modules
     */
    foreach ( $installed_mods as $module ) {
        $mid = $module->mid();
        $open_a_tag  =  $close_a_tag = "";
        if ( $module->hasAdmin() && $module->isActivated() ) {
            $open_a_tag = "<a href='".SYS_MOD_URL."/".$module->dirname()."/".$module->adminindex()."'>";
            $close_a_tag = "</a>";
        }
        $table_array[$mid][] = new SysFormLabel('', "$open_a_tag".trim($module->name())."$close_a_tag");
        $table_array[$mid][] = new SysFormLabel('', $module->currentVersion());
        $table_array[$mid][] = new SysFormLabel('', formatTimestamp($module->last_update(),"m"));
        
        if ( ($module->dirname() == "system") || $module->isActivated() ) {
            $status = "<span style='color:#ff0000;'>"._ACTIVE."</span>";
        } else {
            $status = _INACTIVE;
        }
        $table_array[$mid][] = new SysFormLabel('', $status);

        if ( ($module->dirname() != "system") && $module->isActivated() ) {
            $action_array = array ('nochange' => _MD_NOCHANGE, 'update' => _UPDATE, 
                'deactivate' => _DEACTIVATE, 'uninstall' => _UNINSTALL);        
        } elseif ( $module->dirname() != "system" ) {
            $action_array = array ('nochange' => _MD_NOCHANGE, 'activate' => _ACTIVATE, 
                'update' => _UPDATE, 'uninstall' => _UNINSTALL); 
        } else {
            $action_array = array ('nochange' => _MD_NOCHANGE, 'update' => _UPDATE); 
        }
        $table_array[$mid][] = new SysFormSelect('', 'newstatus[]', 'nochange', 1, false, $action_array);
        
        if ( $module->hasMain() ) {
            $table_array[$mid][] = new SysFormText('', 'weight[]', 3, 3, $module->weight);
        } else {
            $table_array[$mid][] = new SysFormHidden('weight[]', '0');
        }
        
        $info = "<a href='javascript:openWithSelfMain(\"".SYS_MOD_URL."/system/admin.php?fct=version&amp;mid=$mid\",\"Info\",300,230);'>
                 <img src='".SYS_ROOT_URL."/images/editor/info.gif' alt='"._INFO."' /></a>";
        $table_array[$mid][] = new SysFormLabel('', $info);

        $table_array[$mid][] = new SysFormHidden('name[]', htmlspecialchars($module->name()));
        $table_array[$mid][] = new SysFormHidden('oldstatus[]', 1);
        
        if ( $module->hasMain() ) {
            $weight = $module->weight();
        } else {
            $weight = 0;
        }
        $table_array[$mid][] = new SysFormHidden('oldweight[]', $weight);
        $table_array[$mid][] = new SysFormHidden('module[]', $module->dirname());
        $listed_mods[] = trim($module->dirname());
    }
    
    /**
     * List uninstalled modules
     */
    $modules_dir = SYS_MOD_PATH;
    $handle = opendir($modules_dir);
    $mid = 9000;

    while ( ($file = readdir($handle)) !== false ) {
        if ( @is_dir($modules_dir."/".$file) && @file_exists($modules_dir."/".$file."/version.php") ) {
            if ( !in_array(trim($file), $listed_mods) ) {
                $module = new SysModule();
                $module->loadModInfo($file);

                $table_array[$mid][] = new SysFormLabel('', trim($module->name()));
                $table_array[$mid][] = new SysFormLabel('', $module->currentVersion());
                $table_array[$mid][] = new SysFormLabel('', '---');
                $table_array[$mid][] = new SysFormLabel('', _MD_NOTINSTALLED);

                $action_array = array ('nochange' => _MD_NOCHANGE, 'install' => _INSTALL);
                $table_array[$mid][] = new SysFormSelect('', 'newstatus[]', 'nochange', 1, false, $action_array);

                if ( $module->hasMain() ) {
                    $table_array[$mid][] = new SysFormText('', 'weight[]', 3, 3, '0');
                } else {
                    $table_array[$mid][] = new SysFormHidden('weight[]', '0');
                }

                $info = "<a href='javascript:openWithSelfMain(\"".SYS_MOD_URL."/system/admin.php?fct=version&amp;mid=$mid\",\"Info\",300,230);'>
                    <img src='".SYS_ROOT_URL."/images/editor/info.gif' alt='"._INFO."' /></a>";
                $table_array[$mid][] = new SysFormLabel('', $info);
                $table_array[$mid][] = new SysFormHidden('name[]', htmlspecialchars($module->name()));
                $table_array[$mid][] = new SysFormHidden('oldstatus[]', 0);
                $table_array[$mid][] = new SysFormHidden('oldweight[]', 0);
                $table_array[$mid][] = new SysFormHidden('module[]', $module->dirname());

                unset($module);
                $mid++;    
            }
        }
    }
    
    $form = new SysThemeForm(_MD_MODADMIN, 'moduleadmin', 'admin.php');
    $form_array = array();
    
    $form_array[] = new SysFormElementTable('', $table_array, true);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('fct', 'modulesadmin');
    $form_array[] = new SysFormHidden('op', 'confirm');
    
    sysCpHeader();
    $form->display($form_array, true);
    sysCpFooter();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function installModule($module)
{
    global $sysConfig, $sysUser, $db;

    if ( !SysModule::moduleExists($module) ) {
        $mymodule = new SysModule();
        $mymodule->loadModInfo($module);
        $newmid   = $mymodule->install();
        //update the main menu cache

        if ( !$newmid ) {
            $ret  = "<p>".sprintf(_MD_FAILINS, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br />";
            $errs = $mymodule->errors();

            foreach ( $errs as $err ) {
                $ret .= " - ".$err."<br />";
            }

            $ret .= "</p>";
            return $ret;
        } else {
            $mymodule = new SysModule($newmid);
            $result   = $mymodule->update();
            $groups   = $sysUser->groups();

            // retrieve all block ids for this module
            $blocks =& SysBlock::getByModule($newmid, false);
            foreach ( $groups as $mygroup ) {
                if ( SysGroup::checkRight("module", 0, $mygroup, "A") ) {
                    $sql = "
                        INSERT
                            INTO ".$db->prefix("groups_modules_link")."
                            SET groupid = $mygroup, 
                                mid     = $newmid, 
                                type    = 'A'";
                    $db->query($sql);
                    $sql = "
                        INSERT
                            INTO ".$db->prefix("groups_modules_link")."
                            SET groupid = $mygroup, 
                                mid     = $newmid, 
                                type    = 'R'";
                    $db->query($sql);

                    foreach ( $blocks as $blc ) {
                        $sql = "
                            INSERT
                                INTO ".$db->prefix("groups_blocks_link")."
                                SET groupid  = $mygroup, 
                                    block_id = $blc, 
                                    type     = 'R'";
                        $db->query($sql);
                    }
                }
            }
            return "<p>".sprintf(_MD_OKINS, "<b>".$mymodule->name()."</b>")."</p>";
        }
    }
    return "<p>".sprintf(_MD_FAILINS, "<b>".$module."</b>")."&nbsp;"._ERROR.":<br /> - ".sprintf(_MD_ALEXISTS, $module)."</p>";
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function uninstallModule($module)
{
    global $sysConfig, $sys_request;

    $mymodule =& SysModule::getByDirname($module);

    if ( $mymodule->dirname() == "system" ) {
        $msg = "<p>".
        sprintf(_MD_FAILUNINS, "<b>".$mymodule->name()."</b>").
        "&nbsp;"._ERROR.":<br /> - "._MD_SYSNO."</p>";
        return $msg;

    } elseif ( $mymodule->dirname() == $sysConfig['startpage'] ) {
        $msg =  "<p>".
        sprintf(_MD_FAILUNINS, "<b>".$mymodule->name()."</b>").
        "&nbsp;"._ERROR.":<br /> - "._MD_STRTNO."</p>";
        return $msg;
    } else {
        if ( !$mymodule->uninstall() ) {
            $ret = "<p>".sprintf(_MD_FAILUNINS, "<b>".$mymodule->name()."</b>").
            "&nbsp;"._ERROR.":<br />";
            $errs = $mymodule->errors();
            foreach($errs as $err) {
                $ret .= " - ".$err."<br />";
            }
            return $ret."</p>";
        }
        return "<p>".sprintf(_MD_OKUNINS, "<b>".$mymodule->name()."</b>")."</p>";
    }
}


/**
 * @return string Success or failure message
 * @param integer $module Module ID
 * @desc Enter description here...
 */
function updateModule($module)
{
    global $sysConfig;
    
    $mymodule =& SysModule::getByDirname($module);
    $return = "<p>".sprintf(_MD_OKUPD, "<b>".$mymodule->name()."</b>")."</p>";
    if ( !$mymodule->update() ) {
        $return = "<p>".sprintf(_MD_FAILUPD, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br />";
        $errs = $mymodule->errors();
        foreach ( $errs as $err ) {
            $return .= " - ".$err."<br />";
        }
        $return .= "</p>";
    }
    return $return;
}

/**
 * Description
*
 * @param type $var description
 * @return type description
*/
function activateModule($module)
{
    global $sysConfig;
    
    $mymodule =& SysModule::getByDirname($module);
    $return = "<p>".sprintf(_MD_OKACT, "<b>".$mymodule->name()."</b>")."</p>";
    if ( !$mymodule->activate() ) {
        $return = "<p>".sprintf(_MD_FAILACT, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br />";
        $errs = $mymodule->errors();
        foreach ( $errs as $err ) {
            echo " - ".$err."<br />";
        }
        $return .= "</p>";
    }
    return $return;
}

/**
 * Description
*
 * @param type $var description
 * @return type description
*/
function deactivateModule($module)
{
    global $sysConfig;

    $mymodule =& SysModule::getByDirname($module);

    if ( $mymodule->dirname() == "system" ) {
        return "<p>".sprintf(_MD_FAILDEACT, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br /> - "._MD_SYSNO."</p>";
    } elseif ($mymodule->dirname() == $sysConfig['startpage']) {
        return "<p>".sprintf(_MD_FAILDEACT, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br /> - "._MD_STRTNO."</p>";
    } else {
        if ( !$mymodule->deactivate() ) {
            $ret = "<p>".sprintf(_MD_FAILDEACT, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br />";
            $errs = $mymodule->errors();
            foreach ( $errs as $err ) {
                $ret .= " - ".$err."<br />";
            }
            return $ret."</p>";
        }
        return "<p>".sprintf(_MD_OKDEACT, "<b>".$mymodule->name()."</b>")."</p>";
    }
}

/**
 * Description
*
 * @param type $var description
 * @return type description
*/
function orderModules($module, $order)
{
    global $sysConfig;

    if ( $mymodule = SysModule::getByDirname($module) ) {
        if ( !$mymodule->changeOrder($order) ) {
            $ret = "<p>".sprintf(_MD_FAILORDER, "<b>".$mymodule->name()."</b>")."&nbsp;"._ERROR.":<br />";
            $errs = $mymodule->errors();
            foreach ( $errs as $err ) {
                $ret .= " - ".$err."<br />";
            }
            return $ret."</p>";
        }
        return "<p>".sprintf(_MD_OKORDER, "<b>".$mymodule->name()."</b>")."</p>";
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function getModuleAdminMenu()
{
    /**
     * Based on:
     * - PHP Layers Menu 1.0.7(c)2001,2002 Marco Pratesi <pratesi@telug.it>
     * - TreeMenu 1.1 - Bjorge Dijkstra <bjorge@gmx.net>
     */
    $abscissa_step   = 90;    // step for the left boundaries of layers
    $abscissa_offset = 15;    // to choose the horizontal coordinate start offset for the layers
    $rightarrow      = "";
    /*
     * the following is to support browsers not detecting the mouse position
     */
    $ordinata_step = 15;    // estimated value of the number of pixels between links on a layer
    $ordinata[1]   = (150-$ordinata_step);// to choose the vertical coordinate start offset for the layers

    $moveLayers      = array();
    $shutdown        = array();
    $firstleveltable = array();

    /**
     * read file to $tree array
     * tree[x][0] -> tree level
     * tree[x][1] -> item text
     * tree[x][2] -> item link
     * tree[x][3] -> link target
     * tree[x][4] -> module id
     */
    $js       = "";
    $maxlevel = 0;
    $cnt      = 1;
    $mids     =& SysModule::getHasAdminModulesList(false);
    foreach ($mids as $mid) {
        $mod       = new SysModule($mid);
        $adminmenu = $mod->getAdminMenu();
        if ( !empty($adminmenu) || $mod->adminindex() ) {
            $tree[$cnt][0] = 1;
            $tree[$cnt][5] = "<img src='\".SYS_MOD_URL.\"/".$mod->dirname()."/".$mod->image()."' />";
            $tree[$cnt][1] .= $mod->name();
            $tree[$cnt][2] = "\".SYS_MOD_URL.\"/".$mod->dirname()."/".$mod->adminindex();
            $tree[$cnt][3] = "";
            $tree[$cnt][4] = $mid;
            $tree[$cnt][6] = "<b>"._VERSION.":</b> ".$mod->currentVersion()."<br /><b>"._DESCRIPTION.":</b> ".$mod->description()."";
            $layer_label[$cnt] = "L" . $cnt;
            if ( $tree[$cnt][0] > $maxlevel ) {
                $maxlevel = $tree[$cnt][0];
            }
            $cnt++;
            if ( !empty($adminmenu) ) {
                foreach ( $adminmenu as $menuitem ) {
                    $menuitem['link'] = trim($menuitem['link']);
                    $menuitem['target'] = trim($menuitem['target']);
                    $tree[$cnt][0] = 2;
                    $tree[$cnt][1] = trim($menuitem['title']);
                    $tree[$cnt][2] = (empty($menuitem['link'])) ? "#" : "\".SYS_MOD_URL.\"/".$mod->dirname()."/".$menuitem['link'];
                    $tree[$cnt][3] = (empty($menuitem['target'])) ? "" : $menuitem['target'];
                    $tree[$cnt][4] = $mid;
                    $layer_label[$cnt] = "L" . $cnt;
                    if ($tree[$cnt][0] > $maxlevel) {
                        $maxlevel = $tree[$cnt][0];
                    }
                    $cnt++;
                }
            }
        }
    }
    $tmpcount = count($tree);
    $tree[$tmpcount+1][0] = 0;
    for ( $i = 0; $i < $maxlevel; $i++) {
        $abscissa[$i] = $i  * $abscissa_step + $abscissa_offset;
    }
    // this counter scans all nodes
    for ( $cnt = 1; $cnt <= $tmpcount; $cnt++) {
        // assign the layers name to the current hierarchical level,
        // to keep trace of the route leading to the current node on the tree
        $layername[$tree[$cnt][0]] = $layer_label[$cnt];

        // assign the starting vertical coordinates for all sublevels
        for ( $i = $tree[$cnt][0] + 1; $i < $maxlevel; $i++) {
            $ordinata[$i] = $ordinata[$i-1] + 1.5*$ordinata_step;
        }
        // increment the starting vertical coordinate for the current sublevel
        if ($tree[$cnt][0] < $maxlevel) {
            $ordinata[$tree[$cnt][0]] += $ordinata_step;
        }
        if ($tree[$cnt+1][0]>$tree[$cnt][0] && $cnt<$tmpcount) {
            // the node is not a leaf, hence it has at least a child
            // initialize the corresponding layer content trought a void string
            $layer[$layer_label[$cnt]] = "";
            // prepare the popUp function related to the children
            $js .= "\nfunction popUp" . $layer_label[$cnt] . "() {\n" . "shutdown();\n";
            $js .= "setleft('" . $layer_label[$cnt] . "'," . $abscissa[$tree[$cnt][0]] . ");\n";

            for ($i=1; $i<=$tree[$cnt][0]; $i++) {
                $js .= "popUp(\\\"" . $layername[$i] . "\\\", true);\n";
            }
            $js .= "}";

            // geometrical parameters are assigned to the new layer, related to the above mentioned children
            // $moveLayers[$tree[$cnt][4]] .= "setleft('" . $layer_label[$cnt] . "'," . $abscissa[$tree[$cnt][0]] . ");\n";
            $moveLayers[$tree[$cnt][4]] .= "settop('" . $layer_label[$cnt] . "'," . $ordinata[$tree[$cnt][0]] . ");";
            //$moveLayers[$tree[$cnt][4]] .= "setwidth('" . $layer_label[$cnt] . "'," . $abscissa_step . ");\n";
            // the new layer is accounted for in the shutdown() function
            $shutdown[$tree[$cnt][4]] .= "popUp('" . $layer_label[$cnt] . "', false);";
        }
        if ($tree[$cnt+1][0]>$tree[$cnt][0] && $cnt<$tmpcount) {
            // not a leaf
            $currentarrow = $rightarrow;
        } else {
            // a leaf
            $currentarrow = "";
        }
        /* */
        $currentlink = $tree[$cnt][2];
        /* */
        /*
        if ( $tree[$cnt+1][0] > $tree[$cnt][0] && $cnt < $tmpcount) {
        // not a leaf
        $currentlink = "#";
        } else {
        // a leaf
        $currentlink = $tree[$cnt][2];
        }
        */
        if ( $tree[$cnt][3] != "" ) {
            $currenttarget = " target='" . $tree[$cnt][3] . "'";
        } else {
            $currenttarget = "";
        }
        if ($tree[$cnt][0] > 1) {
            // the hierarchical level is > 1, hence the current node is not a child of the root node
            // handle accordingly the corresponding link, distinguishing if the current node is a leaf or not
            if ( $tree[$cnt+1][0] > $tree[$cnt][0] && $cnt < $tmpcount ) {    // not a leaf
            $onmouseover = " onMouseover='moveLayerY(\\\"" . $layer_label[$cnt] . "\\\", currentY) ; popUp" . $layer_label[$cnt] . "();";
            } else {    // a leaf
            $onmouseover = " onMouseover='popUp" . $layername[$tree[$cnt][0]-1] . "();";
            }
            $layer[$layername[$tree[$cnt][0]-1]] .= "<img src='\".SYS_ROOT_URL.\"/images/menu/pointer.gif' />&nbsp;<a href='" . $currentlink . "'" . $onmouseover . "'" . $currenttarget . ">" .$tree[$cnt][1]. "</a>" . $currentarrow . "<br />\n";
        } elseif ($tree[$cnt][0] == 1) {
            // the hierarchical level is = 1, hence the current node is a child of the root node
            // handle accordingly the corresponding link, distinguishing if the current node is a leaf or not
            if ($tree[$cnt+1][0]>$tree[$cnt][0] && $cnt<$tmpcount) {
                // not a leaf
                $onmouseover = " onMouseover='moveLayerY(\\\"" . $layer_label[$cnt] . "\\\", currentY) ; popUp" . $layer_label[$cnt] . "();";
            } else {
                // a leaf
                $onmouseover = " onMouseover='shutdown();";
            }
            $firstleveltable[$tree[$cnt][4]] .= "<a href='" . $currentlink . "'" . $onmouseover . "'" . $currenttarget . ">" . $tree[$cnt][5] . "</a>" . $currentarrow . "<br />";
        }
    }    // end of the "for" cycle scanning all nodes

    $cellpadding = 10;
    $width = $abscissa_step - $cellpadding;
    $menu_layers = "";
    for ( $cnt = 1; $cnt <= $tmpcount; $cnt++ ) {
        if (!($tree[$cnt+1][0]<=$tree[$cnt][0])) {
            $menu_layers .= "
                <div id='".$layer_label[$cnt]."' style='position: absolute; visibility: hidden; z-index:1000;'>
                <table border='0' cellpadding='0' cellspacing='0' width='".$abscissa_step."'><tr>
                <td class='bg2'>
                <table width='100%' border='0' cellpadding='4' cellspacing='1'><tr>
                <td class='bg3' align='center' nowrap='nowrap'><b>".$tree[$cnt][1]."</b></td>
                </tr><tr>
                <td class='bg1' nowrap='nowrap'>".$layer[$layer_label[$cnt]]."<br /></td>
                </tr><tr>
                <td class='bg3'>".$tree[$cnt][5]."<br /><small>".$tree[$cnt][6]."</small></td>
                </tr></table></td>
                </tr></table></div>\n";
        }
    }
    $menu_layers .= "<script type='text/javascript'>\n<!--\nmoveLayers();\nloaded = 1;\n// -->\n</script>\n";
    $content = "<"."?php\n";
    $content .= "\$sys_admin_menu_js = \"".$js."\";\n";
    foreach ( $moveLayers as $k => $v ){
        $content .= "\$sys_admin_menu_ml[$k] = \"".$v."\";\n";
    }
    foreach ( $shutdown as $k => $v ){
        $content .= "\$sys_admin_menu_sd[$k] = \"".$v."\";\n";
    }
    foreach ( $firstleveltable as $k => $v ){
        $content .= "\$sys_admin_menu_ft[$k] = \"".$v."\";\n";
    }
    $content .= "\$sys_admin_menu_dv = \"".$menu_layers."\";\n";
    $content .= "\n?".">";
    return $content;
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function writeModuleAdminMenu($content)
{
    $filename = SYS_MOD_PATH."/system/cache/adminmenu.php";

    if ( !$file = fopen($filename, "w") ) {
        echo "open file failed";
        return false;
    }

    if ( fwrite($file, $content) == -1 ) {
        echo "write file failed";
        return false;
    }

    fclose($file);
    return true;
}
?>
