<?php
/**
 * File: $Id: main.php,v 1.23 2005/04/08 11:12:03 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author vi0lat0r <@link http://www.ciamosbase.com>
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( !preg_match("/admin\.php/i", _PHP_SELF) ) {
    exit();
}

global $sys_request, $sysHandler, $sysModule, $sysSecurity, $sysUser;

if ( !$sysUser->isAdmin($sysModule->mid()) ) {
   $sysHandler['security']->showSecurityERR(SYS_ROOT_URL.'/', 2, _NOPERM);
   return;
}

include_once(SYS_ROOT_PATH.'/class/systree.php');
include_once(SYS_ROOT_PATH."/class/sysformloader.php");
include_once(SYS_ROOT_PATH."/class/syslists.php");

/**
 * Add a new Admin Note
 *
 */
function addNote()  
{
    global $db, $myts, $sysConfig;

    $form_array[]   = new SysFormText(_TITLE, 'title', 32, 254, _AN_TITLEHERE);
    $form_array[]   = new SysFormTextArea(_AN_NOTE, 'note', _AN_NOTEHERE, 6, 80);
    $form_array[]   = new SysFormButtonTray();
    $form_array[]   = new SysFormHidden('op', 'insert');

    $form = new SysThemeForm(_AN_ADD, 'add', './admin.php?fct=notes');

    $form->display($form_array, true);
}


/**
 * Show Admin Notes and Add Note form 
 *
 */
function displayNoteHome() 
{
    global $db, $myts, $sysConfig;

    $sql = "
        SELECT notes, title, nid 
            FROM ".$db->prefix("admin_notes");
    $result = $db->query($sql);

    $form_array = $table_array = array();
    $table_array[-1][] = new SysFormLabel('', _TITLE);
    $table_array[-1][] = new SysFormLabel('', _AN_NOTE);
    $table_array[-1][] = new SysFormLabel('', _ACTION);

    $form = new SysThemeForm(_AN_NAME, 'setName', 'admin.php?fct=notes');

    while( list($note, $title, $nid) = $db->fetch_array($result) ) {
        $action  = "<a href='admin.php?fct=notes&amp;op=edit&amp;nid=$nid'>
            <img src='".SYS_ROOT_URL."/images/editor/edit.gif' alt='"._EDIT."' border='0' /></a>";
        $action .= "&nbsp;<a href='admin.php?fct=notes&amp;op=delete&amp;nid=$nid'>
            <img src='".SYS_ROOT_URL."/images/editor/delete.gif' alt='"._DELETE."' border='0' /></a>";
        
        $table_array[$nid][] = new SysFormLabel('', $title);
        $table_array[$nid][] = new SysFormLabel('', $note);
        $table_array[$nid][] = new SysFormLabel('', $action);    
    }
    $form_array[] = new SysFormElementTable('', $table_array);
        
    $form->display($form_array, true);
    addNote();
    showNotesFooter();
}


/**
 * Edit an Admin Note
 *
 */
function editNote($nid)
{
    global $db, $myts, $sys_request, $sysConfig;
    
    $sql = "
        SELECT notes, title 
            FROM ".$db->prefix('admin_notes')."
            WHERE nid = $nid";
    $result = $db->query($sql);
    list($note, $title) = $db->fetch_array($result); 

    $form = new SysThemeForm(_AN_NAME, "add", "./admin.php?fct=notes&op=save");
    $form_array = array();
    
    $form_array[] = new SysFormText('Title:', 'title', 32, 254, $myts->makeTboxData4Edit($title));
    $form_array[] = new SysFormTextArea('Notes:', 'note', $myts->makeTboxData4Edit($note), 6, 80);
    $form_array[] = new SysFormHidden('nid', $nid);
    $form_array[] = new SysFormButtonTray();

    $form->display($form_array, true);
    showNotesFooter();
}

/**
 * Save an edited Admin Note
 *
 */
function updateNote()
{
    global $db, $sys_request, $myts, $sysConfig;

    $note  = $myts->makeTboxData4Save($sys_request["note"]);
    $title = $myts->makeTboxData4Save($sys_request["title"]);
    $nid   = $myts->makeTboxData4Save($sys_request["nid"]);
    $sql = "
        UPDATE ".$db->prefix('admin_notes')." 
            SET notes = '$note', 
                title = '$title'
            WHERE nid = '$nid'";
    $result = $db->query($sql);
    redirectHeader(SYS_MOD_URL.'/system/admin.php?fct=notes&op=home', 3, _AN_UPDATED);
    exit();
}

/**
 * Save a new Admin Note
 *
 */
function insertNote()
{
    global $db, $sys_request, $myts, $sysConfig;

    $note  = $myts->makeTboxData4Save($sys_request["note"]);
    $title = $myts->makeTboxData4Save($sys_request["title"]);
    $sql = "
        INSERT
            INTO ".$db->prefix("admin_notes")."
            SET notes = '$note',
                title = '$title'";
    $result = $db->query($sql);

    redirectHeader(SYS_MOD_URL.'/system/admin.php?fct=notes&op=home', 2, _AN_INSERTED);
    exit();
}

/**
 * Delete an Admin Note
 *
 */
function delNote()
{
    global $db, $sys_request, $myts, $sysConfig;

    $nid = $myts->makeTboxData4Save($sys_request["nid"]);
    $sql = "
        DELETE
            FROM ".$db->prefix("admin_notes")."
            WHERE nid ='$nid'";
    $result = $db->query($sql);
    redirectHeader(SYS_MOD_URL.'/system/admin.php?fct=notes&op=home', 2, _AN_DELETED);
    exit();
}

/**
 * Show Module Admin footer
 *
 */
function showNotesFooter()
{
    openTable();
    echo "
        <div>"._AN_NAME." &copy; 2005 
            <a href='http://www.ciamos.com' target='_blank'>Ciamos</a></div>";
    closeTable();
}

switch( $sys_request['op'] ) {

    case "add":
    sysCpHeader();
    addNote();
    sysCpFooter();
    break;

    case "edit":
    sysCpHeader();
    editNote($sys_request['nid']);
    sysCpFooter();
    break;

    case "delete":
    delNote();
    break;

    case "insert":
    insertNote();
    break;

    case "save":
    updateNote();
    break;

    default:
    sysCpHeader();
    displayNoteHome();
    sysCpFooter();
    break;
}

?>
