<?php
/**
 * File: $Id: search.php,v 1.19 2005/03/25 15:02:43 greyhead Exp $
 * Ciamos: Manages site search
 * Ciamos - Content Management System
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author The Xoops Project (@link http://www.xoops.org)
 */

$sysOption['pagetype'] = "search";

include_once("mainfile.php");
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

$action = isset($sys_request['action']) ? trim($sys_request['action'])  : "search";
$query  = isset($sys_request['query'])  ? trim($sys_request['query'])   : "";
$andor  = isset($sys_request['andor'])  ? trim($sys_request['andor'])   : "AND";
$start  = isset($sys_request['start'])  ? intval($sys_request['start']) : 0;
$mids   = isset($sys_request['mids'])   ? $sys_request['mids']          : array();
$mid    = isset($sys_request['mid'])    ? intval($sys_request['mid'])   : 0;
$uid    = isset($sys_request['uid'])    ? intval($sys_request['uid'])   : 0;

if ( empty($uid) ) {
    if ( $action == "results" && $query == "" ) {
        redirectHeader("search.php", 1, _SR_PLZENTER);
        exit();
    }
    if ( $action == "showall" && ($query == "" || empty($mid)) ) {
        redirectHeader("search.php", 1, _SR_PLZENTER);
        exit();
    }
}

if ( $andor != "OR" && $andor != "exact" ) {
    $andor = "AND";
}

if ( $action == "results" ) {
    if ( !is_array($mids) || count($mids) == 0 ) {
        $mids = array();
        $mids =& SysModule::getHasSearchModulesList(false);
    }
    if ( $andor != "exact" ) {
        $queries = split(" ", $myts->oopsAddSlashesGPC($query));
    } else {
        $queries = array($myts->oopsAddSlashesGPC($query));
    }
    include_once(SYS_ROOT_PATH."/include/header.php");
    openTable();
    echo "<h3>"._SEARCHRESULTS."</h3>";
    foreach ( $mids as $mid ) {
        $mid     = intval($mid);
        $module  = new SysModule($mid);
        $results = array();
        $results = $module->search($queries, $andor, 5, 0, $uid);
        echo "<h4>".$module->name()."</h4>";
        $count = count($results);
        if ( !is_array($results) || ($count == 0) ) {
            echo _SR_NOMATCH."</p>";
        } else {
            for ( $i = 0; $i < $count; $i++ ) {
                if ( isset($results[$i]['image']) || $results[$i]['image'] != "" ) {
                    echo "<img vspace='2' src='./".SYS_MOD_FOLDER."/".$module->dirname()."/".$results[$i]['image']."' alt='".$module->name()."' />&nbsp;";
                } else {
                    echo "<img vspace='2' src='images/icons/posticon.gif' alt='".$module->name()."' />&nbsp;";
                }
                echo "<b><a href='./".SYS_MOD_FOLDER."/".$module->dirname()."/".$results[$i]['link']."'>".$myts->makeTboxData4Show($results[$i]['title'])."</a></b><br />\n";
                if ($results[$i]['content']) {
                    echo '<small>&nbsp;&nbsp;&nbsp;&nbsp;'.strip_tags($myts->makeTareaData4Show(strip_tags($results[$i]['content']),2,1,1)).'</small><br />';
                }
                echo "<small>&nbsp;&nbsp;&nbsp;&nbsp;";
                $results[$i]['uid'] = intval($results[$i]['uid']);
                if ( !empty($results[$i]['uid']) ) {
                    $uname = SysUser::getUnameFromId($results[$i]['uid']);
                    echo "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$results[$i]['uid']."'>".$uname."</a>\n";
                }
                echo $results[$i]['time'] ? " (". formatTimestamp(intval($results[$i]['time'])).")" : "";
                echo "</small><br />";
            }
            if ( $count == 5 ) {
                echo "
                <br />
                <form action='search.php' method='post' id='showall".$mid."' name='showall".$mid."'>
                <input type='hidden' value='".$myts->makeTboxData4PreviewInForm($query)."' name='query' />
                <input type='hidden' name='mid' value='".$mid."' />
                <input type='hidden' name='uid' value='".$uid."' />
                <input type='hidden' name='action' value='showall' />
                <input type='hidden' name='andor' value='".$andor."' />
                <img src='".SYS_ROOT_URL."/images/pixel.gif' />
                <a href='#"._ALL."' onclick='sysGetElementById(\"showall".$mid."\").submit();'>"._SR_SHOWALLR."</a>
                </form>";
            }
        }
    }
    closeTable();
}

if ( ($action == "search") || ($action == "results") ) {
    if ( $action == "search" ) {
        include_once(SYS_ROOT_PATH."/include/header.php");
    }
    openTable();
    include_once("include/searchform.php");
    $search_form->display();
    closeTable();
}

if ( $action == "showall" ) {
    if ( $andor != "exact" ) {
        $queries = split(" ", $myts->oopsAddSlashesGPC($query));
    } else {
        $queries = array($myts->oopsAddSlashesGPC($query));
    }
    include_once(SYS_ROOT_PATH."/include/header.php");
    $module  = new SysModule($mid);
    $results = array();
    $results = $module->search($queries, $andor, 0, 0, $uid);
    $count   = count($results);
    if ( ($count-$start) > 20 ) {
        $limit = ($start + 20);
    } else {
        $limit = $count;
    }
    openTable();
    echo "<h3>"._SEARCHRESULTS."</h3>".sprintf(_SR_FOUND, $count)."
        <br />".sprintf(_SR_SHOWING, ($start+1), $limit)."<p><h4>".$module->name()."</h4>";
    for ( $i = $start; $i < $limit; $i++) {
        if ( isset($results[$i]['image']) && $results[$i]['image'] != "" ) {
            echo "<img vspace='2' src='./".SYS_MOD_FOLDER."/".$module->dirname()."/".$results[$i]['image']."' alt='".$module->name()."' />&nbsp;";
        } else {
            echo "<img vspace='2' src='images/icons/posticon.gif' alt='".$module->name()."' />&nbsp;";
        }
        echo "<b><a href='./".SYS_MOD_FOLDER."/".$module->dirname()."/".$results[$i]['link']."'>".$myts->makeTboxData4Show($results[$i]['title'])."</a></b><br />\n";
        if ($results[$i]['content']) {
            echo '<small>&nbsp;&nbsp;&nbsp;&nbsp;'.strip_tags($myts->makeTareaData4Show(strip_tags($results[$i]['content']),2,1,1)).'</small><br />';
        }
        echo "<small>&nbsp;&nbsp;&nbsp;&nbsp;";
        $results[$i]['uid'] = intval($results[$i]['uid']);
        if ( !empty($results[$i]['uid']) ) {
            $uname = SysUser::getUnameFromId($results[$i]['uid']);
            echo "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$results[$i]['uid']."'>".$uname."</a>\n";
        }
        echo $results[$i]['time'] ? " (". formatTimestamp(intval($results[$i]['time'])).")" : "";
        echo "</small><br />";
    }
    echo "</p><table><tr>";
    if ( $start > 0 ) {
        $prev = ($start - 20);
        echo "
        <td align='left'>
        <form action='search.php' method='post' id='showprev' name='showprev'>
        <input type='hidden' value='".$myts->makeTboxData4PreviewInForm($query)."' name='query' />
        <input type='hidden' name='mid' value='".$mid."' />
        <input type='hidden' name='uid' value='".$uid."' />
        <input type='hidden' name='action' value='showall' />
        <input type='hidden' name='andor' value='".$andor."' />
        <input type='hidden' name='start' value='".$prev."' />
        <img src='".SYS_ROOT_URL."/images/pixel.gif' />
        <a href='#$prev' onclick='sysGetElementById(\"showprev\").submit();'><<"._PREVIOUS."</a></form></td>\n";
    }
    echo "<td>&nbsp;</td>";
    if ( ($count-$start) > 20 ) {
        $next = ($start + 20);
        echo "
        <td align='right'><form action='search.php' method='post' id='shownext' name='shownext'>
        <input type='hidden' value='".$myts->makeTboxData4PreviewInForm($query)."' name='query' />
        <input type='hidden' name='mid' value='".$mid."' />
        <input type='hidden' name='uid' value='".$uid."' />
        <input type='hidden' name='action' value='showall' />
        <input type='hidden' name='andor' value='".$andor."' />
        <input type='hidden' name='start' value='".$next."' />
        <img src='".SYS_ROOT_URL."/images/pixel.gif' />
        <a href='#$next' onclick='sysGetElementById(\"shownext\").submit();'>"._NEXT.">></a></form></td>\n";
    }
    echo "</tr></table><p>";
    include_once("include/searchform.php");
    $search_form->display();
    echo "</p>";
    closeTable();
}
include_once(SYS_ROOT_PATH."/include/footer.php");
?>
